/* Generated by re2c 1.1.1 */
#line 1 "Zend/zend_language_scanner.l"
/*
   +----------------------------------------------------------------------+
   | Zend Engine                                                          |
   +----------------------------------------------------------------------+
   | Copyright (c) Zend Technologies Ltd. (http://www.zend.com)           |
   +----------------------------------------------------------------------+
   | This source file is subject to version 2.00 of the Zend license,     |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.zend.com/license/2_00.txt.                                |
   | If you did not receive a copy of the Zend license and are unable to  |
   | obtain it through the world-wide-web, please send a note to          |
   | license@zend.com so we can mail you a copy immediately.              |
   +----------------------------------------------------------------------+
   | Authors: Marcus Boerger <helly@php.net>                              |
   |          Nuno Lopes <nlopess@php.net>                                |
   |          Scott MacVicar <scottmac@php.net>                           |
   | Flex version authors:                                                |
   |          Andi Gutmans <andi@php.net>                                 |
   |          Zeev Suraski <zeev@php.net>                                 |
   +----------------------------------------------------------------------+
*/

#if 0
# define YYDEBUG(s, c) printf("state: %d char: %c\n", s, c)
#else
# define YYDEBUG(s, c)
#endif

#include "zend_language_scanner_defs.h"

#include <errno.h>
#include "zend.h"
#ifdef ZEND_WIN32
# include <Winuser.h>
#endif
#include "zend_alloc.h"
#include <zend_language_parser.h>
#include "zend_compile.h"
#include "zend_language_scanner.h"
#include "zend_highlight.h"
#include "zend_constants.h"
#include "zend_variables.h"
#include "zend_operators.h"
#include "zend_API.h"
#include "zend_strtod.h"
#include "zend_exceptions.h"
#include "zend_virtual_cwd.h"

#define YYCTYPE   unsigned char
#define YYFILL(n) { if ((YYCURSOR + n) >= (YYLIMIT + ZEND_MMAP_AHEAD)) { return 0; } }
#define YYCURSOR  SCNG(yy_cursor)
#define YYLIMIT   SCNG(yy_limit)
#define YYMARKER  SCNG(yy_marker)

#define YYGETCONDITION()  SCNG(yy_state)
#define YYSETCONDITION(s) SCNG(yy_state) = s

#define STATE(name)  yyc##name

/* emulate flex constructs */
#define BEGIN(state) YYSETCONDITION(STATE(state))
#define YYSTATE      YYGETCONDITION()
#define yytext       ((char*)SCNG(yy_text))
#define yyleng       SCNG(yy_leng)
#define yyless(x)    do { YYCURSOR = (unsigned char*)yytext + x; \
                          yyleng   = (unsigned int)x; } while(0)
#define yymore()     goto yymore_restart

/* perform sanity check. If this message is triggered you should
   increase the ZEND_MMAP_AHEAD value in the zend_streams.h file */
#define YYMAXFILL 16

#if ZEND_MMAP_AHEAD < YYMAXFILL
# error ZEND_MMAP_AHEAD should be greater than or equal to YYMAXFILL
#endif

#include <stdarg.h>

#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif

/* Globals Macros */
#define SCNG	LANG_SCNG
#ifdef ZTS
ZEND_API ts_rsrc_id language_scanner_globals_id;
ZEND_API size_t language_scanner_globals_offset;
#else
ZEND_API zend_php_scanner_globals language_scanner_globals;
#endif

#define HANDLE_NEWLINES(s, l)													\
do {																			\
	char *p = (s), *boundary = p+(l);											\
																				\
	while (p<boundary) {														\
		if (*p == '\n' || (*p == '\r' && (*(p+1) != '\n'))) {					\
			CG(zend_lineno)++;													\
		}																		\
		p++;																	\
	}																			\
} while (0)

#define HANDLE_NEWLINE(c) \
{ \
	if (c == '\n' || c == '\r') { \
		CG(zend_lineno)++; \
	} \
}

/* To save initial string length after scanning to first variable */
#define SET_DOUBLE_QUOTES_SCANNED_LENGTH(len) SCNG(scanned_string_len) = (len)
#define GET_DOUBLE_QUOTES_SCANNED_LENGTH()    SCNG(scanned_string_len)

#define IS_LABEL_START(c) (((c) >= 'a' && (c) <= 'z') || ((c) >= 'A' && (c) <= 'Z') || (c) == '_' || (c) >= 0x80)
#define IS_LABEL_SUCCESSOR(c) (((c) >= 'a' && (c) <= 'z') || ((c) >= 'A' && (c) <= 'Z') || ((c) >= '0' && (c) <= '9') || (c) == '_' || (c) >= 0x80)

#define ZEND_IS_OCT(c)  ((c)>='0' && (c)<='7')
#define ZEND_IS_HEX(c)  (((c)>='0' && (c)<='9') || ((c)>='a' && (c)<='f') || ((c)>='A' && (c)<='F'))


static void strip_underscores(char *str, size_t *len)
{
	char *src = str, *dest = str;
	while (*src != '\0') {
		if (*src != '_') {
			*dest = *src;
			dest++;
		} else {
			--(*len);
		}
		src++;
	}
	*dest = '\0';
}

static size_t encoding_filter_script_to_internal(unsigned char **to, size_t *to_length, const unsigned char *from, size_t from_length)
{
	const zend_encoding *internal_encoding = zend_multibyte_get_internal_encoding();
	ZEND_ASSERT(internal_encoding);
	return zend_multibyte_encoding_converter(to, to_length, from, from_length, internal_encoding, LANG_SCNG(script_encoding));
}

static size_t encoding_filter_script_to_intermediate(unsigned char **to, size_t *to_length, const unsigned char *from, size_t from_length)
{
	return zend_multibyte_encoding_converter(to, to_length, from, from_length, zend_multibyte_encoding_utf8, LANG_SCNG(script_encoding));
}

static size_t encoding_filter_intermediate_to_script(unsigned char **to, size_t *to_length, const unsigned char *from, size_t from_length)
{
	return zend_multibyte_encoding_converter(to, to_length, from, from_length,
LANG_SCNG(script_encoding), zend_multibyte_encoding_utf8);
}

static size_t encoding_filter_intermediate_to_internal(unsigned char **to, size_t *to_length, const unsigned char *from, size_t from_length)
{
	const zend_encoding *internal_encoding = zend_multibyte_get_internal_encoding();
	ZEND_ASSERT(internal_encoding);
	return zend_multibyte_encoding_converter(to, to_length, from, from_length,
internal_encoding, zend_multibyte_encoding_utf8);
}


static void _yy_push_state(int new_state)
{
	zend_stack_push(&SCNG(state_stack), (void *) &YYGETCONDITION());
	YYSETCONDITION(new_state);
}

#define yy_push_state(state_and_tsrm) _yy_push_state(yyc##state_and_tsrm)

static void yy_pop_state(void)
{
	int *stack_state = zend_stack_top(&SCNG(state_stack));
	YYSETCONDITION(*stack_state);
	zend_stack_del_top(&SCNG(state_stack));
}

static void yy_scan_buffer(char *str, size_t len)
{
	YYCURSOR       = (YYCTYPE*)str;
	YYLIMIT        = YYCURSOR + len;
	if (!SCNG(yy_start)) {
		SCNG(yy_start) = YYCURSOR;
	}
}

void startup_scanner(void)
{
	CG(parse_error) = 0;
	CG(doc_comment) = NULL;
	CG(extra_fn_flags) = 0;
	zend_stack_init(&SCNG(state_stack), sizeof(int));
	zend_stack_init(&SCNG(nest_location_stack), sizeof(zend_nest_location));
	zend_ptr_stack_init(&SCNG(heredoc_label_stack));
	SCNG(heredoc_scan_ahead) = 0;
}

static void heredoc_label_dtor(zend_heredoc_label *heredoc_label) {
    efree(heredoc_label->label);
}

void shutdown_scanner(void)
{
	CG(parse_error) = 0;
	RESET_DOC_COMMENT();
	zend_stack_destroy(&SCNG(state_stack));
	zend_stack_destroy(&SCNG(nest_location_stack));
	zend_ptr_stack_clean(&SCNG(heredoc_label_stack), (void (*)(void *)) &heredoc_label_dtor, 1);
	zend_ptr_stack_destroy(&SCNG(heredoc_label_stack));
	SCNG(heredoc_scan_ahead) = 0;
	SCNG(on_event) = NULL;
}

ZEND_API void zend_save_lexical_state(zend_lex_state *lex_state)
{
	lex_state->yy_leng   = SCNG(yy_leng);
	lex_state->yy_start  = SCNG(yy_start);
	lex_state->yy_text   = SCNG(yy_text);
	lex_state->yy_cursor = SCNG(yy_cursor);
	lex_state->yy_marker = SCNG(yy_marker);
	lex_state->yy_limit  = SCNG(yy_limit);

	lex_state->state_stack = SCNG(state_stack);
	zend_stack_init(&SCNG(state_stack), sizeof(int));

	lex_state->nest_location_stack = SCNG(nest_location_stack);
	zend_stack_init(&SCNG(nest_location_stack), sizeof(zend_nest_location));

	lex_state->heredoc_label_stack = SCNG(heredoc_label_stack);
	zend_ptr_stack_init(&SCNG(heredoc_label_stack));

	lex_state->in = SCNG(yy_in);
	lex_state->yy_state = YYSTATE;
	lex_state->filename = CG(compiled_filename);
	lex_state->lineno = CG(zend_lineno);
	CG(compiled_filename) = NULL;

	lex_state->script_org = SCNG(script_org);
	lex_state->script_org_size = SCNG(script_org_size);
	lex_state->script_filtered = SCNG(script_filtered);
	lex_state->script_filtered_size = SCNG(script_filtered_size);
	lex_state->input_filter = SCNG(input_filter);
	lex_state->output_filter = SCNG(output_filter);
	lex_state->script_encoding = SCNG(script_encoding);

	lex_state->on_event = SCNG(on_event);
	lex_state->on_event_context = SCNG(on_event_context);

	lex_state->ast = CG(ast);
	lex_state->ast_arena = CG(ast_arena);
}

ZEND_API void zend_restore_lexical_state(zend_lex_state *lex_state)
{
	SCNG(yy_leng)   = lex_state->yy_leng;
	SCNG(yy_start)  = lex_state->yy_start;
	SCNG(yy_text)   = lex_state->yy_text;
	SCNG(yy_cursor) = lex_state->yy_cursor;
	SCNG(yy_marker) = lex_state->yy_marker;
	SCNG(yy_limit)  = lex_state->yy_limit;

	zend_stack_destroy(&SCNG(state_stack));
	SCNG(state_stack) = lex_state->state_stack;

	zend_stack_destroy(&SCNG(nest_location_stack));
	SCNG(nest_location_stack) = lex_state->nest_location_stack;

	zend_ptr_stack_clean(&SCNG(heredoc_label_stack), (void (*)(void *)) &heredoc_label_dtor, 1);
	zend_ptr_stack_destroy(&SCNG(heredoc_label_stack));
	SCNG(heredoc_label_stack) = lex_state->heredoc_label_stack;

	SCNG(yy_in) = lex_state->in;
	YYSETCONDITION(lex_state->yy_state);
	CG(zend_lineno) = lex_state->lineno;
	zend_restore_compiled_filename(lex_state->filename);

	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
	SCNG(script_org) = lex_state->script_org;
	SCNG(script_org_size) = lex_state->script_org_size;
	SCNG(script_filtered) = lex_state->script_filtered;
	SCNG(script_filtered_size) = lex_state->script_filtered_size;
	SCNG(input_filter) = lex_state->input_filter;
	SCNG(output_filter) = lex_state->output_filter;
	SCNG(script_encoding) = lex_state->script_encoding;

	SCNG(on_event) = lex_state->on_event;
	SCNG(on_event_context) = lex_state->on_event_context;

	CG(ast) = lex_state->ast;
	CG(ast_arena) = lex_state->ast_arena;

	RESET_DOC_COMMENT();
}

ZEND_API zend_result zend_lex_tstring(zval *zv, unsigned char *ident)
{
	unsigned char *end = ident;
	while ((*end >= 'a' && *end <= 'z') || (*end >= 'A' && *end <= 'Z') || *end == '_') {
		end++;
	}

	size_t length = end - ident;
	if (length == 0) {
		ZEND_ASSERT(ident[0] == '<' && ident[1] == '?' && ident[2] == '=');
		zend_throw_exception(zend_ce_parse_error, "Cannot use \"<?=\" as an identifier", 0);
		return FAILURE;
	}

	if (SCNG(on_event)) {
		SCNG(on_event)(ON_FEEDBACK, T_STRING, 0, (char *) ident, length, SCNG(on_event_context));
	}

	ZVAL_STRINGL(zv, (char *) ident, length);
	return SUCCESS;
}

#define BOM_UTF32_BE	"\x00\x00\xfe\xff"
#define	BOM_UTF32_LE	"\xff\xfe\x00\x00"
#define	BOM_UTF16_BE	"\xfe\xff"
#define	BOM_UTF16_LE	"\xff\xfe"
#define	BOM_UTF8		"\xef\xbb\xbf"

static const zend_encoding *zend_multibyte_detect_utf_encoding(const unsigned char *script, size_t script_size)
{
	const unsigned char *p;
	int wchar_size = 2;
	int le = 0;

	/* utf-16 or utf-32? */
	p = script;
	assert(p >= script);
	while ((size_t)(p-script) < script_size) {
		p = memchr(p, 0, script_size-(p-script)-2);
		if (!p) {
			break;
		}
		if (*(p+1) == '\0' && *(p+2) == '\0') {
			wchar_size = 4;
			break;
		}

		/* searching for UTF-32 specific byte orders, so this will do */
		p += 4;
	}

	/* BE or LE? */
	p = script;
	assert(p >= script);
	while ((size_t)(p-script) < script_size) {
		if (*p == '\0' && *(p+wchar_size-1) != '\0') {
			/* BE */
			le = 0;
			break;
		} else if (*p != '\0' && *(p+wchar_size-1) == '\0') {
			/* LE* */
			le = 1;
			break;
		}
		p += wchar_size;
	}

	if (wchar_size == 2) {
		return le ? zend_multibyte_encoding_utf16le : zend_multibyte_encoding_utf16be;
	} else {
		return le ? zend_multibyte_encoding_utf32le : zend_multibyte_encoding_utf32be;
	}

	return NULL;
}

static const zend_encoding* zend_multibyte_detect_unicode(void)
{
	const zend_encoding *script_encoding = NULL;
	int bom_size;
	unsigned char *pos1, *pos2;

	if (LANG_SCNG(script_org_size) < sizeof(BOM_UTF32_LE)-1) {
		return NULL;
	}

	/* check out BOM */
	if (!memcmp(LANG_SCNG(script_org), BOM_UTF32_BE, sizeof(BOM_UTF32_BE)-1)) {
		script_encoding = zend_multibyte_encoding_utf32be;
		bom_size = sizeof(BOM_UTF32_BE)-1;
	} else if (!memcmp(LANG_SCNG(script_org), BOM_UTF32_LE, sizeof(BOM_UTF32_LE)-1)) {
		script_encoding = zend_multibyte_encoding_utf32le;
		bom_size = sizeof(BOM_UTF32_LE)-1;
	} else if (!memcmp(LANG_SCNG(script_org), BOM_UTF16_BE, sizeof(BOM_UTF16_BE)-1)) {
		script_encoding = zend_multibyte_encoding_utf16be;
		bom_size = sizeof(BOM_UTF16_BE)-1;
	} else if (!memcmp(LANG_SCNG(script_org), BOM_UTF16_LE, sizeof(BOM_UTF16_LE)-1)) {
		script_encoding = zend_multibyte_encoding_utf16le;
		bom_size = sizeof(BOM_UTF16_LE)-1;
	} else if (!memcmp(LANG_SCNG(script_org), BOM_UTF8, sizeof(BOM_UTF8)-1)) {
		script_encoding = zend_multibyte_encoding_utf8;
		bom_size = sizeof(BOM_UTF8)-1;
	}

	if (script_encoding) {
		/* remove BOM */
		LANG_SCNG(script_org) += bom_size;
		LANG_SCNG(script_org_size) -= bom_size;

		return script_encoding;
	}

	/* script contains NULL bytes -> auto-detection */
	if ((pos1 = memchr(LANG_SCNG(script_org), 0, LANG_SCNG(script_org_size)))) {
		/* check if the NULL byte is after the __HALT_COMPILER(); */
		pos2 = LANG_SCNG(script_org);

		while ((size_t)(pos1 - pos2) >= sizeof("__HALT_COMPILER();")-1) {
			pos2 = memchr(pos2, '_', pos1 - pos2);
			if (!pos2) break;
			pos2++;
			if (strncasecmp((char*)pos2, "_HALT_COMPILER", sizeof("_HALT_COMPILER")-1) == 0) {
				pos2 += sizeof("_HALT_COMPILER")-1;
				while (*pos2 == ' '  ||
					   *pos2 == '\t' ||
					   *pos2 == '\r' ||
					   *pos2 == '\n') {
					pos2++;
				}
				if (*pos2 == '(') {
					pos2++;
					while (*pos2 == ' '  ||
						   *pos2 == '\t' ||
						   *pos2 == '\r' ||
						   *pos2 == '\n') {
						pos2++;
					}
					if (*pos2 == ')') {
						pos2++;
						while (*pos2 == ' '  ||
							   *pos2 == '\t' ||
							   *pos2 == '\r' ||
							   *pos2 == '\n') {
							pos2++;
						}
						if (*pos2 == ';') {
							return NULL;
						}
					}
				}
			}
		}
		/* make best effort if BOM is missing */
		return zend_multibyte_detect_utf_encoding(LANG_SCNG(script_org), LANG_SCNG(script_org_size));
	}

	return NULL;
}

static const zend_encoding* zend_multibyte_find_script_encoding(void)
{
	const zend_encoding *script_encoding;

	if (CG(detect_unicode)) {
		/* check out bom(byte order mark) and see if containing wchars */
		script_encoding = zend_multibyte_detect_unicode();
		if (script_encoding != NULL) {
			/* bom or wchar detection is prior to 'script_encoding' option */
			return script_encoding;
		}
	}

	/* if no script_encoding specified, just leave alone */
	if (!CG(script_encoding_list) || !CG(script_encoding_list_size)) {
		return NULL;
	}

	/* if multiple encodings specified, detect automagically */
	if (CG(script_encoding_list_size) > 1) {
		return zend_multibyte_encoding_detector(LANG_SCNG(script_org), LANG_SCNG(script_org_size), CG(script_encoding_list), CG(script_encoding_list_size));
	}

	return CG(script_encoding_list)[0];
}

ZEND_API zend_result zend_multibyte_set_filter(const zend_encoding *onetime_encoding)
{
	const zend_encoding *internal_encoding = zend_multibyte_get_internal_encoding();
	const zend_encoding *script_encoding = onetime_encoding ? onetime_encoding: zend_multibyte_find_script_encoding();

	if (!script_encoding) {
		return FAILURE;
	}

	/* judge input/output filter */
	LANG_SCNG(script_encoding) = script_encoding;
	LANG_SCNG(input_filter) = NULL;
	LANG_SCNG(output_filter) = NULL;

	if (!internal_encoding || LANG_SCNG(script_encoding) == internal_encoding) {
		if (!zend_multibyte_check_lexer_compatibility(LANG_SCNG(script_encoding))) {
			/* and if not, work around w/ script_encoding -> utf-8 -> script_encoding conversion */
			LANG_SCNG(input_filter) = encoding_filter_script_to_intermediate;
			LANG_SCNG(output_filter) = encoding_filter_intermediate_to_script;
		} else {
			LANG_SCNG(input_filter) = NULL;
			LANG_SCNG(output_filter) = NULL;
		}
		return SUCCESS;
	}

	if (zend_multibyte_check_lexer_compatibility(internal_encoding)) {
		LANG_SCNG(input_filter) = encoding_filter_script_to_internal;
		LANG_SCNG(output_filter) = NULL;
	} else if (zend_multibyte_check_lexer_compatibility(LANG_SCNG(script_encoding))) {
		LANG_SCNG(input_filter) = NULL;
		LANG_SCNG(output_filter) = encoding_filter_script_to_internal;
	} else {
		/* both script and internal encodings are incompatible w/ flex */
		LANG_SCNG(input_filter) = encoding_filter_script_to_intermediate;
		LANG_SCNG(output_filter) = encoding_filter_intermediate_to_internal;
	}

	return SUCCESS;
}

ZEND_API zend_result open_file_for_scanning(zend_file_handle *file_handle)
{
	char *buf;
	size_t size;
	zend_string *compiled_filename;

	if (zend_stream_fixup(file_handle, &buf, &size) == FAILURE) {
		/* Still add it to open_files to make destroy_file_handle work */
		zend_llist_add_element(&CG(open_files), file_handle);
		file_handle->in_list = 1;
		return FAILURE;
	}

	ZEND_ASSERT(!EG(exception) && "stream_fixup() should have failed");
	zend_llist_add_element(&CG(open_files), file_handle);
	file_handle->in_list = 1;

	/* Reset the scanner for scanning the new file */
	SCNG(yy_in) = file_handle;
	SCNG(yy_start) = NULL;

	if (size != (size_t)-1) {
		if (CG(multibyte)) {
			SCNG(script_org) = (unsigned char*)buf;
			SCNG(script_org_size) = size;
			SCNG(script_filtered) = NULL;

			zend_multibyte_set_filter(NULL);

			if (SCNG(input_filter)) {
				if ((size_t)-1 == SCNG(input_filter)(&SCNG(script_filtered), &SCNG(script_filtered_size), SCNG(script_org), SCNG(script_org_size))) {
					zend_error_noreturn(E_COMPILE_ERROR, "Could not convert the script from the detected "
							"encoding \"%s\" to a compatible encoding", zend_multibyte_get_encoding_name(LANG_SCNG(script_encoding)));
				}
				buf = (char*)SCNG(script_filtered);
				size = SCNG(script_filtered_size);
			}
		}
		SCNG(yy_start) = (unsigned char *)buf;
		yy_scan_buffer(buf, size);
	} else {
		zend_error_noreturn(E_COMPILE_ERROR, "zend_stream_mmap() failed");
	}

	if (CG(skip_shebang)) {
		BEGIN(SHEBANG);
	} else {
		BEGIN(INITIAL);
	}

	if (file_handle->opened_path) {
		compiled_filename = zend_string_copy(file_handle->opened_path);
	} else {
		compiled_filename = zend_string_copy(file_handle->filename);
	}

	zend_set_compiled_filename(compiled_filename);
	zend_string_release_ex(compiled_filename, 0);

	RESET_DOC_COMMENT();
	CG(zend_lineno) = 1;
	CG(increment_lineno) = 0;
	return SUCCESS;
}

static zend_op_array *zend_compile(int type)
{
	zend_op_array *op_array = NULL;
	bool original_in_compilation = CG(in_compilation);

	CG(in_compilation) = 1;
	CG(ast) = NULL;
	CG(ast_arena) = zend_arena_create(1024 * 32);

	if (!zendparse()) {
		int last_lineno = CG(zend_lineno);
		zend_file_context original_file_context;
		zend_oparray_context original_oparray_context;
		zend_op_array *original_active_op_array = CG(active_op_array);

		op_array = emalloc(sizeof(zend_op_array));
		init_op_array(op_array, type, INITIAL_OP_ARRAY_SIZE);
		CG(active_op_array) = op_array;

		/* Use heap to not waste arena memory */
		op_array->fn_flags |= ZEND_ACC_HEAP_RT_CACHE;

		if (zend_ast_process) {
			zend_ast_process(CG(ast));
		}

		zend_file_context_begin(&original_file_context);
		zend_oparray_context_begin(&original_oparray_context);
		zend_compile_top_stmt(CG(ast));
		CG(zend_lineno) = last_lineno;
		zend_emit_final_return(type == ZEND_USER_FUNCTION);
		op_array->line_start = 1;
		op_array->line_end = last_lineno;
		zend_init_static_variables_map_ptr(op_array);
		pass_two(op_array);
		zend_oparray_context_end(&original_oparray_context);
		zend_file_context_end(&original_file_context);

		CG(active_op_array) = original_active_op_array;
	}

	zend_ast_destroy(CG(ast));
	zend_arena_destroy(CG(ast_arena));

	CG(in_compilation) = original_in_compilation;

	return op_array;
}

ZEND_API zend_op_array *compile_file(zend_file_handle *file_handle, int type)
{
	zend_lex_state original_lex_state;
	zend_op_array *op_array = NULL;
	zend_save_lexical_state(&original_lex_state);

	if (open_file_for_scanning(file_handle)==FAILURE) {
		if (!EG(exception)) {
			if (type==ZEND_REQUIRE) {
				zend_message_dispatcher(ZMSG_FAILED_REQUIRE_FOPEN, ZSTR_VAL(file_handle->filename));
			} else {
				zend_message_dispatcher(ZMSG_FAILED_INCLUDE_FOPEN, ZSTR_VAL(file_handle->filename));
			}
		}
	} else {
		op_array = zend_compile(ZEND_USER_FUNCTION);
	}

	zend_restore_lexical_state(&original_lex_state);
	return op_array;
}

ZEND_API zend_ast *zend_compile_string_to_ast(
		zend_string *code, zend_arena **ast_arena, zend_string *filename) {
	zval code_zv;
	bool original_in_compilation;
	zend_lex_state original_lex_state;
	zend_ast *ast;

	ZVAL_STR_COPY(&code_zv, code);

	original_in_compilation = CG(in_compilation);
	CG(in_compilation) = 1;

	zend_save_lexical_state(&original_lex_state);
	zend_prepare_string_for_scanning(&code_zv, filename);
	CG(ast) = NULL;
	CG(ast_arena) = zend_arena_create(1024 * 32);
	LANG_SCNG(yy_state) = yycINITIAL;

	if (zendparse() != 0) {
		zend_ast_destroy(CG(ast));
		zend_arena_destroy(CG(ast_arena));
		CG(ast) = NULL;
	}

	/* restore_lexical_state changes CG(ast) and CG(ast_arena) */
	ast = CG(ast);
	*ast_arena = CG(ast_arena);

	zend_restore_lexical_state(&original_lex_state);
	CG(in_compilation) = original_in_compilation;

	zval_ptr_dtor_str(&code_zv);

	return ast;
}

zend_op_array *compile_filename(int type, zend_string *filename)
{
	zend_file_handle file_handle;
	zend_op_array *retval;
	zend_string *opened_path = NULL;

	zend_stream_init_filename_ex(&file_handle, filename);

	retval = zend_compile_file(&file_handle, type);
	if (retval && file_handle.handle.stream.handle) {
		if (!file_handle.opened_path) {
			file_handle.opened_path = opened_path = zend_string_copy(filename);
		}

		zend_hash_add_empty_element(&EG(included_files), file_handle.opened_path);

		if (opened_path) {
			zend_string_release_ex(opened_path, 0);
		}
	}
	zend_destroy_file_handle(&file_handle);

	return retval;
}

ZEND_API void zend_prepare_string_for_scanning(zval *str, zend_string *filename)
{
	char *buf;
	size_t size, old_len;

	/* enforce ZEND_MMAP_AHEAD trailing NULLs for flex... */
	old_len = Z_STRLEN_P(str);
	Z_STR_P(str) = zend_string_extend(Z_STR_P(str), old_len + ZEND_MMAP_AHEAD, 0);
	Z_TYPE_INFO_P(str) = IS_STRING_EX;
	memset(Z_STRVAL_P(str) + old_len, 0, ZEND_MMAP_AHEAD + 1);

	SCNG(yy_in) = NULL;
	SCNG(yy_start) = NULL;

	buf = Z_STRVAL_P(str);
	size = old_len;

	if (CG(multibyte)) {
		SCNG(script_org) = (unsigned char*)buf;
		SCNG(script_org_size) = size;
		SCNG(script_filtered) = NULL;

		zend_multibyte_set_filter(zend_multibyte_get_internal_encoding());

		if (SCNG(input_filter)) {
			if ((size_t)-1 == SCNG(input_filter)(&SCNG(script_filtered), &SCNG(script_filtered_size), SCNG(script_org), SCNG(script_org_size))) {
				zend_error_noreturn(E_COMPILE_ERROR, "Could not convert the script from the detected "
						"encoding \"%s\" to a compatible encoding", zend_multibyte_get_encoding_name(LANG_SCNG(script_encoding)));
			}
			buf = (char*)SCNG(script_filtered);
			size = SCNG(script_filtered_size);
		}
	}

	yy_scan_buffer(buf, size);
	zend_set_compiled_filename(filename);
	CG(zend_lineno) = 1;
	CG(increment_lineno) = 0;
	RESET_DOC_COMMENT();
}


ZEND_API size_t zend_get_scanned_file_offset(void)
{
	size_t offset = SCNG(yy_cursor) - SCNG(yy_start);
	if (SCNG(input_filter)) {
		size_t original_offset = offset, length = 0;
		do {
			unsigned char *p = NULL;
			if ((size_t)-1 == SCNG(input_filter)(&p, &length, SCNG(script_org), offset)) {
				return (size_t)-1;
			}
			efree(p);
			if (length > original_offset) {
				offset--;
			} else if (length < original_offset) {
				offset++;
			}
		} while (original_offset != length);
	}
	return offset;
}

zend_op_array *compile_string(zend_string *source_string, const char *filename)
{
	zend_lex_state original_lex_state;
	zend_op_array *op_array = NULL;
	zval tmp;
	zend_string *filename_str;

	if (ZSTR_LEN(source_string) == 0) {
		return NULL;
	}

	ZVAL_STR_COPY(&tmp, source_string);

	zend_save_lexical_state(&original_lex_state);
	filename_str = zend_string_init(filename, strlen(filename), 0);
	zend_prepare_string_for_scanning(&tmp, filename_str);
	zend_string_release(filename_str);
	BEGIN(ST_IN_SCRIPTING);
	op_array = zend_compile(ZEND_EVAL_CODE);

	zend_restore_lexical_state(&original_lex_state);
	zval_ptr_dtor(&tmp);

	return op_array;
}


zend_result highlight_file(const char *filename, zend_syntax_highlighter_ini *syntax_highlighter_ini)
{
	zend_lex_state original_lex_state;
	zend_file_handle file_handle;

	zend_stream_init_filename(&file_handle, filename);
	zend_save_lexical_state(&original_lex_state);
	if (open_file_for_scanning(&file_handle)==FAILURE) {
		zend_message_dispatcher(ZMSG_FAILED_HIGHLIGHT_FOPEN, filename);
		zend_destroy_file_handle(&file_handle);
		zend_restore_lexical_state(&original_lex_state);
		return FAILURE;
	}
	zend_highlight(syntax_highlighter_ini);
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
	zend_destroy_file_handle(&file_handle);
	zend_restore_lexical_state(&original_lex_state);
	return SUCCESS;
}

void highlight_string(zend_string *str, zend_syntax_highlighter_ini *syntax_highlighter_ini, const char *filename)
{
	zend_lex_state original_lex_state;
	zval str_zv;
	zend_string *filename_str = zend_string_init(filename, strlen(filename), 0);
	ZVAL_STR_COPY(&str_zv, str);
	zend_save_lexical_state(&original_lex_state);
	zend_prepare_string_for_scanning(&str_zv, filename_str);
	zend_string_release(filename_str);
	BEGIN(INITIAL);
	zend_highlight(syntax_highlighter_ini);
	if (SCNG(script_filtered)) {
		efree(SCNG(script_filtered));
		SCNG(script_filtered) = NULL;
	}
	zend_restore_lexical_state(&original_lex_state);
	zval_ptr_dtor(&str_zv);
}

ZEND_API void zend_multibyte_yyinput_again(zend_encoding_filter old_input_filter, const zend_encoding *old_encoding)
{
	size_t length;
	unsigned char *new_yy_start;

	/* convert and set */
	if (!SCNG(input_filter)) {
		if (SCNG(script_filtered)) {
			efree(SCNG(script_filtered));
			SCNG(script_filtered) = NULL;
		}
		SCNG(script_filtered_size) = 0;
		length = SCNG(script_org_size);
		new_yy_start = SCNG(script_org);
	} else {
		if ((size_t)-1 == SCNG(input_filter)(&new_yy_start, &length, SCNG(script_org), SCNG(script_org_size))) {
			zend_error_noreturn(E_COMPILE_ERROR, "Could not convert the script from the detected "
					"encoding \"%s\" to a compatible encoding", zend_multibyte_get_encoding_name(LANG_SCNG(script_encoding)));
		}
		if (SCNG(script_filtered)) {
			efree(SCNG(script_filtered));
		}
		SCNG(script_filtered) = new_yy_start;
		SCNG(script_filtered_size) = length;
	}

	SCNG(yy_cursor) = new_yy_start + (SCNG(yy_cursor) - SCNG(yy_start));
	SCNG(yy_marker) = new_yy_start + (SCNG(yy_marker) - SCNG(yy_start));
	SCNG(yy_text) = new_yy_start + (SCNG(yy_text) - SCNG(yy_start));
	SCNG(yy_limit) = new_yy_start + length;

	SCNG(yy_start) = new_yy_start;
}


// TODO: avoid reallocation ???
# define zend_copy_value(zendlval, yytext, yyleng) \
	if (SCNG(output_filter)) { \
		size_t sz = 0; \
		char *s = NULL; \
		SCNG(output_filter)((unsigned char **)&s, &sz, (unsigned char *)yytext, (size_t)yyleng); \
		ZVAL_STRINGL(zendlval, s, sz); \
		efree(s); \
	} else if (yyleng == 1) { \
		ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR((zend_uchar)*(yytext))); \
	} else { \
		ZVAL_STRINGL(zendlval, yytext, yyleng); \
	}

static zend_result zend_scan_escape_string(zval *zendlval, char *str, int len, char quote_type)
{
	char *s, *t;
	char *end;

	if (len <= 1) {
		if (len < 1) {
			ZVAL_EMPTY_STRING(zendlval);
		} else {
			zend_uchar c = (zend_uchar)*str;
			if (c == '\n' || c == '\r') {
				CG(zend_lineno)++;
			}
			ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR(c));
		}
		goto skip_escape_conversion;
	}

	ZVAL_STRINGL(zendlval, str, len);

	/* convert escape sequences */
	s = Z_STRVAL_P(zendlval);
	end = s+Z_STRLEN_P(zendlval);
	while (1) {
		if (UNEXPECTED(*s=='\\')) {
			break;
		}
		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
		if (s == end) {
			goto skip_escape_conversion;
		}
	}

	t = s;
	while (s<end) {
		if (*s=='\\') {
			s++;
			if (s >= end) {
				*t++ = '\\';
				break;
			}

			switch(*s) {
				case 'n':
					*t++ = '\n';
					break;
				case 'r':
					*t++ = '\r';
					break;
				case 't':
					*t++ = '\t';
					break;
				case 'f':
					*t++ = '\f';
					break;
				case 'v':
					*t++ = '\v';
					break;
				case 'e':
#ifdef ZEND_WIN32
					*t++ = VK_ESCAPE;
#else
					*t++ = '\e';
#endif
					break;
				case '"':
				case '`':
					if (*s != quote_type) {
						*t++ = '\\';
						*t++ = *s;
						break;
					}
					ZEND_FALLTHROUGH;
				case '\\':
				case '$':
					*t++ = *s;
					break;
				case 'x':
				case 'X':
					if (ZEND_IS_HEX(*(s+1))) {
						char hex_buf[3] = { 0, 0, 0 };

						hex_buf[0] = *(++s);
						if (ZEND_IS_HEX(*(s+1))) {
							hex_buf[1] = *(++s);
						}
						*t++ = (char) ZEND_STRTOL(hex_buf, NULL, 16);
					} else {
						*t++ = '\\';
						*t++ = *s;
					}
					break;
				/* UTF-8 codepoint escape, format: /\\u\{\x+\}/ */
				case 'u':
					{
						/* cache where we started so we can parse after validating */
						char *start = s + 1;
						size_t len = 0;
						bool valid = 1;
						unsigned long codepoint;

						if (*start != '{') {
							/* we silently let this pass to avoid breaking code
							 * with JSON in string literals (e.g. "\"\u202e\""
							 */
							*t++ = '\\';
							*t++ = 'u';
							break;
						} else {
							/* on the other hand, invalid \u{blah} errors */
							s++;
							len++;
							s++;
							while (*s != '}') {
								if (!ZEND_IS_HEX(*s)) {
									valid = 0;
									break;
								} else {
									len++;
								}
								s++;
							}
							if (*s == '}') {
								valid = 1;
								len++;
							}
						}

						/* \u{} is invalid */
						if (len <= 2) {
							valid = 0;
						}

						if (!valid) {
							zend_throw_exception(zend_ce_parse_error,
								"Invalid UTF-8 codepoint escape sequence", 0);
							zval_ptr_dtor(zendlval);
							ZVAL_UNDEF(zendlval);
							return FAILURE;
						}

						errno = 0;
						codepoint = strtoul(start + 1, NULL, 16);

						/* per RFC 3629, UTF-8 can only represent 21 bits */
						if (codepoint > 0x10FFFF || errno) {
							zend_throw_exception(zend_ce_parse_error,
								"Invalid UTF-8 codepoint escape sequence: Codepoint too large", 0);
							zval_ptr_dtor(zendlval);
							ZVAL_UNDEF(zendlval);
							return FAILURE;
						}

						/* based on https://en.wikipedia.org/wiki/UTF-8#Sample_code */
						if (codepoint < 0x80) {
							*t++ = codepoint;
						} else if (codepoint <= 0x7FF) {
							*t++ = (codepoint >> 6) + 0xC0;
							*t++ = (codepoint & 0x3F) + 0x80;
						} else if (codepoint <= 0xFFFF) {
							*t++ = (codepoint >> 12) + 0xE0;
							*t++ = ((codepoint >> 6) & 0x3F) + 0x80;
							*t++ = (codepoint & 0x3F) + 0x80;
						} else if (codepoint <= 0x10FFFF) {
							*t++ = (codepoint >> 18) + 0xF0;
							*t++ = ((codepoint >> 12) & 0x3F) + 0x80;
							*t++ = ((codepoint >> 6) & 0x3F) + 0x80;
							*t++ = (codepoint & 0x3F) + 0x80;
						}
					}
					break;
				default:
					/* check for an octal */
					if (ZEND_IS_OCT(*s)) {
						char octal_buf[4] = { 0, 0, 0, 0 };

						octal_buf[0] = *s;
						if (ZEND_IS_OCT(*(s+1))) {
							octal_buf[1] = *(++s);
							if (ZEND_IS_OCT(*(s+1))) {
								octal_buf[2] = *(++s);
							}
						}
						if (octal_buf[2] && (octal_buf[0] > '3') && !SCNG(heredoc_scan_ahead)) {
							/* 3 octit values must not overflow 0xFF (\377) */
							zend_error(E_COMPILE_WARNING, "Octal escape sequence overflow \\%s is greater than \\377", octal_buf);
						}

						*t++ = (char) ZEND_STRTOL(octal_buf, NULL, 8);
					} else {
						*t++ = '\\';
						*t++ = *s;
					}
					break;
			}
		} else {
			*t++ = *s;
		}

		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
	}
	*t = 0;
	Z_STRLEN_P(zendlval) = t - Z_STRVAL_P(zendlval);

skip_escape_conversion:
	if (SCNG(output_filter)) {
		size_t sz = 0;
		unsigned char *str;
		// TODO: avoid realocation ???
		s = Z_STRVAL_P(zendlval);
		SCNG(output_filter)(&str, &sz, (unsigned char *)s, (size_t)Z_STRLEN_P(zendlval));
		zval_ptr_dtor(zendlval);
		ZVAL_STRINGL(zendlval, (char *) str, sz);
		efree(str);
	}
	return SUCCESS;
}

#define HEREDOC_USING_SPACES 1
#define HEREDOC_USING_TABS 2

static const char *next_newline(const char *str, const char *end, size_t *newline_len) {
	for (; str < end; str++) {
		if (*str == '\r') {
			*newline_len = str + 1 < end && *(str + 1) == '\n' ? 2 : 1;
			return str;
		} else if (*str == '\n') {
			*newline_len = 1;
			return str;
		}
	}
	*newline_len = 0;
	return NULL;
}

static bool strip_multiline_string_indentation(
	zval *zendlval, int indentation, bool using_spaces,
	bool newline_at_start, bool newline_at_end)
{
	const char *str = Z_STRVAL_P(zendlval), *end = str + Z_STRLEN_P(zendlval);
	char *copy = Z_STRVAL_P(zendlval);

	int newline_count = 0;
	size_t newline_len;
	const char *nl;

	if (!newline_at_start) {
		nl = next_newline(str, end, &newline_len);
		if (!nl) {
			return 1;
		}

		str = nl + newline_len;
		copy = (char *) nl + newline_len;
		newline_count++;
	} else {
		nl = str;
	}

	/* <= intentional */
	while (str <= end && nl) {
		size_t skip;
		nl = next_newline(str, end, &newline_len);
		if (!nl && newline_at_end) {
			nl = end;
		}

		/* Try to skip indentation */
		for (skip = 0; skip < indentation; skip++, str++) {
			if (str == nl) {
				/* Don't require full indentation on whitespace-only lines */
				break;
			}

			if (str == end || (*str != ' ' && *str != '\t')) {
				CG(zend_lineno) += newline_count;
				zend_throw_exception_ex(zend_ce_parse_error, 0,
					"Invalid body indentation level (expecting an indentation level of at least %d)", indentation);
				goto error;
			}

			if ((!using_spaces && *str == ' ') || (using_spaces && *str == '\t')) {
				CG(zend_lineno) += newline_count;
				zend_throw_exception(zend_ce_parse_error,
					"Invalid indentation - tabs and spaces cannot be mixed", 0);
				goto error;
			}
		}

		if (str == end) {
			break;
		}

		size_t len = nl ? (nl - str + newline_len) : (end - str);
		memmove(copy, str, len);
		str += len;
		copy += len;
		newline_count++;
	}

	*copy = '\0';
	Z_STRLEN_P(zendlval) = copy - Z_STRVAL_P(zendlval);
	return 1;

error:
	zval_ptr_dtor_str(zendlval);
	ZVAL_UNDEF(zendlval);

	return 0;
}

static void copy_heredoc_label_stack(void *void_heredoc_label)
{
	zend_heredoc_label *heredoc_label = void_heredoc_label;
	zend_heredoc_label *new_heredoc_label = emalloc(sizeof(zend_heredoc_label));

	*new_heredoc_label = *heredoc_label;
	new_heredoc_label->label = estrndup(heredoc_label->label, heredoc_label->length);

	zend_ptr_stack_push(&SCNG(heredoc_label_stack), (void *) new_heredoc_label);
}

/* Check that { }, [ ], ( ) are nested correctly */
static void report_bad_nesting(char opening, int opening_lineno, char closing)
{
	char   buf[256];
	size_t used = 0;

	used = snprintf(buf, sizeof(buf), "Unclosed '%c'", opening);

	if (opening_lineno != CG(zend_lineno)) {
		used += snprintf(buf + used, sizeof(buf) - used, " on line %d", opening_lineno);
	}

	if (closing) { 	/* 'closing' will be 0 if at end of file */
		used += snprintf(buf + used, sizeof(buf) - used, " does not match '%c'", closing);
	}

	zend_throw_exception(zend_ce_parse_error, buf, 0);
}

static void enter_nesting(char opening)
{
	zend_nest_location nest_loc = {opening, CG(zend_lineno)};
	zend_stack_push(&SCNG(nest_location_stack), &nest_loc);
}

static zend_result exit_nesting(char closing)
{
	if (zend_stack_is_empty(&SCNG(nest_location_stack))) {
		zend_throw_exception_ex(zend_ce_parse_error, 0, "Unmatched '%c'", closing);
		return FAILURE;
	}

	zend_nest_location *nest_loc = zend_stack_top(&SCNG(nest_location_stack));
	char opening = nest_loc->text;

	if ((opening == '{' && closing != '}') ||
	    (opening == '[' && closing != ']') ||
	    (opening == '(' && closing != ')')) {
		report_bad_nesting(opening, nest_loc->lineno, closing);
		return FAILURE;
	}

	zend_stack_del_top(&SCNG(nest_location_stack));
	return SUCCESS;
}

static zend_result check_nesting_at_end(void)
{
	if (!zend_stack_is_empty(&SCNG(nest_location_stack))) {
		zend_nest_location *nest_loc = zend_stack_top(&SCNG(nest_location_stack));
		report_bad_nesting(nest_loc->text, nest_loc->lineno, 0);
		return FAILURE;
	}

	return SUCCESS;
}

#define PARSER_MODE() \
	EXPECTED(elem != NULL)

#define RETURN_TOKEN(_token) do { \
		token = _token; \
		goto emit_token; \
	} while (0)

#define RETURN_TOKEN_WITH_VAL(_token) do { \
		token = _token; \
		goto emit_token_with_val; \
	} while (0)

#define RETURN_TOKEN_WITH_STR(_token, _offset) do { \
		token = _token; \
		offset = _offset; \
		goto emit_token_with_str; \
	} while (0)

#define RETURN_TOKEN_WITH_IDENT(_token) do { \
		token = _token; \
		goto emit_token_with_ident; \
	} while (0)

#define RETURN_OR_SKIP_TOKEN(_token) do { \
		token = _token; \
		if (PARSER_MODE()) { \
			goto skip_token; \
		} \
		goto emit_token; \
	} while (0)

#define RETURN_EXIT_NESTING_TOKEN(_token) do { \
		if (exit_nesting(_token) && PARSER_MODE()) { \
			RETURN_TOKEN(T_ERROR); \
		} else { \
			RETURN_TOKEN(_token); \
		} \
	} while(0)

#define RETURN_END_TOKEN do { \
		if (check_nesting_at_end() && PARSER_MODE()) { \
			RETURN_TOKEN(T_ERROR); \
		} else { \
			RETURN_TOKEN(END); \
		} \
	} while (0)

int ZEND_FASTCALL lex_scan(zval *zendlval, zend_parser_stack_elem *elem)
{
int token;
int offset;
int start_line = CG(zend_lineno);

	ZVAL_UNDEF(zendlval);
restart:
	SCNG(yy_text) = YYCURSOR;


#line 1351 "Zend/zend_language_scanner.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	if (YYGETCONDITION() < 5) {
		if (YYGETCONDITION() < 2) {
			if (YYGETCONDITION() < 1) {
				goto yyc_ST_IN_SCRIPTING;
			} else {
				goto yyc_ST_LOOKING_FOR_PROPERTY;
			}
		} else {
			if (YYGETCONDITION() < 3) {
				goto yyc_ST_BACKQUOTE;
			} else {
				if (YYGETCONDITION() < 4) {
					goto yyc_ST_DOUBLE_QUOTES;
				} else {
					goto yyc_ST_HEREDOC;
				}
			}
		}
	} else {
		if (YYGETCONDITION() < 8) {
			if (YYGETCONDITION() < 6) {
				goto yyc_ST_LOOKING_FOR_VARNAME;
			} else {
				if (YYGETCONDITION() < 7) {
					goto yyc_ST_VAR_OFFSET;
				} else {
					goto yyc_SHEBANG;
				}
			}
		} else {
			if (YYGETCONDITION() < 9) {
				goto yyc_INITIAL;
			} else {
				if (YYGETCONDITION() < 10) {
					goto yyc_ST_END_HEREDOC;
				} else {
					goto yyc_ST_NOWDOC;
				}
			}
		}
	}
/* *********************************** */
yyc_ST_IN_SCRIPTING:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,  18,   2,   0,   0,   2,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			 18,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			236, 236, 204, 204, 204, 204, 204, 204, 
			140, 140,   0,   0,   0,   0,   0,   0, 
			  0, 136, 136, 136, 136, 136, 136,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   0,   0,   0,   0,   8, 
			  0, 136, 136, 136, 136, 136, 136,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   0,   0,   0,   0,   0, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
			  8,   8,   8,   8,   8,   8,   8,   8, 
		};
		YYDEBUG(1, *YYCURSOR);
		YYFILL(16);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 2) {
			goto yy5;
		}
		switch (yych) {
		case 0x00:
		case 0x01:
		case 0x02:
		case 0x03:
		case 0x04:
		case 0x05:
		case 0x06:
		case 0x07:
		case 0x08:
		case '\t':
		case '\n':
		case '\v':
		case '\f':
		case '\r':
		case 0x0E:
		case 0x0F:
		case 0x10:
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x1F:
		case 0x7F:	goto yy3;
		case ' ':
		case '!':	goto yy8;
		case '"':	goto yy10;
		case '#':	goto yy12;
		case '$':	goto yy14;
		case '%':	goto yy15;
		case '&':	goto yy16;
		case '\'':	goto yy18;
		case '(':	goto yy20;
		case ')':
		case ']':	goto yy22;
		case '*':	goto yy24;
		case '+':	goto yy25;
		case ',':
		case ';':
		case '@':
		case '~':	goto yy26;
		case '-':	goto yy27;
		case '.':	goto yy28;
		case '/':	goto yy29;
		case '0':	goto yy30;
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':	goto yy32;
		case ':':	goto yy34;
		case '<':	goto yy35;
		case '=':	goto yy36;
		case '>':	goto yy37;
		case '?':	goto yy38;
		case 'A':
		case 'a':	goto yy39;
		case 'B':
		case 'b':	goto yy41;
		case 'C':
		case 'c':	goto yy42;
		case 'D':
		case 'd':	goto yy43;
		case 'E':
		case 'e':	goto yy44;
		case 'F':
		case 'f':	goto yy45;
		case 'G':
		case 'g':	goto yy46;
		case 'I':
		case 'i':	goto yy49;
		case 'L':
		case 'l':	goto yy50;
		case 'M':
		case 'm':	goto yy51;
		case 'N':
		case 'n':	goto yy52;
		case 'O':
		case 'o':	goto yy53;
		case 'P':
		case 'p':	goto yy54;
		case 'R':
		case 'r':	goto yy55;
		case 'S':
		case 's':	goto yy56;
		case 'T':
		case 't':	goto yy57;
		case 'U':
		case 'u':	goto yy58;
		case 'V':
		case 'v':	goto yy59;
		case 'W':
		case 'w':	goto yy60;
		case 'X':
		case 'x':	goto yy61;
		case 'Y':
		case 'y':	goto yy62;
		case '[':	goto yy63;
		case '\\':	goto yy64;
		case '^':	goto yy66;
		case '_':	goto yy67;
		case '`':	goto yy68;
		case '{':	goto yy70;
		case '|':	goto yy72;
		case '}':	goto yy73;
		default:	goto yy47;
		}
yy3:
		YYDEBUG(3, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(4, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 3087 "Zend/zend_language_scanner.l"
		{
	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

	RETURN_TOKEN(T_BAD_CHARACTER);
}
#line 1573 "Zend/zend_language_scanner.c"
yy5:
		YYDEBUG(5, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(6, *YYCURSOR);
		if (yybm[0+yych] & 2) {
			goto yy5;
		}
		YYDEBUG(7, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1562 "Zend/zend_language_scanner.l"
		{
	goto return_whitespace;
}
#line 1589 "Zend/zend_language_scanner.c"
yy8:
		YYDEBUG(8, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy75;
yy9:
		YYDEBUG(9, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1886 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(yytext[0]);
}
#line 1601 "Zend/zend_language_scanner.c"
yy10:
		YYDEBUG(10, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(11, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2541 "Zend/zend_language_scanner.l"
		{
	int bprefix = (yytext[0] != '"') ? 1 : 0;

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '"':
				yyleng = YYCURSOR - SCNG(yy_text);
				if (EXPECTED(zend_scan_escape_string(zendlval, yytext+bprefix+1, yyleng-bprefix-2, '"') == SUCCESS)
				 || !PARSER_MODE()) {
					RETURN_TOKEN_WITH_VAL(T_CONSTANT_ENCAPSED_STRING);
				} else {
					RETURN_TOKEN(T_ERROR);
				}
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT) {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

	/* Remember how much was scanned to save rescanning */
	SET_DOUBLE_QUOTES_SCANNED_LENGTH(YYCURSOR - SCNG(yy_text) - yyleng);

	YYCURSOR = SCNG(yy_text) + yyleng;

	BEGIN(ST_DOUBLE_QUOTES);
	RETURN_TOKEN('"');
}
#line 1652 "Zend/zend_language_scanner.c"
yy12:
		YYDEBUG(12, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '[') goto yy77;
yy13:
		YYDEBUG(13, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2373 "Zend/zend_language_scanner.l"
		{
	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '\r':
			case '\n':
				YYCURSOR--;
				break;
			case '?':
				if (*YYCURSOR == '>') {
					YYCURSOR--;
					break;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		break;
	}

	yyleng = YYCURSOR - SCNG(yy_text);
	RETURN_OR_SKIP_TOKEN(T_COMMENT);
}
#line 1684 "Zend/zend_language_scanner.c"
yy14:
		YYDEBUG(14, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy9;
			if (yych <= 'Z') goto yy79;
			if (yych <= '^') goto yy9;
			goto yy79;
		} else {
			if (yych <= '`') goto yy9;
			if (yych <= 'z') goto yy79;
			if (yych <= 0x7F) goto yy9;
			goto yy79;
		}
yy15:
		YYDEBUG(15, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy82;
		goto yy9;
yy16:
		YYDEBUG(16, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '#') {
			if (yych <= '\f') {
				if (yych <= 0x08) goto yy17;
				if (yych <= '\n') goto yy84;
			} else {
				if (yych <= '\r') goto yy84;
				if (yych == ' ') goto yy84;
			}
		} else {
			if (yych <= '-') {
				if (yych <= '$') goto yy87;
				if (yych == '&') goto yy89;
			} else {
				if (yych <= '.') goto yy91;
				if (yych == '=') goto yy92;
			}
		}
yy17:
		YYDEBUG(17, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1872 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_AMPERSAND_NOT_FOLLOWED_BY_VAR_OR_VARARG);
}
#line 1732 "Zend/zend_language_scanner.c"
yy18:
		YYDEBUG(18, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(19, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2445 "Zend/zend_language_scanner.l"
		{
	char *s, *t;
	char *end;
	int bprefix = (yytext[0] != '\'') ? 1 : 0;

	while (1) {
		if (YYCURSOR < YYLIMIT) {
			if (*YYCURSOR == '\'') {
				YYCURSOR++;
				yyleng = YYCURSOR - SCNG(yy_text);

				break;
			} else if (*YYCURSOR++ == '\\' && YYCURSOR < YYLIMIT) {
				YYCURSOR++;
			}
		} else {
			yyleng = YYLIMIT - SCNG(yy_text);

			/* Unclosed single quotes; treat similar to double quotes, but without a separate token
			 * for ' (unrecognized by parser), instead of old flex fallback to "Unexpected character..."
			 * rule, which continued in ST_IN_SCRIPTING state after the quote */
			ZVAL_NULL(zendlval);
			RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
		}
	}

	if (yyleng-bprefix-2 <= 1) {
		if (yyleng-bprefix-2 < 1) {
			ZVAL_EMPTY_STRING(zendlval);
		} else {
			zend_uchar c = (zend_uchar)*(yytext+bprefix+1);
			if (c == '\n' || c == '\r') {
				CG(zend_lineno)++;
			}
			ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR(c));
		}
		goto skip_escape_conversion;
	}
	ZVAL_STRINGL(zendlval, yytext+bprefix+1, yyleng-bprefix-2);

	/* convert escape sequences */
	s = Z_STRVAL_P(zendlval);
	end = s+Z_STRLEN_P(zendlval);
	while (1) {
		if (UNEXPECTED(*s=='\\')) {
			break;
		}
		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
		if (s == end) {
			goto skip_escape_conversion;
		}
	}

	t = s;
	while (s<end) {
		if (*s=='\\') {
			s++;
			if (*s == '\\' || *s == '\'') {
				*t++ = *s;
			} else {
				*t++ = '\\';
				*t++ = *s;
			}
		} else {
			*t++ = *s;
		}
		if (*s == '\n' || (*s == '\r' && (*(s+1) != '\n'))) {
			CG(zend_lineno)++;
		}
		s++;
	}
	*t = 0;
	Z_STRLEN_P(zendlval) = t - Z_STRVAL_P(zendlval);

skip_escape_conversion:
	if (SCNG(output_filter)) {
		size_t sz = 0;
		char *str = NULL;
		zend_string *new_str;
		s = Z_STRVAL_P(zendlval);
		// TODO: avoid reallocation ???
		SCNG(output_filter)((unsigned char **)&str, &sz, (unsigned char *)s, (size_t)Z_STRLEN_P(zendlval));
		new_str = zend_string_init(str, sz, 0);
		if (str != s) {
			efree(str);
		}
		zend_string_release_ex(Z_STR_P(zendlval), 0);
		ZVAL_STR(zendlval, new_str);
	}
	RETURN_TOKEN_WITH_VAL(T_CONSTANT_ENCAPSED_STRING);
}
#line 1833 "Zend/zend_language_scanner.c"
yy20:
		YYDEBUG(20, *YYCURSOR);
		yyaccept = 1;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'D') {
				if (yych <= ' ') {
					if (yych == '\t') goto yy95;
					if (yych >= ' ') goto yy95;
				} else {
					if (yych <= '@') goto yy21;
					if (yych != 'C') goto yy95;
				}
			} else {
				if (yych <= 'I') {
					if (yych == 'F') goto yy95;
					if (yych >= 'I') goto yy95;
				} else {
					if (yych == 'O') goto yy95;
					if (yych >= 'R') goto yy95;
				}
			}
		} else {
			if (yych <= 'f') {
				if (yych <= 'b') {
					if (yych == 'U') goto yy95;
					if (yych >= 'a') goto yy95;
				} else {
					if (yych == 'd') goto yy95;
					if (yych >= 'f') goto yy95;
				}
			} else {
				if (yych <= 'o') {
					if (yych == 'i') goto yy95;
					if (yych >= 'o') goto yy95;
				} else {
					if (yych <= 's') {
						if (yych >= 'r') goto yy95;
					} else {
						if (yych == 'u') goto yy95;
					}
				}
			}
		}
yy21:
		YYDEBUG(21, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1881 "Zend/zend_language_scanner.l"
		{
	enter_nesting(yytext[0]);
	RETURN_TOKEN(yytext[0]);
}
#line 1886 "Zend/zend_language_scanner.c"
yy22:
		YYDEBUG(22, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(23, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1876 "Zend/zend_language_scanner.l"
		{
	/* Check that ] and ) match up properly with a preceding [ or ( */
	RETURN_EXIT_NESTING_TOKEN(yytext[0]);
}
#line 1897 "Zend/zend_language_scanner.c"
yy24:
		YYDEBUG(24, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '*') goto yy105;
		if (yych == '=') goto yy107;
		goto yy9;
yy25:
		YYDEBUG(25, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '+') goto yy109;
		if (yych == '=') goto yy111;
		goto yy9;
yy26:
		YYDEBUG(26, *YYCURSOR);
		++YYCURSOR;
		goto yy9;
yy27:
		YYDEBUG(27, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') {
			if (yych == '-') goto yy113;
			goto yy9;
		} else {
			if (yych <= '=') goto yy115;
			if (yych <= '>') goto yy117;
			goto yy9;
		}
yy28:
		YYDEBUG(28, *YYCURSOR);
		yyaccept = 2;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '/') {
			if (yych == '.') goto yy119;
			goto yy9;
		} else {
			if (yych <= '9') goto yy120;
			if (yych == '=') goto yy123;
			goto yy9;
		}
yy29:
		YYDEBUG(29, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '.') {
			if (yych == '*') goto yy125;
			goto yy9;
		} else {
			if (yych <= '/') goto yy127;
			if (yych == '=') goto yy128;
			goto yy9;
		}
yy30:
		YYDEBUG(30, *YYCURSOR);
		yyaccept = 3;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'X') {
			if (yych <= 'N') {
				if (yych == 'B') goto yy131;
				goto yy33;
			} else {
				if (yych <= 'O') goto yy133;
				if (yych <= 'W') goto yy33;
				goto yy134;
			}
		} else {
			if (yych <= 'n') {
				if (yych == 'b') goto yy131;
				goto yy33;
			} else {
				if (yych <= 'o') goto yy133;
				if (yych == 'x') goto yy134;
				goto yy33;
			}
		}
yy31:
		YYDEBUG(31, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2020 "Zend/zend_language_scanner.l"
		{
	size_t len = yyleng;
	char *end, *lnum = yytext;
	bool is_octal = lnum[0] == '0';
	bool contains_underscores = (memchr(lnum, '_', len) != NULL);

	if (contains_underscores) {
		lnum = estrndup(lnum, len);
		strip_underscores(lnum, &len);
	}

	/* Digits 8 and 9 are illegal in octal literals. */
	if (is_octal) {
		size_t i;
		for (i = 0; i < len; i++) {
			if (lnum[i] == '8' || lnum[i] == '9') {
				zend_throw_exception(zend_ce_parse_error, "Invalid numeric literal", 0);
				if (PARSER_MODE()) {
					if (contains_underscores) {
						efree(lnum);
					}
					ZVAL_UNDEF(zendlval);
					RETURN_TOKEN(T_ERROR);
				}

				/* Continue in order to determine if this is T_LNUMBER or T_DNUMBER. */
				len = i;
				break;
			}
		}
	}


	if (len < MAX_LENGTH_OF_LONG - 1) { /* Won't overflow */
		errno = 0;
		/* base must be passed explicitly for correct parse error on Windows */
		ZVAL_LONG(zendlval, ZEND_STRTOL(lnum, &end, is_octal ? 8 : 10));
		ZEND_ASSERT(end == lnum + len);
	} else {
		errno = 0;
		ZVAL_LONG(zendlval, ZEND_STRTOL(lnum, &end, 0));
		if (errno == ERANGE) { /* Overflow */
			errno = 0;
			if (is_octal) { /* octal overflow */
				ZVAL_DOUBLE(zendlval, zend_oct_strtod(lnum, (const char **)&end));
			} else {
				ZVAL_DOUBLE(zendlval, zend_strtod(lnum, (const char **)&end));
			}
			ZEND_ASSERT(end == lnum + len);
			if (contains_underscores) {
				efree(lnum);
			}
			RETURN_TOKEN_WITH_VAL(T_DNUMBER);
		}
		ZEND_ASSERT(end == lnum + len);
	}
	ZEND_ASSERT(!errno);
	if (contains_underscores) {
		efree(lnum);
	}
	RETURN_TOKEN_WITH_VAL(T_LNUMBER);
}
#line 2037 "Zend/zend_language_scanner.c"
yy32:
		YYDEBUG(32, *YYCURSOR);
		yyaccept = 3;
		YYMARKER = ++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy33:
		YYDEBUG(33, *YYCURSOR);
		if (yybm[0+yych] & 4) {
			goto yy32;
		}
		if (yych <= 'E') {
			if (yych == '.') goto yy130;
			if (yych <= 'D') goto yy31;
			goto yy132;
		} else {
			if (yych <= '_') {
				if (yych <= '^') goto yy31;
				goto yy135;
			} else {
				if (yych == 'e') goto yy132;
				goto yy31;
			}
		}
yy34:
		YYDEBUG(34, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == ':') goto yy136;
		goto yy9;
yy35:
		YYDEBUG(35, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= ';') goto yy9;
		if (yych <= '<') goto yy138;
		if (yych <= '=') goto yy140;
		if (yych <= '>') goto yy142;
		goto yy9;
yy36:
		YYDEBUG(36, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy9;
		if (yych <= '=') goto yy143;
		if (yych <= '>') goto yy145;
		goto yy9;
yy37:
		YYDEBUG(37, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '<') goto yy9;
		if (yych <= '=') goto yy147;
		if (yych <= '>') goto yy149;
		goto yy9;
yy38:
		YYDEBUG(38, *YYCURSOR);
		yyaccept = 2;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '=') {
			if (yych == '-') goto yy151;
			goto yy9;
		} else {
			if (yych <= '>') goto yy152;
			if (yych <= '?') goto yy154;
			goto yy9;
		}
yy39:
		YYDEBUG(39, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'M') {
				if (yych == 'B') goto yy156;
				goto yy48;
			} else {
				if (yych <= 'N') goto yy157;
				if (yych <= 'Q') goto yy48;
				if (yych <= 'R') goto yy158;
				goto yy159;
			}
		} else {
			if (yych <= 'n') {
				if (yych == 'b') goto yy156;
				if (yych <= 'm') goto yy48;
				goto yy157;
			} else {
				if (yych <= 'q') goto yy48;
				if (yych <= 'r') goto yy158;
				if (yych <= 's') goto yy159;
				goto yy48;
			}
		}
yy40:
		YYDEBUG(40, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2368 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_STR(T_STRING, 0);
}
#line 2134 "Zend/zend_language_scanner.c"
yy41:
		YYDEBUG(41, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= ';') {
			if (yych <= '"') {
				if (yych <= '!') goto yy48;
				goto yy10;
			} else {
				if (yych == '\'') goto yy18;
				goto yy48;
			}
		} else {
			if (yych <= 'R') {
				if (yych <= '<') goto yy162;
				if (yych <= 'Q') goto yy48;
				goto yy163;
			} else {
				if (yych == 'r') goto yy163;
				goto yy48;
			}
		}
yy42:
		YYDEBUG(42, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych <= 'K') {
				if (yych == 'A') goto yy164;
				goto yy48;
			} else {
				if (yych <= 'L') goto yy165;
				if (yych <= 'N') goto yy48;
				goto yy166;
			}
		} else {
			if (yych <= 'k') {
				if (yych == 'a') goto yy164;
				goto yy48;
			} else {
				if (yych <= 'l') goto yy165;
				if (yych == 'o') goto yy166;
				goto yy48;
			}
		}
yy43:
		YYDEBUG(43, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych <= 'H') {
				if (yych == 'E') goto yy167;
				goto yy48;
			} else {
				if (yych <= 'I') goto yy168;
				if (yych <= 'N') goto yy48;
				goto yy169;
			}
		} else {
			if (yych <= 'h') {
				if (yych == 'e') goto yy167;
				goto yy48;
			} else {
				if (yych <= 'i') goto yy168;
				if (yych == 'o') goto yy169;
				goto yy48;
			}
		}
yy44:
		YYDEBUG(44, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		switch (yych) {
		case 'C':
		case 'c':	goto yy171;
		case 'L':
		case 'l':	goto yy172;
		case 'M':
		case 'm':	goto yy173;
		case 'N':
		case 'n':	goto yy174;
		case 'V':
		case 'v':	goto yy175;
		case 'X':
		case 'x':	goto yy176;
		default:	goto yy48;
		}
yy45:
		YYDEBUG(45, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'U') {
			if (yych <= 'M') {
				if (yych == 'I') goto yy177;
				goto yy48;
			} else {
				if (yych <= 'N') goto yy178;
				if (yych <= 'O') goto yy180;
				if (yych <= 'T') goto yy48;
				goto yy181;
			}
		} else {
			if (yych <= 'n') {
				if (yych == 'i') goto yy177;
				if (yych <= 'm') goto yy48;
				goto yy178;
			} else {
				if (yych <= 'o') goto yy180;
				if (yych == 'u') goto yy181;
				goto yy48;
			}
		}
yy46:
		YYDEBUG(46, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych == 'L') goto yy182;
			if (yych <= 'N') goto yy48;
			goto yy183;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy48;
				goto yy182;
			} else {
				if (yych == 'o') goto yy183;
				goto yy48;
			}
		}
yy47:
		YYDEBUG(47, *YYCURSOR);
		yyaccept = 4;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy48:
		YYDEBUG(48, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
		goto yy40;
yy49:
		YYDEBUG(49, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych <= 'L') {
				if (yych == 'F') goto yy184;
				goto yy48;
			} else {
				if (yych <= 'M') goto yy186;
				if (yych <= 'N') goto yy187;
				if (yych <= 'R') goto yy48;
				goto yy188;
			}
		} else {
			if (yych <= 'm') {
				if (yych == 'f') goto yy184;
				if (yych <= 'l') goto yy48;
				goto yy186;
			} else {
				if (yych <= 'n') goto yy187;
				if (yych == 's') goto yy188;
				goto yy48;
			}
		}
yy50:
		YYDEBUG(50, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy189;
		if (yych == 'i') goto yy189;
		goto yy48;
yy51:
		YYDEBUG(51, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy190;
		if (yych == 'a') goto yy190;
		goto yy48;
yy52:
		YYDEBUG(52, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'E') {
			if (yych == 'A') goto yy191;
			if (yych <= 'D') goto yy48;
			goto yy192;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy48;
				goto yy191;
			} else {
				if (yych == 'e') goto yy192;
				goto yy48;
			}
		}
yy53:
		YYDEBUG(53, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy193;
		if (yych == 'r') goto yy193;
		goto yy48;
yy54:
		YYDEBUG(54, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'U') {
			if (yych == 'R') goto yy195;
			if (yych <= 'T') goto yy48;
			goto yy196;
		} else {
			if (yych <= 'r') {
				if (yych <= 'q') goto yy48;
				goto yy195;
			} else {
				if (yych == 'u') goto yy196;
				goto yy48;
			}
		}
yy55:
		YYDEBUG(55, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy197;
		if (yych == 'e') goto yy197;
		goto yy48;
yy56:
		YYDEBUG(56, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'W') {
			if (yych == 'T') goto yy198;
			if (yych <= 'V') goto yy48;
			goto yy199;
		} else {
			if (yych <= 't') {
				if (yych <= 's') goto yy48;
				goto yy198;
			} else {
				if (yych == 'w') goto yy199;
				goto yy48;
			}
		}
yy57:
		YYDEBUG(57, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'R') {
			if (yych == 'H') goto yy200;
			if (yych <= 'Q') goto yy48;
			goto yy201;
		} else {
			if (yych <= 'h') {
				if (yych <= 'g') goto yy48;
				goto yy200;
			} else {
				if (yych == 'r') goto yy201;
				goto yy48;
			}
		}
yy58:
		YYDEBUG(58, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'S') {
			if (yych == 'N') goto yy202;
			if (yych <= 'R') goto yy48;
			goto yy203;
		} else {
			if (yych <= 'n') {
				if (yych <= 'm') goto yy48;
				goto yy202;
			} else {
				if (yych == 's') goto yy203;
				goto yy48;
			}
		}
yy59:
		YYDEBUG(59, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy204;
		if (yych == 'a') goto yy204;
		goto yy48;
yy60:
		YYDEBUG(60, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy205;
		if (yych == 'h') goto yy205;
		goto yy48;
yy61:
		YYDEBUG(61, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy206;
		if (yych == 'o') goto yy206;
		goto yy48;
yy62:
		YYDEBUG(62, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy207;
		if (yych == 'i') goto yy207;
		goto yy48;
yy63:
		YYDEBUG(63, *YYCURSOR);
		++YYCURSOR;
		goto yy21;
yy64:
		YYDEBUG(64, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy65;
			if (yych <= 'Z') goto yy208;
			if (yych >= '_') goto yy208;
		} else {
			if (yych <= '`') goto yy65;
			if (yych <= 'z') goto yy208;
			if (yych >= 0x80) goto yy208;
		}
yy65:
		YYDEBUG(65, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2364 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_NS_SEPARATOR);
}
#line 2466 "Zend/zend_language_scanner.c"
yy66:
		YYDEBUG(66, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy211;
		goto yy9;
yy67:
		YYDEBUG(67, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy213;
		goto yy48;
yy68:
		YYDEBUG(68, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(69, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2733 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_BACKQUOTE);
	RETURN_TOKEN('`');
}
#line 2488 "Zend/zend_language_scanner.c"
yy70:
		YYDEBUG(70, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(71, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1891 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_IN_SCRIPTING);
	enter_nesting('{');
	RETURN_TOKEN('{');
}
#line 2500 "Zend/zend_language_scanner.c"
yy72:
		YYDEBUG(72, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy214;
		if (yych == '|') goto yy216;
		goto yy9;
yy73:
		YYDEBUG(73, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(74, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1904 "Zend/zend_language_scanner.l"
		{
	RESET_DOC_COMMENT();
	if (!zend_stack_is_empty(&SCNG(state_stack))) {
		yy_pop_state();
	}
	RETURN_EXIT_NESTING_TOKEN('}');
}
#line 2520 "Zend/zend_language_scanner.c"
yy75:
		YYDEBUG(75, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy218;
yy76:
		YYDEBUG(76, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1767 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_IS_NOT_EQUAL);
}
#line 2532 "Zend/zend_language_scanner.c"
yy77:
		YYDEBUG(77, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(78, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1388 "Zend/zend_language_scanner.l"
		{
	enter_nesting('[');
	RETURN_TOKEN(T_ATTRIBUTE);
}
#line 2543 "Zend/zend_language_scanner.c"
yy79:
		YYDEBUG(79, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(80, *YYCURSOR);
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy79;
			} else {
				if (yych <= '@') goto yy81;
				if (yych <= 'Z') goto yy79;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy79;
			} else {
				if (yych <= 'z') goto yy79;
				if (yych >= 0x80) goto yy79;
			}
		}
yy81:
		YYDEBUG(81, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2330 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
#line 2572 "Zend/zend_language_scanner.c"
yy82:
		YYDEBUG(82, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(83, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1811 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_MOD_EQUAL);
}
#line 2582 "Zend/zend_language_scanner.c"
yy84:
		YYDEBUG(84, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
		YYDEBUG(85, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych >= '\t') goto yy84;
			} else {
				if (yych == '\r') goto yy84;
			}
		} else {
			if (yych <= '$') {
				if (yych <= ' ') goto yy84;
				if (yych >= '$') goto yy87;
			} else {
				if (yych == '.') goto yy91;
			}
		}
yy86:
		YYDEBUG(86, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept <= 46) {
			if (yyaccept <= 23) {
				if (yyaccept <= 11) {
					if (yyaccept <= 5) {
						if (yyaccept <= 2) {
							if (yyaccept <= 1) {
								if (yyaccept == 0) {
									goto yy17;
								} else {
									goto yy21;
								}
							} else {
								goto yy9;
							}
						} else {
							if (yyaccept <= 4) {
								if (yyaccept == 3) {
									goto yy31;
								} else {
									goto yy40;
								}
							} else {
								goto yy122;
							}
						}
					} else {
						if (yyaccept <= 8) {
							if (yyaccept <= 7) {
								if (yyaccept == 6) {
									goto yy126;
								} else {
									goto yy139;
								}
							} else {
								goto yy160;
							}
						} else {
							if (yyaccept <= 10) {
								if (yyaccept == 9) {
									goto yy170;
								} else {
									goto yy179;
								}
							} else {
								goto yy185;
							}
						}
					}
				} else {
					if (yyaccept <= 17) {
						if (yyaccept <= 14) {
							if (yyaccept <= 13) {
								if (yyaccept == 12) {
									goto yy194;
								} else {
									goto yy210;
								}
							} else {
								goto yy239;
							}
						} else {
							if (yyaccept <= 16) {
								if (yyaccept == 15) {
									goto yy245;
								} else {
									goto yy248;
								}
							} else {
								goto yy267;
							}
						}
					} else {
						if (yyaccept <= 20) {
							if (yyaccept <= 19) {
								if (yyaccept == 18) {
									goto yy271;
								} else {
									goto yy283;
								}
							} else {
								goto yy294;
							}
						} else {
							if (yyaccept <= 22) {
								if (yyaccept == 21) {
									goto yy307;
								} else {
									goto yy319;
								}
							} else {
								goto yy322;
							}
						}
					}
				}
			} else {
				if (yyaccept <= 35) {
					if (yyaccept <= 29) {
						if (yyaccept <= 26) {
							if (yyaccept <= 25) {
								if (yyaccept == 24) {
									goto yy324;
								} else {
									goto yy327;
								}
							} else {
								goto yy359;
							}
						} else {
							if (yyaccept <= 28) {
								if (yyaccept == 27) {
									goto yy368;
								} else {
									goto yy370;
								}
							} else {
								goto yy379;
							}
						}
					} else {
						if (yyaccept <= 32) {
							if (yyaccept <= 31) {
								if (yyaccept == 30) {
									goto yy381;
								} else {
									goto yy388;
								}
							} else {
								goto yy395;
							}
						} else {
							if (yyaccept <= 34) {
								if (yyaccept == 33) {
									goto yy445;
								} else {
									goto yy447;
								}
							} else {
								goto yy450;
							}
						}
					}
				} else {
					if (yyaccept <= 41) {
						if (yyaccept <= 38) {
							if (yyaccept <= 37) {
								if (yyaccept == 36) {
									goto yy452;
								} else {
									goto yy454;
								}
							} else {
								goto yy456;
							}
						} else {
							if (yyaccept <= 40) {
								if (yyaccept == 39) {
									goto yy462;
								} else {
									goto yy466;
								}
							} else {
								goto yy473;
							}
						}
					} else {
						if (yyaccept <= 44) {
							if (yyaccept <= 43) {
								if (yyaccept == 42) {
									goto yy483;
								} else {
									goto yy485;
								}
							} else {
								goto yy488;
							}
						} else {
							if (yyaccept == 45) {
								goto yy498;
							} else {
								goto yy500;
							}
						}
					}
				}
			}
		} else {
			if (yyaccept <= 69) {
				if (yyaccept <= 58) {
					if (yyaccept <= 52) {
						if (yyaccept <= 49) {
							if (yyaccept <= 48) {
								if (yyaccept == 47) {
									goto yy502;
								} else {
									goto yy504;
								}
							} else {
								goto yy506;
							}
						} else {
							if (yyaccept <= 51) {
								if (yyaccept == 50) {
									goto yy541;
								} else {
									goto yy544;
								}
							} else {
								goto yy548;
							}
						}
					} else {
						if (yyaccept <= 55) {
							if (yyaccept <= 54) {
								if (yyaccept == 53) {
									goto yy556;
								} else {
									goto yy566;
								}
							} else {
								goto yy570;
							}
						} else {
							if (yyaccept <= 57) {
								if (yyaccept == 56) {
									goto yy572;
								} else {
									goto yy574;
								}
							} else {
								goto yy602;
							}
						}
					}
				} else {
					if (yyaccept <= 64) {
						if (yyaccept <= 61) {
							if (yyaccept <= 60) {
								if (yyaccept == 59) {
									goto yy604;
								} else {
									goto yy612;
								}
							} else {
								goto yy614;
							}
						} else {
							if (yyaccept <= 63) {
								if (yyaccept == 62) {
									goto yy616;
								} else {
									goto yy620;
								}
							} else {
								goto yy626;
							}
						}
					} else {
						if (yyaccept <= 67) {
							if (yyaccept <= 66) {
								if (yyaccept == 65) {
									goto yy630;
								} else {
									goto yy634;
								}
							} else {
								goto yy647;
							}
						} else {
							if (yyaccept == 68) {
								goto yy649;
							} else {
								goto yy651;
							}
						}
					}
				}
			} else {
				if (yyaccept <= 81) {
					if (yyaccept <= 75) {
						if (yyaccept <= 72) {
							if (yyaccept <= 71) {
								if (yyaccept == 70) {
									goto yy656;
								} else {
									goto yy660;
								}
							} else {
								goto yy669;
							}
						} else {
							if (yyaccept <= 74) {
								if (yyaccept == 73) {
									goto yy674;
								} else {
									goto yy678;
								}
							} else {
								goto yy685;
							}
						}
					} else {
						if (yyaccept <= 78) {
							if (yyaccept <= 77) {
								if (yyaccept == 76) {
									goto yy692;
								} else {
									goto yy694;
								}
							} else {
								goto yy696;
							}
						} else {
							if (yyaccept <= 80) {
								if (yyaccept == 79) {
									goto yy698;
								} else {
									goto yy706;
								}
							} else {
								goto yy712;
							}
						}
					}
				} else {
					if (yyaccept <= 87) {
						if (yyaccept <= 84) {
							if (yyaccept <= 83) {
								if (yyaccept == 82) {
									goto yy714;
								} else {
									goto yy716;
								}
							} else {
								goto yy720;
							}
						} else {
							if (yyaccept <= 86) {
								if (yyaccept == 85) {
									goto yy723;
								} else {
									goto yy730;
								}
							} else {
								goto yy737;
							}
						}
					} else {
						if (yyaccept <= 90) {
							if (yyaccept <= 89) {
								if (yyaccept == 88) {
									goto yy748;
								} else {
									goto yy750;
								}
							} else {
								goto yy752;
							}
						} else {
							if (yyaccept == 91) {
								goto yy758;
							} else {
								goto yy761;
							}
						}
					}
				}
			}
		}
yy87:
		YYDEBUG(87, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(88, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1867 "Zend/zend_language_scanner.l"
		{
	yyless(1);
	RETURN_TOKEN(T_AMPERSAND_FOLLOWED_BY_VAR_OR_VARARG);
}
#line 2985 "Zend/zend_language_scanner.c"
yy89:
		YYDEBUG(89, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(90, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1843 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_BOOLEAN_AND);
}
#line 2995 "Zend/zend_language_scanner.c"
yy91:
		YYDEBUG(91, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '.') goto yy220;
		goto yy86;
yy92:
		YYDEBUG(92, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(93, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1823 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_AND_EQUAL);
}
#line 3010 "Zend/zend_language_scanner.c"
yy94:
		YYDEBUG(94, *YYCURSOR);
		++YYCURSOR;
		YYFILL(7);
		yych = *YYCURSOR;
yy95:
		YYDEBUG(95, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy94;
		}
		switch (yych) {
		case 'A':
		case 'a':	goto yy96;
		case 'B':
		case 'b':	goto yy97;
		case 'D':
		case 'd':	goto yy98;
		case 'F':
		case 'f':	goto yy99;
		case 'I':
		case 'i':	goto yy100;
		case 'O':
		case 'o':	goto yy101;
		case 'R':
		case 'r':	goto yy102;
		case 'S':
		case 's':	goto yy103;
		case 'U':
		case 'u':	goto yy104;
		default:	goto yy86;
		}
yy96:
		YYDEBUG(96, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy221;
		if (yych == 'r') goto yy221;
		goto yy86;
yy97:
		YYDEBUG(97, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= 'O') {
			if (yych == 'I') goto yy222;
			if (yych <= 'N') goto yy86;
			goto yy223;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy86;
				goto yy222;
			} else {
				if (yych == 'o') goto yy223;
				goto yy86;
			}
		}
yy98:
		YYDEBUG(98, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy224;
		if (yych == 'o') goto yy224;
		goto yy86;
yy99:
		YYDEBUG(99, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy225;
		if (yych == 'l') goto yy225;
		goto yy86;
yy100:
		YYDEBUG(100, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy226;
		if (yych == 'n') goto yy226;
		goto yy86;
yy101:
		YYDEBUG(101, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy227;
		if (yych == 'b') goto yy227;
		goto yy86;
yy102:
		YYDEBUG(102, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy228;
		if (yych == 'e') goto yy228;
		goto yy86;
yy103:
		YYDEBUG(103, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy229;
		if (yych == 't') goto yy229;
		goto yy86;
yy104:
		YYDEBUG(104, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy230;
		if (yych == 'n') goto yy230;
		goto yy86;
yy105:
		YYDEBUG(105, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy231;
		YYDEBUG(106, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1795 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_POW);
}
#line 3116 "Zend/zend_language_scanner.c"
yy107:
		YYDEBUG(107, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(108, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1791 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_MUL_EQUAL);
}
#line 3126 "Zend/zend_language_scanner.c"
yy109:
		YYDEBUG(109, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(110, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1747 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_INC);
}
#line 3136 "Zend/zend_language_scanner.c"
yy111:
		YYDEBUG(111, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(112, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1783 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_PLUS_EQUAL);
}
#line 3146 "Zend/zend_language_scanner.c"
yy113:
		YYDEBUG(113, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(114, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1751 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_DEC);
}
#line 3156 "Zend/zend_language_scanner.c"
yy115:
		YYDEBUG(115, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(116, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1787 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_MINUS_EQUAL);
}
#line 3166 "Zend/zend_language_scanner.c"
yy117:
		YYDEBUG(117, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(118, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1552 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN(T_OBJECT_OPERATOR);
}
#line 3177 "Zend/zend_language_scanner.c"
yy119:
		YYDEBUG(119, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '.') goto yy233;
		goto yy86;
yy120:
		YYDEBUG(120, *YYCURSOR);
		yyaccept = 5;
		YYMARKER = ++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
yy121:
		YYDEBUG(121, *YYCURSOR);
		if (yych <= 'E') {
			if (yych <= '/') goto yy122;
			if (yych <= '9') goto yy120;
			if (yych >= 'E') goto yy132;
		} else {
			if (yych <= '_') {
				if (yych >= '_') goto yy235;
			} else {
				if (yych == 'e') goto yy132;
			}
		}
yy122:
		YYDEBUG(122, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2150 "Zend/zend_language_scanner.l"
		{
	const char *end;
	size_t len = yyleng;
	char *dnum = yytext;
	bool contains_underscores = (memchr(dnum, '_', len) != NULL);

	if (contains_underscores) {
		dnum = estrndup(dnum, len);
		strip_underscores(dnum, &len);
	}

	ZVAL_DOUBLE(zendlval, zend_strtod(dnum, &end));
	/* errno isn't checked since we allow HUGE_VAL/INF overflow */
	ZEND_ASSERT(end == dnum + len);
	if (contains_underscores) {
		efree(dnum);
	}
	RETURN_TOKEN_WITH_VAL(T_DNUMBER);
}
#line 3225 "Zend/zend_language_scanner.c"
yy123:
		YYDEBUG(123, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(124, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1807 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_CONCAT_EQUAL);
}
#line 3235 "Zend/zend_language_scanner.c"
yy125:
		YYDEBUG(125, *YYCURSOR);
		yyaccept = 6;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '*') goto yy236;
yy126:
		YYDEBUG(126, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2397 "Zend/zend_language_scanner.l"
		{
	int doc_com;

	if (yyleng > 2) {
		doc_com = 1;
		RESET_DOC_COMMENT();
	} else {
		doc_com = 0;
	}

	while (YYCURSOR < YYLIMIT) {
		if (*YYCURSOR++ == '*' && *YYCURSOR == '/') {
			break;
		}
	}

	if (YYCURSOR < YYLIMIT) {
		YYCURSOR++;
	} else {
		zend_throw_exception_ex(zend_ce_parse_error, 0, "Unterminated comment starting line %d", CG(zend_lineno));
		if (PARSER_MODE()) {
			RETURN_TOKEN(T_ERROR);
		}
	}

	yyleng = YYCURSOR - SCNG(yy_text);
	HANDLE_NEWLINES(yytext, yyleng);

	if (doc_com) {
		CG(doc_comment) = zend_string_init(yytext, yyleng, 0);
		RETURN_OR_SKIP_TOKEN(T_DOC_COMMENT);
	}

	RETURN_OR_SKIP_TOKEN(T_COMMENT);
}
#line 3280 "Zend/zend_language_scanner.c"
yy127:
		YYDEBUG(127, *YYCURSOR);
		++YYCURSOR;
		goto yy13;
yy128:
		YYDEBUG(128, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(129, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1803 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_DIV_EQUAL);
}
#line 3294 "Zend/zend_language_scanner.c"
yy130:
		YYDEBUG(130, *YYCURSOR);
		yyaccept = 5;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy122;
		goto yy121;
yy131:
		YYDEBUG(131, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy237;
		}
		goto yy86;
yy132:
		YYDEBUG(132, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= ',') {
			if (yych == '+') goto yy240;
			goto yy86;
		} else {
			if (yych <= '-') goto yy240;
			if (yych <= '/') goto yy86;
			if (yych <= '9') goto yy241;
			goto yy86;
		}
yy133:
		YYDEBUG(133, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 64) {
			goto yy243;
		}
		goto yy86;
yy134:
		YYDEBUG(134, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 128) {
			goto yy246;
		}
		goto yy86;
yy135:
		YYDEBUG(135, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 4) {
			goto yy32;
		}
		goto yy86;
yy136:
		YYDEBUG(136, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(137, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1585 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_PAAMAYIM_NEKUDOTAYIM);
}
#line 3358 "Zend/zend_language_scanner.c"
yy138:
		YYDEBUG(138, *YYCURSOR);
		yyaccept = 7;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= ';') goto yy139;
		if (yych <= '<') goto yy249;
		if (yych <= '=') goto yy251;
yy139:
		YYDEBUG(139, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1859 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_SL);
}
#line 3373 "Zend/zend_language_scanner.c"
yy140:
		YYDEBUG(140, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy253;
		YYDEBUG(141, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1775 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_IS_SMALLER_OR_EQUAL);
}
#line 3384 "Zend/zend_language_scanner.c"
yy142:
		YYDEBUG(142, *YYCURSOR);
		++YYCURSOR;
		goto yy76;
yy143:
		YYDEBUG(143, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy255;
		YYDEBUG(144, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1763 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_IS_EQUAL);
}
#line 3399 "Zend/zend_language_scanner.c"
yy145:
		YYDEBUG(145, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(146, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1731 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_DOUBLE_ARROW);
}
#line 3409 "Zend/zend_language_scanner.c"
yy147:
		YYDEBUG(147, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(148, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1779 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_IS_GREATER_OR_EQUAL);
}
#line 3419 "Zend/zend_language_scanner.c"
yy149:
		YYDEBUG(149, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy257;
		YYDEBUG(150, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1863 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_SR);
}
#line 3430 "Zend/zend_language_scanner.c"
yy151:
		YYDEBUG(151, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy259;
		goto yy86;
yy152:
		YYDEBUG(152, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy261;
		if (yych == '\r') goto yy262;
yy153:
		YYDEBUG(153, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2433 "Zend/zend_language_scanner.l"
		{
	BEGIN(INITIAL);
	if (yytext[yyleng-1] != '>') {
		CG(increment_lineno) = 1;
	}
	if (PARSER_MODE()) {
		RETURN_TOKEN(';');  /* implicit ';' at php-end tag */
	}
	RETURN_TOKEN(T_CLOSE_TAG);
}
#line 3455 "Zend/zend_language_scanner.c"
yy154:
		YYDEBUG(154, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '=') goto yy263;
		YYDEBUG(155, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1593 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_COALESCE);
}
#line 3466 "Zend/zend_language_scanner.c"
yy156:
		YYDEBUG(156, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy265;
		if (yych == 's') goto yy265;
		goto yy48;
yy157:
		YYDEBUG(157, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy266;
		if (yych == 'd') goto yy266;
		goto yy48;
yy158:
		YYDEBUG(158, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy268;
		if (yych == 'r') goto yy268;
		goto yy48;
yy159:
		YYDEBUG(159, *YYCURSOR);
		yyaccept = 8;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy160:
		YYDEBUG(160, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1475 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_AS);
}
#line 3503 "Zend/zend_language_scanner.c"
yy161:
		YYDEBUG(161, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy86;
			if (yych <= 'Z') goto yy269;
			if (yych <= '^') goto yy86;
			goto yy269;
		} else {
			if (yych <= '`') goto yy86;
			if (yych <= 'z') goto yy269;
			if (yych <= 0x7F) goto yy86;
			goto yy269;
		}
yy162:
		YYDEBUG(162, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '<') goto yy272;
		goto yy86;
yy163:
		YYDEBUG(163, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy273;
		if (yych == 'e') goto yy273;
		goto yy48;
yy164:
		YYDEBUG(164, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych <= 'L') {
				if (yych <= 'K') goto yy48;
				goto yy274;
			} else {
				if (yych <= 'R') goto yy48;
				if (yych <= 'S') goto yy275;
				goto yy276;
			}
		} else {
			if (yych <= 'r') {
				if (yych == 'l') goto yy274;
				goto yy48;
			} else {
				if (yych <= 's') goto yy275;
				if (yych <= 't') goto yy276;
				goto yy48;
			}
		}
yy165:
		YYDEBUG(165, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych == 'A') goto yy277;
			if (yych <= 'N') goto yy48;
			goto yy278;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy48;
				goto yy277;
			} else {
				if (yych == 'o') goto yy278;
				goto yy48;
			}
		}
yy166:
		YYDEBUG(166, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy279;
		if (yych == 'n') goto yy279;
		goto yy48;
yy167:
		YYDEBUG(167, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'F') {
			if (yych == 'C') goto yy280;
			if (yych <= 'E') goto yy48;
			goto yy281;
		} else {
			if (yych <= 'c') {
				if (yych <= 'b') goto yy48;
				goto yy280;
			} else {
				if (yych == 'f') goto yy281;
				goto yy48;
			}
		}
yy168:
		YYDEBUG(168, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy282;
		if (yych == 'e') goto yy282;
		goto yy48;
yy169:
		YYDEBUG(169, *YYCURSOR);
		yyaccept = 9;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy170:
		YYDEBUG(170, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1443 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_DO);
}
#line 3618 "Zend/zend_language_scanner.c"
yy171:
		YYDEBUG(171, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy284;
		if (yych == 'h') goto yy284;
		goto yy48;
yy172:
		YYDEBUG(172, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy285;
		if (yych == 's') goto yy285;
		goto yy48;
yy173:
		YYDEBUG(173, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy286;
		if (yych == 'p') goto yy286;
		goto yy48;
yy174:
		YYDEBUG(174, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'U') {
			if (yych == 'D') goto yy287;
			if (yych <= 'T') goto yy48;
			goto yy288;
		} else {
			if (yych <= 'd') {
				if (yych <= 'c') goto yy48;
				goto yy287;
			} else {
				if (yych == 'u') goto yy288;
				goto yy48;
			}
		}
yy175:
		YYDEBUG(175, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy289;
		if (yych == 'a') goto yy289;
		goto yy48;
yy176:
		YYDEBUG(176, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych == 'I') goto yy290;
			if (yych <= 'S') goto yy48;
			goto yy291;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy48;
				goto yy290;
			} else {
				if (yych == 't') goto yy291;
				goto yy48;
			}
		}
yy177:
		YYDEBUG(177, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy292;
		if (yych == 'n') goto yy292;
		goto yy48;
yy178:
		YYDEBUG(178, *YYCURSOR);
		yyaccept = 10;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy179:
		YYDEBUG(179, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1372 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_FN);
}
#line 3703 "Zend/zend_language_scanner.c"
yy180:
		YYDEBUG(180, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy293;
		if (yych == 'r') goto yy293;
		goto yy48;
yy181:
		YYDEBUG(181, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy295;
		if (yych == 'n') goto yy295;
		goto yy48;
yy182:
		YYDEBUG(182, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy296;
		if (yych == 'o') goto yy296;
		goto yy48;
yy183:
		YYDEBUG(183, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy297;
		if (yych == 't') goto yy297;
		goto yy48;
yy184:
		YYDEBUG(184, *YYCURSOR);
		yyaccept = 11;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy185:
		YYDEBUG(185, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1419 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_IF);
}
#line 3747 "Zend/zend_language_scanner.c"
yy186:
		YYDEBUG(186, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy298;
		if (yych == 'p') goto yy298;
		goto yy48;
yy187:
		YYDEBUG(187, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych <= 'C') {
				if (yych <= 'B') goto yy48;
				goto yy299;
			} else {
				if (yych <= 'R') goto yy48;
				if (yych <= 'S') goto yy300;
				goto yy301;
			}
		} else {
			if (yych <= 'r') {
				if (yych == 'c') goto yy299;
				goto yy48;
			} else {
				if (yych <= 's') goto yy300;
				if (yych <= 't') goto yy301;
				goto yy48;
			}
		}
yy188:
		YYDEBUG(188, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy302;
		if (yych == 's') goto yy302;
		goto yy48;
yy189:
		YYDEBUG(189, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy303;
		if (yych == 's') goto yy303;
		goto yy48;
yy190:
		YYDEBUG(190, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy304;
		if (yych == 't') goto yy304;
		goto yy48;
yy191:
		YYDEBUG(191, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy305;
		if (yych == 'm') goto yy305;
		goto yy48;
yy192:
		YYDEBUG(192, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'W') goto yy306;
		if (yych == 'w') goto yy306;
		goto yy48;
yy193:
		YYDEBUG(193, *YYCURSOR);
		yyaccept = 12;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy194:
		YYDEBUG(194, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1847 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_LOGICAL_OR);
}
#line 3828 "Zend/zend_language_scanner.c"
yy195:
		YYDEBUG(195, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'O') {
			if (yych == 'I') goto yy308;
			if (yych <= 'N') goto yy48;
			goto yy309;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy48;
				goto yy308;
			} else {
				if (yych == 'o') goto yy309;
				goto yy48;
			}
		}
yy196:
		YYDEBUG(196, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'B') goto yy310;
		if (yych == 'b') goto yy310;
		goto yy48;
yy197:
		YYDEBUG(197, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych <= 'P') {
				if (yych == 'A') goto yy311;
				goto yy48;
			} else {
				if (yych <= 'Q') goto yy312;
				if (yych <= 'S') goto yy48;
				goto yy313;
			}
		} else {
			if (yych <= 'p') {
				if (yych == 'a') goto yy311;
				goto yy48;
			} else {
				if (yych <= 'q') goto yy312;
				if (yych == 't') goto yy313;
				goto yy48;
			}
		}
yy198:
		YYDEBUG(198, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy314;
		if (yych == 'a') goto yy314;
		goto yy48;
yy199:
		YYDEBUG(199, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy315;
		if (yych == 'i') goto yy315;
		goto yy48;
yy200:
		YYDEBUG(200, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy316;
		if (yych == 'r') goto yy316;
		goto yy48;
yy201:
		YYDEBUG(201, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'Y') {
			if (yych == 'A') goto yy317;
			if (yych <= 'X') goto yy48;
			goto yy318;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy48;
				goto yy317;
			} else {
				if (yych == 'y') goto yy318;
				goto yy48;
			}
		}
yy202:
		YYDEBUG(202, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy320;
		if (yych == 's') goto yy320;
		goto yy48;
yy203:
		YYDEBUG(203, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy321;
		if (yych == 'e') goto yy321;
		goto yy48;
yy204:
		YYDEBUG(204, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy323;
		if (yych == 'r') goto yy323;
		goto yy48;
yy205:
		YYDEBUG(205, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy325;
		if (yych == 'i') goto yy325;
		goto yy48;
yy206:
		YYDEBUG(206, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy326;
		if (yych == 'r') goto yy326;
		goto yy48;
yy207:
		YYDEBUG(207, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy328;
		if (yych == 'e') goto yy328;
		goto yy48;
yy208:
		YYDEBUG(208, *YYCURSOR);
		yyaccept = 13;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(209, *YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy210;
				if (yych <= '9') goto yy208;
			} else {
				if (yych <= 'Z') goto yy208;
				if (yych >= '\\') goto yy329;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy208;
			} else {
				if (yych <= 'z') goto yy208;
				if (yych >= 0x80) goto yy208;
			}
		}
yy210:
		YYDEBUG(210, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2360 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_STR(T_NAME_FULLY_QUALIFIED, 1);
}
#line 3986 "Zend/zend_language_scanner.c"
yy211:
		YYDEBUG(211, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(212, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1831 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_XOR_EQUAL);
}
#line 3996 "Zend/zend_language_scanner.c"
yy213:
		YYDEBUG(213, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		switch (yych) {
		case 'C':
		case 'c':	goto yy330;
		case 'D':
		case 'd':	goto yy331;
		case 'F':
		case 'f':	goto yy332;
		case 'H':
		case 'h':	goto yy333;
		case 'L':
		case 'l':	goto yy334;
		case 'M':
		case 'm':	goto yy335;
		case 'N':
		case 'n':	goto yy336;
		case 'T':
		case 't':	goto yy337;
		default:	goto yy48;
		}
yy214:
		YYDEBUG(214, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(215, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1827 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_OR_EQUAL);
}
#line 4029 "Zend/zend_language_scanner.c"
yy216:
		YYDEBUG(216, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(217, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1839 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_BOOLEAN_OR);
}
#line 4039 "Zend/zend_language_scanner.c"
yy218:
		YYDEBUG(218, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(219, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1759 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_IS_NOT_IDENTICAL);
}
#line 4049 "Zend/zend_language_scanner.c"
yy220:
		YYDEBUG(220, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '.') goto yy87;
		goto yy86;
yy221:
		YYDEBUG(221, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy338;
		if (yych == 'r') goto yy338;
		goto yy86;
yy222:
		YYDEBUG(222, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy339;
		if (yych == 'n') goto yy339;
		goto yy86;
yy223:
		YYDEBUG(223, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy340;
		if (yych == 'o') goto yy340;
		goto yy86;
yy224:
		YYDEBUG(224, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'U') goto yy341;
		if (yych == 'u') goto yy341;
		goto yy86;
yy225:
		YYDEBUG(225, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy342;
		if (yych == 'o') goto yy342;
		goto yy86;
yy226:
		YYDEBUG(226, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy343;
		if (yych == 't') goto yy343;
		goto yy86;
yy227:
		YYDEBUG(227, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'J') goto yy344;
		if (yych == 'j') goto yy344;
		goto yy86;
yy228:
		YYDEBUG(228, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy345;
		if (yych == 'a') goto yy345;
		goto yy86;
yy229:
		YYDEBUG(229, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy346;
		if (yych == 'r') goto yy346;
		goto yy86;
yy230:
		YYDEBUG(230, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy347;
		if (yych == 's') goto yy347;
		goto yy86;
yy231:
		YYDEBUG(231, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(232, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1799 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_POW_EQUAL);
}
#line 4124 "Zend/zend_language_scanner.c"
yy233:
		YYDEBUG(233, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(234, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1589 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_ELLIPSIS);
}
#line 4134 "Zend/zend_language_scanner.c"
yy235:
		YYDEBUG(235, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy86;
		if (yych <= '9') goto yy120;
		goto yy86;
yy236:
		YYDEBUG(236, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '\f') {
			if (yych <= 0x08) goto yy86;
			if (yych <= '\n') goto yy348;
			goto yy86;
		} else {
			if (yych <= '\r') goto yy348;
			if (yych == ' ') goto yy348;
			goto yy86;
		}
yy237:
		YYDEBUG(237, *YYCURSOR);
		yyaccept = 14;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(238, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy237;
		}
		if (yych == '_') goto yy131;
yy239:
		YYDEBUG(239, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1928 "Zend/zend_language_scanner.l"
		{
	/* The +/- 2 skips "0b" */
	size_t len = yyleng - 2;
	char *end, *bin = yytext + 2;
	bool contains_underscores;

	/* Skip any leading 0s */
	while (len > 0 && (*bin == '0' || *bin == '_')) {
		++bin;
		--len;
	}

	contains_underscores = (memchr(bin, '_', len) != NULL);

	if (contains_underscores) {
		bin = estrndup(bin, len);
		strip_underscores(bin, &len);
	}

	if (len < SIZEOF_ZEND_LONG * 8) {
		if (len == 0) {
			ZVAL_LONG(zendlval, 0);
		} else {
			errno = 0;
			ZVAL_LONG(zendlval, ZEND_STRTOL(bin, &end, 2));
			ZEND_ASSERT(!errno && end == bin + len);
		}
		if (contains_underscores) {
			efree(bin);
		}
		RETURN_TOKEN_WITH_VAL(T_LNUMBER);
	} else {
		ZVAL_DOUBLE(zendlval, zend_bin_strtod(bin, (const char **)&end));
		/* errno isn't checked since we allow HUGE_VAL/INF overflow */
		ZEND_ASSERT(end == bin + len);
		if (contains_underscores) {
			efree(bin);
		}
		RETURN_TOKEN_WITH_VAL(T_DNUMBER);
	}
}
#line 4211 "Zend/zend_language_scanner.c"
yy240:
		YYDEBUG(240, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy86;
		if (yych >= ':') goto yy86;
yy241:
		YYDEBUG(241, *YYCURSOR);
		yyaccept = 5;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(242, *YYCURSOR);
		if (yych <= '/') goto yy122;
		if (yych <= '9') goto yy241;
		if (yych == '_') goto yy240;
		goto yy122;
yy243:
		YYDEBUG(243, *YYCURSOR);
		yyaccept = 15;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(244, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy243;
		}
		if (yych == '_') goto yy133;
yy245:
		YYDEBUG(245, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1970 "Zend/zend_language_scanner.l"
		{
	/* The +/- 2 skips "0o" */
	size_t len = yyleng - 2;
	char *end, *octal = yytext + 2;
	bool contains_underscores = (memchr(octal, '_', len) != NULL);

	/* Skip any leading 0s */
	while (len > 0 && (*octal == '0' || *octal == '_')) {
		++octal;
		--len;
	}

	if (len == 0) {
		ZVAL_LONG(zendlval, 0);
		RETURN_TOKEN_WITH_VAL(T_LNUMBER);
	}

	if (contains_underscores) {
		octal = estrndup(octal, len);
		strip_underscores(octal, &len);
	}

	errno = 0;

	ZVAL_LONG(zendlval, ZEND_STRTOL(octal, &end, 8));

	ZEND_ASSERT(end == octal + len);

	if (!errno) {
		if (contains_underscores) {
			efree(octal);
		}
		RETURN_TOKEN_WITH_VAL(T_LNUMBER);
	}

	/* Overflow */
	ZEND_ASSERT(errno == ERANGE);
	/* Reset errno */
	errno = 0;

	/* zend_oct_strtod skips leading '0' */
	ZVAL_DOUBLE(zendlval, zend_oct_strtod(octal, (const char **)&end));
	ZEND_ASSERT(!errno);
	ZEND_ASSERT(end == octal + len);
	if (contains_underscores) {
		efree(octal);
	}
	RETURN_TOKEN_WITH_VAL(T_DNUMBER);
}
#line 4294 "Zend/zend_language_scanner.c"
yy246:
		YYDEBUG(246, *YYCURSOR);
		yyaccept = 16;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(247, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy246;
		}
		if (yych == '_') goto yy134;
yy248:
		YYDEBUG(248, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2083 "Zend/zend_language_scanner.l"
		{
	/* The +/- 2 skips "0x" */
	size_t len = yyleng - 2;
	char *end, *hex = yytext + 2;
	bool contains_underscores;

	/* Skip any leading 0s */
	while (len > 0 && (*hex == '0' || *hex == '_')) {
		++hex;
		--len;
	}

	contains_underscores = (memchr(hex, '_', len) != NULL);

	if (contains_underscores) {
		hex = estrndup(hex, len);
		strip_underscores(hex, &len);
	}

	if (len < SIZEOF_ZEND_LONG * 2 || (len == SIZEOF_ZEND_LONG * 2 && *hex <= '7')) {
		if (len == 0) {
			ZVAL_LONG(zendlval, 0);
		} else {
			errno = 0;
			ZVAL_LONG(zendlval, ZEND_STRTOL(hex, &end, 16));
			ZEND_ASSERT(!errno && end == hex + len);
		}
		if (contains_underscores) {
			efree(hex);
		}
		RETURN_TOKEN_WITH_VAL(T_LNUMBER);
	} else {
		ZVAL_DOUBLE(zendlval, zend_hex_strtod(hex, (const char **)&end));
		/* errno isn't checked since we allow HUGE_VAL/INF overflow */
		ZEND_ASSERT(end == hex + len);
		if (contains_underscores) {
			efree(hex);
		}
		RETURN_TOKEN_WITH_VAL(T_DNUMBER);
	}
}
#line 4351 "Zend/zend_language_scanner.c"
yy249:
		YYDEBUG(249, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(250, *YYCURSOR);
		if (yych <= '\'') {
			if (yych <= ' ') {
				if (yych == '\t') goto yy249;
				if (yych <= 0x1F) goto yy86;
				goto yy249;
			} else {
				if (yych == '"') goto yy350;
				if (yych <= '&') goto yy86;
				goto yy351;
			}
		} else {
			if (yych <= '_') {
				if (yych <= '@') goto yy86;
				if (yych <= 'Z') goto yy352;
				if (yych <= '^') goto yy86;
				goto yy352;
			} else {
				if (yych <= '`') goto yy86;
				if (yych <= 'z') goto yy352;
				if (yych <= 0x7F) goto yy86;
				goto yy352;
			}
		}
yy251:
		YYDEBUG(251, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(252, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1815 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_SL_EQUAL);
}
#line 4390 "Zend/zend_language_scanner.c"
yy253:
		YYDEBUG(253, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(254, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1771 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_SPACESHIP);
}
#line 4400 "Zend/zend_language_scanner.c"
yy255:
		YYDEBUG(255, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(256, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1755 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_IS_IDENTICAL);
}
#line 4410 "Zend/zend_language_scanner.c"
yy257:
		YYDEBUG(257, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(258, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1819 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_SR_EQUAL);
}
#line 4420 "Zend/zend_language_scanner.c"
yy259:
		YYDEBUG(259, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(260, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1557 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN(T_NULLSAFE_OBJECT_OPERATOR);
}
#line 4431 "Zend/zend_language_scanner.c"
yy261:
		YYDEBUG(261, *YYCURSOR);
		++YYCURSOR;
		goto yy153;
yy262:
		YYDEBUG(262, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy261;
		goto yy153;
yy263:
		YYDEBUG(263, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(264, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1835 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_COALESCE_EQUAL);
}
#line 4450 "Zend/zend_language_scanner.c"
yy265:
		YYDEBUG(265, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy354;
		if (yych == 't') goto yy354;
		goto yy48;
yy266:
		YYDEBUG(266, *YYCURSOR);
		yyaccept = 17;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy267:
		YYDEBUG(267, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1851 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_LOGICAL_AND);
}
#line 4473 "Zend/zend_language_scanner.c"
yy268:
		YYDEBUG(268, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy355;
		if (yych == 'a') goto yy355;
		goto yy48;
yy269:
		YYDEBUG(269, *YYCURSOR);
		yyaccept = 18;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(270, *YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy271;
				if (yych <= '9') goto yy269;
			} else {
				if (yych <= 'Z') goto yy269;
				if (yych >= '\\') goto yy161;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy269;
			} else {
				if (yych <= 'z') goto yy269;
				if (yych >= 0x80) goto yy269;
			}
		}
yy271:
		YYDEBUG(271, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2356 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_STR(T_NAME_QUALIFIED, 0);
}
#line 4511 "Zend/zend_language_scanner.c"
yy272:
		YYDEBUG(272, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '<') goto yy249;
		goto yy86;
yy273:
		YYDEBUG(273, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy356;
		if (yych == 'a') goto yy356;
		goto yy48;
yy274:
		YYDEBUG(274, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy357;
		if (yych == 'l') goto yy357;
		goto yy48;
yy275:
		YYDEBUG(275, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy358;
		if (yych == 'e') goto yy358;
		goto yy48;
yy276:
		YYDEBUG(276, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy360;
		if (yych == 'c') goto yy360;
		goto yy48;
yy277:
		YYDEBUG(277, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy361;
		if (yych == 's') goto yy361;
		goto yy48;
yy278:
		YYDEBUG(278, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy362;
		if (yych == 'n') goto yy362;
		goto yy48;
yy279:
		YYDEBUG(279, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'T') {
			if (yych <= 'R') goto yy48;
			if (yych <= 'S') goto yy363;
			goto yy364;
		} else {
			if (yych <= 'r') goto yy48;
			if (yych <= 's') goto yy363;
			if (yych <= 't') goto yy364;
			goto yy48;
		}
yy280:
		YYDEBUG(280, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy365;
		if (yych == 'l') goto yy365;
		goto yy48;
yy281:
		YYDEBUG(281, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy366;
		if (yych == 'a') goto yy366;
		goto yy48;
yy282:
		YYDEBUG(282, *YYCURSOR);
		yyaccept = 19;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy283:
		YYDEBUG(283, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1368 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_EXIT);
}
#line 4602 "Zend/zend_language_scanner.c"
yy284:
		YYDEBUG(284, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy367;
		if (yych == 'o') goto yy367;
		goto yy48;
yy285:
		YYDEBUG(285, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy369;
		if (yych == 'e') goto yy369;
		goto yy48;
yy286:
		YYDEBUG(286, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy371;
		if (yych == 't') goto yy371;
		goto yy48;
yy287:
		YYDEBUG(287, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		switch (yych) {
		case 'D':
		case 'd':	goto yy372;
		case 'F':
		case 'f':	goto yy373;
		case 'I':
		case 'i':	goto yy374;
		case 'S':
		case 's':	goto yy375;
		case 'W':
		case 'w':	goto yy376;
		default:	goto yy48;
		}
yy288:
		YYDEBUG(288, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy377;
		if (yych == 'm') goto yy377;
		goto yy48;
yy289:
		YYDEBUG(289, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy378;
		if (yych == 'l') goto yy378;
		goto yy48;
yy290:
		YYDEBUG(290, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy380;
		if (yych == 't') goto yy380;
		goto yy48;
yy291:
		YYDEBUG(291, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy382;
		if (yych == 'e') goto yy382;
		goto yy48;
yy292:
		YYDEBUG(292, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy383;
		if (yych == 'a') goto yy383;
		goto yy48;
yy293:
		YYDEBUG(293, *YYCURSOR);
		yyaccept = 20;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= 'D') {
				if (yych <= '/') goto yy294;
				if (yych <= '9') goto yy47;
				if (yych >= 'A') goto yy47;
			} else {
				if (yych <= 'E') goto yy384;
				if (yych <= 'Z') goto yy47;
				if (yych >= '\\') goto yy161;
			}
		} else {
			if (yych <= 'd') {
				if (yych == '_') goto yy47;
				if (yych >= 'a') goto yy47;
			} else {
				if (yych <= 'e') goto yy384;
				if (yych <= 'z') goto yy47;
				if (yych >= 0x80) goto yy47;
			}
		}
yy294:
		YYDEBUG(294, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1447 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_FOR);
}
#line 4707 "Zend/zend_language_scanner.c"
yy295:
		YYDEBUG(295, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy385;
		if (yych == 'c') goto yy385;
		goto yy48;
yy296:
		YYDEBUG(296, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'B') goto yy386;
		if (yych == 'b') goto yy386;
		goto yy48;
yy297:
		YYDEBUG(297, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy387;
		if (yych == 'o') goto yy387;
		goto yy48;
yy298:
		YYDEBUG(298, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy389;
		if (yych == 'l') goto yy389;
		goto yy48;
yy299:
		YYDEBUG(299, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy390;
		if (yych == 'l') goto yy390;
		goto yy48;
yy300:
		YYDEBUG(300, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy391;
		if (yych == 't') goto yy391;
		goto yy48;
yy301:
		YYDEBUG(301, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy392;
		if (yych == 'e') goto yy392;
		goto yy48;
yy302:
		YYDEBUG(302, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy393;
		if (yych == 'e') goto yy393;
		goto yy48;
yy303:
		YYDEBUG(303, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy394;
		if (yych == 't') goto yy394;
		goto yy48;
yy304:
		YYDEBUG(304, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy396;
		if (yych == 'c') goto yy396;
		goto yy48;
yy305:
		YYDEBUG(305, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy397;
		if (yych == 'e') goto yy397;
		goto yy48;
yy306:
		YYDEBUG(306, *YYCURSOR);
		yyaccept = 21;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy307:
		YYDEBUG(307, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1597 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_NEW);
}
#line 4800 "Zend/zend_language_scanner.c"
yy308:
		YYDEBUG(308, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'V') {
			if (yych == 'N') goto yy398;
			if (yych <= 'U') goto yy48;
			goto yy399;
		} else {
			if (yych <= 'n') {
				if (yych <= 'm') goto yy48;
				goto yy398;
			} else {
				if (yych == 'v') goto yy399;
				goto yy48;
			}
		}
yy309:
		YYDEBUG(309, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy400;
		if (yych == 't') goto yy400;
		goto yy48;
yy310:
		YYDEBUG(310, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy401;
		if (yych == 'l') goto yy401;
		goto yy48;
yy311:
		YYDEBUG(311, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy402;
		if (yych == 'd') goto yy402;
		goto yy48;
yy312:
		YYDEBUG(312, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy403;
		if (yych == 'u') goto yy403;
		goto yy48;
yy313:
		YYDEBUG(313, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy404;
		if (yych == 'u') goto yy404;
		goto yy48;
yy314:
		YYDEBUG(314, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy405;
		if (yych == 't') goto yy405;
		goto yy48;
yy315:
		YYDEBUG(315, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy406;
		if (yych == 't') goto yy406;
		goto yy48;
yy316:
		YYDEBUG(316, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy407;
		if (yych == 'o') goto yy407;
		goto yy48;
yy317:
		YYDEBUG(317, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy408;
		if (yych == 'i') goto yy408;
		goto yy48;
yy318:
		YYDEBUG(318, *YYCURSOR);
		yyaccept = 22;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy319:
		YYDEBUG(319, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1403 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_TRY);
}
#line 4896 "Zend/zend_language_scanner.c"
yy320:
		YYDEBUG(320, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy409;
		if (yych == 'e') goto yy409;
		goto yy48;
yy321:
		YYDEBUG(321, *YYCURSOR);
		yyaccept = 23;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy322:
		YYDEBUG(322, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1669 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_USE);
}
#line 4919 "Zend/zend_language_scanner.c"
yy323:
		YYDEBUG(323, *YYCURSOR);
		yyaccept = 24;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy324:
		YYDEBUG(324, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1605 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_VAR);
}
#line 4935 "Zend/zend_language_scanner.c"
yy325:
		YYDEBUG(325, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy410;
		if (yych == 'l') goto yy410;
		goto yy48;
yy326:
		YYDEBUG(326, *YYCURSOR);
		yyaccept = 25;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy327:
		YYDEBUG(327, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1855 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_LOGICAL_XOR);
}
#line 4958 "Zend/zend_language_scanner.c"
yy328:
		YYDEBUG(328, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy411;
		if (yych == 'l') goto yy411;
		goto yy48;
yy329:
		YYDEBUG(329, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy86;
			if (yych <= 'Z') goto yy208;
			if (yych <= '^') goto yy86;
			goto yy208;
		} else {
			if (yych <= '`') goto yy86;
			if (yych <= 'z') goto yy208;
			if (yych <= 0x7F) goto yy86;
			goto yy208;
		}
yy330:
		YYDEBUG(330, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy412;
		if (yych == 'l') goto yy412;
		goto yy48;
yy331:
		YYDEBUG(331, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy413;
		if (yych == 'i') goto yy413;
		goto yy48;
yy332:
		YYDEBUG(332, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'U') {
			if (yych == 'I') goto yy414;
			if (yych <= 'T') goto yy48;
			goto yy415;
		} else {
			if (yych <= 'i') {
				if (yych <= 'h') goto yy48;
				goto yy414;
			} else {
				if (yych == 'u') goto yy415;
				goto yy48;
			}
		}
yy333:
		YYDEBUG(333, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy416;
		if (yych == 'a') goto yy416;
		goto yy48;
yy334:
		YYDEBUG(334, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy417;
		if (yych == 'i') goto yy417;
		goto yy48;
yy335:
		YYDEBUG(335, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy418;
		if (yych == 'e') goto yy418;
		goto yy48;
yy336:
		YYDEBUG(336, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy419;
		if (yych == 'a') goto yy419;
		goto yy48;
yy337:
		YYDEBUG(337, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy420;
		if (yych == 'r') goto yy420;
		goto yy48;
yy338:
		YYDEBUG(338, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy421;
		if (yych == 'a') goto yy421;
		goto yy86;
yy339:
		YYDEBUG(339, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy422;
		if (yych == 'a') goto yy422;
		goto yy86;
yy340:
		YYDEBUG(340, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy423;
		if (yych == 'l') goto yy423;
		goto yy86;
yy341:
		YYDEBUG(341, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'B') goto yy424;
		if (yych == 'b') goto yy424;
		goto yy86;
yy342:
		YYDEBUG(342, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy425;
		if (yych == 'a') goto yy425;
		goto yy86;
yy343:
		YYDEBUG(343, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy430;
		if (yych == 'e') goto yy430;
		goto yy427;
yy344:
		YYDEBUG(344, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy431;
		if (yych == 'e') goto yy431;
		goto yy86;
yy345:
		YYDEBUG(345, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy432;
		if (yych == 'l') goto yy432;
		goto yy86;
yy346:
		YYDEBUG(346, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'I') goto yy434;
		if (yych == 'i') goto yy434;
		goto yy86;
yy347:
		YYDEBUG(347, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy435;
		if (yych == 'e') goto yy435;
		goto yy86;
yy348:
		YYDEBUG(348, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(349, *YYCURSOR);
		if (yych <= '\f') {
			if (yych <= 0x08) goto yy126;
			if (yych <= '\n') goto yy348;
			goto yy126;
		} else {
			if (yych <= '\r') goto yy348;
			if (yych == ' ') goto yy348;
			goto yy126;
		}
yy350:
		YYDEBUG(350, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '"') goto yy86;
		if (yych <= '/') goto yy437;
		if (yych <= '9') goto yy86;
		goto yy437;
yy351:
		YYDEBUG(351, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\'') goto yy86;
		if (yych <= '/') goto yy439;
		if (yych <= '9') goto yy86;
		goto yy439;
yy352:
		YYDEBUG(352, *YYCURSOR);
		++YYCURSOR;
		YYFILL(2);
		yych = *YYCURSOR;
		YYDEBUG(353, *YYCURSOR);
		if (yych <= '@') {
			if (yych <= '\f') {
				if (yych == '\n') goto yy440;
				goto yy86;
			} else {
				if (yych <= '\r') goto yy442;
				if (yych <= '/') goto yy86;
				if (yych <= '9') goto yy352;
				goto yy86;
			}
		} else {
			if (yych <= '_') {
				if (yych <= 'Z') goto yy352;
				if (yych <= '^') goto yy86;
				goto yy352;
			} else {
				if (yych <= '`') goto yy86;
				if (yych <= 'z') goto yy352;
				if (yych <= 0x7F) goto yy86;
				goto yy352;
			}
		}
yy354:
		YYDEBUG(354, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy443;
		if (yych == 'r') goto yy443;
		goto yy48;
yy355:
		YYDEBUG(355, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'Y') goto yy444;
		if (yych == 'y') goto yy444;
		goto yy48;
yy356:
		YYDEBUG(356, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'K') goto yy446;
		if (yych == 'k') goto yy446;
		goto yy48;
yy357:
		YYDEBUG(357, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy448;
		if (yych == 'a') goto yy448;
		goto yy48;
yy358:
		YYDEBUG(358, *YYCURSOR);
		yyaccept = 26;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy359:
		YYDEBUG(359, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1491 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_CASE);
}
#line 5208 "Zend/zend_language_scanner.c"
yy360:
		YYDEBUG(360, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy449;
		if (yych == 'h') goto yy449;
		goto yy48;
yy361:
		YYDEBUG(361, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy451;
		if (yych == 's') goto yy451;
		goto yy48;
yy362:
		YYDEBUG(362, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy453;
		if (yych == 'e') goto yy453;
		goto yy48;
yy363:
		YYDEBUG(363, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy455;
		if (yych == 't') goto yy455;
		goto yy48;
yy364:
		YYDEBUG(364, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy457;
		if (yych == 'i') goto yy457;
		goto yy48;
yy365:
		YYDEBUG(365, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy458;
		if (yych == 'a') goto yy458;
		goto yy48;
yy366:
		YYDEBUG(366, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy459;
		if (yych == 'u') goto yy459;
		goto yy48;
yy367:
		YYDEBUG(367, *YYCURSOR);
		yyaccept = 27;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy368:
		YYDEBUG(368, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1511 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_ECHO);
}
#line 5273 "Zend/zend_language_scanner.c"
yy369:
		YYDEBUG(369, *YYCURSOR);
		yyaccept = 28;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= 'H') {
				if (yych <= '/') goto yy370;
				if (yych <= '9') goto yy47;
				if (yych >= 'A') goto yy47;
			} else {
				if (yych <= 'I') goto yy460;
				if (yych <= 'Z') goto yy47;
				if (yych >= '\\') goto yy161;
			}
		} else {
			if (yych <= 'h') {
				if (yych == '_') goto yy47;
				if (yych >= 'a') goto yy47;
			} else {
				if (yych <= 'i') goto yy460;
				if (yych <= 'z') goto yy47;
				if (yych >= 0x80) goto yy47;
			}
		}
yy370:
		YYDEBUG(370, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1431 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_ELSE);
}
#line 5305 "Zend/zend_language_scanner.c"
yy371:
		YYDEBUG(371, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'Y') goto yy461;
		if (yych == 'y') goto yy461;
		goto yy48;
yy372:
		YYDEBUG(372, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy463;
		if (yych == 'e') goto yy463;
		goto yy48;
yy373:
		YYDEBUG(373, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy464;
		if (yych == 'o') goto yy464;
		goto yy48;
yy374:
		YYDEBUG(374, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy465;
		if (yych == 'f') goto yy465;
		goto yy48;
yy375:
		YYDEBUG(375, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'W') goto yy467;
		if (yych == 'w') goto yy467;
		goto yy48;
yy376:
		YYDEBUG(376, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy468;
		if (yych == 'h') goto yy468;
		goto yy48;
yy377:
		YYDEBUG(377, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\f') {
			if (yych <= 0x08) goto yy48;
			if (yych <= '\n') goto yy469;
			goto yy48;
		} else {
			if (yych <= '\r') goto yy469;
			if (yych == ' ') goto yy469;
			goto yy48;
		}
yy378:
		YYDEBUG(378, *YYCURSOR);
		yyaccept = 29;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy379:
		YYDEBUG(379, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1645 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_EVAL);
}
#line 5376 "Zend/zend_language_scanner.c"
yy380:
		YYDEBUG(380, *YYCURSOR);
		yyaccept = 30;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy381:
		YYDEBUG(381, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1364 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_EXIT);
}
#line 5392 "Zend/zend_language_scanner.c"
yy382:
		YYDEBUG(382, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy471;
		if (yych == 'n') goto yy471;
		goto yy48;
yy383:
		YYDEBUG(383, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy472;
		if (yych == 'l') goto yy472;
		goto yy48;
yy384:
		YYDEBUG(384, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy474;
		if (yych == 'a') goto yy474;
		goto yy48;
yy385:
		YYDEBUG(385, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy475;
		if (yych == 't') goto yy475;
		goto yy48;
yy386:
		YYDEBUG(386, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy476;
		if (yych == 'a') goto yy476;
		goto yy48;
yy387:
		YYDEBUG(387, *YYCURSOR);
		yyaccept = 31;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy388:
		YYDEBUG(388, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1507 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_GOTO);
}
#line 5443 "Zend/zend_language_scanner.c"
yy389:
		YYDEBUG(389, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy477;
		if (yych == 'e') goto yy477;
		goto yy48;
yy390:
		YYDEBUG(390, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy478;
		if (yych == 'u') goto yy478;
		goto yy48;
yy391:
		YYDEBUG(391, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'E') {
			if (yych == 'A') goto yy479;
			if (yych <= 'D') goto yy48;
			goto yy480;
		} else {
			if (yych <= 'a') {
				if (yych <= '`') goto yy48;
				goto yy479;
			} else {
				if (yych == 'e') goto yy480;
				goto yy48;
			}
		}
yy392:
		YYDEBUG(392, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy481;
		if (yych == 'r') goto yy481;
		goto yy48;
yy393:
		YYDEBUG(393, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy482;
		if (yych == 't') goto yy482;
		goto yy48;
yy394:
		YYDEBUG(394, *YYCURSOR);
		yyaccept = 32;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy395:
		YYDEBUG(395, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1735 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_LIST);
}
#line 5504 "Zend/zend_language_scanner.c"
yy396:
		YYDEBUG(396, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy484;
		if (yych == 'h') goto yy484;
		goto yy48;
yy397:
		YYDEBUG(397, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy486;
		if (yych == 's') goto yy486;
		goto yy48;
yy398:
		YYDEBUG(398, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy487;
		if (yych == 't') goto yy487;
		goto yy48;
yy399:
		YYDEBUG(399, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy489;
		if (yych == 'a') goto yy489;
		goto yy48;
yy400:
		YYDEBUG(400, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy490;
		if (yych == 'e') goto yy490;
		goto yy48;
yy401:
		YYDEBUG(401, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy491;
		if (yych == 'i') goto yy491;
		goto yy48;
yy402:
		YYDEBUG(402, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy492;
		if (yych == 'o') goto yy492;
		goto yy48;
yy403:
		YYDEBUG(403, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy493;
		if (yych == 'i') goto yy493;
		goto yy48;
yy404:
		YYDEBUG(404, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy494;
		if (yych == 'r') goto yy494;
		goto yy48;
yy405:
		YYDEBUG(405, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy495;
		if (yych == 'i') goto yy495;
		goto yy48;
yy406:
		YYDEBUG(406, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy496;
		if (yych == 'c') goto yy496;
		goto yy48;
yy407:
		YYDEBUG(407, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'W') goto yy497;
		if (yych == 'w') goto yy497;
		goto yy48;
yy408:
		YYDEBUG(408, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy499;
		if (yych == 't') goto yy499;
		goto yy48;
yy409:
		YYDEBUG(409, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy501;
		if (yych == 't') goto yy501;
		goto yy48;
yy410:
		YYDEBUG(410, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy503;
		if (yych == 'e') goto yy503;
		goto yy48;
yy411:
		YYDEBUG(411, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy505;
		if (yych == 'd') goto yy505;
		goto yy48;
yy412:
		YYDEBUG(412, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy507;
		if (yych == 'a') goto yy507;
		goto yy48;
yy413:
		YYDEBUG(413, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy508;
		if (yych == 'r') goto yy508;
		goto yy48;
yy414:
		YYDEBUG(414, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy509;
		if (yych == 'l') goto yy509;
		goto yy48;
yy415:
		YYDEBUG(415, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy510;
		if (yych == 'n') goto yy510;
		goto yy48;
yy416:
		YYDEBUG(416, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy511;
		if (yych == 'l') goto yy511;
		goto yy48;
yy417:
		YYDEBUG(417, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy512;
		if (yych == 'n') goto yy512;
		goto yy48;
yy418:
		YYDEBUG(418, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy513;
		if (yych == 't') goto yy513;
		goto yy48;
yy419:
		YYDEBUG(419, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy514;
		if (yych == 'm') goto yy514;
		goto yy48;
yy420:
		YYDEBUG(420, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy515;
		if (yych == 'a') goto yy515;
		goto yy48;
yy421:
		YYDEBUG(421, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy516;
		if (yych == 'y') goto yy516;
		goto yy86;
yy422:
		YYDEBUG(422, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy518;
		if (yych == 'r') goto yy518;
		goto yy86;
yy423:
		YYDEBUG(423, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy523;
		if (yych == 'e') goto yy523;
		goto yy520;
yy424:
		YYDEBUG(424, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy524;
		if (yych == 'l') goto yy524;
		goto yy86;
yy425:
		YYDEBUG(425, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy525;
		if (yych == 't') goto yy525;
		goto yy86;
yy426:
		YYDEBUG(426, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy427:
		YYDEBUG(427, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy426;
			goto yy86;
		} else {
			if (yych <= ' ') goto yy426;
			if (yych != ')') goto yy86;
		}
		YYDEBUG(428, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(429, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1609 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_INT_CAST);
}
#line 5732 "Zend/zend_language_scanner.c"
yy430:
		YYDEBUG(430, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy527;
		if (yych == 'g') goto yy527;
		goto yy86;
yy431:
		YYDEBUG(431, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'C') goto yy528;
		if (yych == 'c') goto yy528;
		goto yy86;
yy432:
		YYDEBUG(432, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(433, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy432;
			goto yy86;
		} else {
			if (yych <= ' ') goto yy432;
			if (yych == ')') goto yy529;
			goto yy86;
		}
yy434:
		YYDEBUG(434, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy531;
		if (yych == 'n') goto yy531;
		goto yy86;
yy435:
		YYDEBUG(435, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy532;
		if (yych == 't') goto yy532;
		goto yy86;
yy436:
		YYDEBUG(436, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy437:
		YYDEBUG(437, *YYCURSOR);
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych == '"') goto yy534;
				goto yy86;
			} else {
				if (yych <= '9') goto yy436;
				if (yych <= '@') goto yy86;
				goto yy436;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy436;
				goto yy86;
			} else {
				if (yych <= 'z') goto yy436;
				if (yych <= 0x7F) goto yy86;
				goto yy436;
			}
		}
yy438:
		YYDEBUG(438, *YYCURSOR);
		++YYCURSOR;
		YYFILL(3);
		yych = *YYCURSOR;
yy439:
		YYDEBUG(439, *YYCURSOR);
		if (yych <= 'Z') {
			if (yych <= '/') {
				if (yych == '\'') goto yy534;
				goto yy86;
			} else {
				if (yych <= '9') goto yy438;
				if (yych <= '@') goto yy86;
				goto yy438;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy438;
				goto yy86;
			} else {
				if (yych <= 'z') goto yy438;
				if (yych <= 0x7F) goto yy86;
				goto yy438;
			}
		}
yy440:
		YYDEBUG(440, *YYCURSOR);
		++YYCURSOR;
yy441:
		YYDEBUG(441, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2587 "Zend/zend_language_scanner.l"
		{
	char *s;
	unsigned char *saved_cursor;
	int bprefix = (yytext[0] != '<') ? 1 : 0, spacing = 0, indentation = 0;
	zend_heredoc_label *heredoc_label = emalloc(sizeof(zend_heredoc_label));
	bool is_heredoc = 1;

	CG(zend_lineno)++;
	heredoc_label->length = yyleng-bprefix-3-1-(yytext[yyleng-2]=='\r'?1:0);
	s = yytext+bprefix+3;
	while ((*s == ' ') || (*s == '\t')) {
		s++;
		heredoc_label->length--;
	}

	if (*s == '\'') {
		s++;
		heredoc_label->length -= 2;
		is_heredoc = 0;

		BEGIN(ST_NOWDOC);
	} else {
		if (*s == '"') {
			s++;
			heredoc_label->length -= 2;
		}

		BEGIN(ST_HEREDOC);
	}

	heredoc_label->label = estrndup(s, heredoc_label->length);
	heredoc_label->indentation_uses_spaces = 0;
	heredoc_label->indentation = 0;
	saved_cursor = YYCURSOR;

	zend_ptr_stack_push(&SCNG(heredoc_label_stack), (void *) heredoc_label);

	while (YYCURSOR < YYLIMIT && (*YYCURSOR == ' ' || *YYCURSOR == '\t')) {
		if (*YYCURSOR == '\t') {
			spacing |= HEREDOC_USING_TABS;
		} else {
			spacing |= HEREDOC_USING_SPACES;
		}
		++YYCURSOR;
		++indentation;
	}

	if (YYCURSOR == YYLIMIT) {
		YYCURSOR = saved_cursor;
		RETURN_TOKEN(T_START_HEREDOC);
	}

	/* Check for ending label on the next line */
	if (heredoc_label->length < YYLIMIT - YYCURSOR && !memcmp(YYCURSOR, s, heredoc_label->length)) {
		if (!IS_LABEL_SUCCESSOR(YYCURSOR[heredoc_label->length])) {
			if (spacing == (HEREDOC_USING_SPACES | HEREDOC_USING_TABS)) {
				zend_throw_exception(zend_ce_parse_error, "Invalid indentation - tabs and spaces cannot be mixed", 0);
				if (PARSER_MODE()) {
					RETURN_TOKEN(T_ERROR);
				}
			}

			YYCURSOR = saved_cursor;
			heredoc_label->indentation = indentation;

			BEGIN(ST_END_HEREDOC);
			RETURN_TOKEN(T_START_HEREDOC);
		}
	}

	YYCURSOR = saved_cursor;

	if (is_heredoc && !SCNG(heredoc_scan_ahead)) {
		zend_lex_state current_state;
		zend_string *saved_doc_comment = CG(doc_comment);
		int heredoc_nesting_level = 1;
		int first_token = 0;
		int error = 0;

		zend_save_lexical_state(&current_state);

		SCNG(heredoc_scan_ahead) = 1;
		SCNG(heredoc_indentation) = 0;
		SCNG(heredoc_indentation_uses_spaces) = 0;
		LANG_SCNG(on_event) = NULL;
		CG(doc_comment) = NULL;

		zend_ptr_stack_reverse_apply(&current_state.heredoc_label_stack, copy_heredoc_label_stack);

		zend_exception_save();
		while (heredoc_nesting_level) {
			zval zv;
			int retval;

			ZVAL_UNDEF(&zv);
			retval = lex_scan(&zv, NULL);
			zval_ptr_dtor_nogc(&zv);

			if (EG(exception)) {
				zend_clear_exception();
				break;
			}

			if (!first_token) {
				first_token = retval;
			}

			switch (retval) {
				case T_START_HEREDOC:
					++heredoc_nesting_level;
					break;
				case T_END_HEREDOC:
					--heredoc_nesting_level;
					break;
				case END:
					heredoc_nesting_level = 0;
			}
		}
		zend_exception_restore();

		if (
		    (first_token == T_VARIABLE
		     || first_token == T_DOLLAR_OPEN_CURLY_BRACES
		     || first_token == T_CURLY_OPEN
		    ) && SCNG(heredoc_indentation)) {
			zend_throw_exception_ex(zend_ce_parse_error, 0, "Invalid body indentation level (expecting an indentation level of at least %d)", SCNG(heredoc_indentation));
			error = 1;
		}

		heredoc_label->indentation = SCNG(heredoc_indentation);
		heredoc_label->indentation_uses_spaces = SCNG(heredoc_indentation_uses_spaces);

		zend_restore_lexical_state(&current_state);
		SCNG(heredoc_scan_ahead) = 0;
		CG(increment_lineno) = 0;
		CG(doc_comment) = saved_doc_comment;

		if (PARSER_MODE() && error) {
			RETURN_TOKEN(T_ERROR);
		}
	}

	RETURN_TOKEN(T_START_HEREDOC);
}
#line 5974 "Zend/zend_language_scanner.c"
yy442:
		YYDEBUG(442, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy440;
		goto yy441;
yy443:
		YYDEBUG(443, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy535;
		if (yych == 'a') goto yy535;
		goto yy48;
yy444:
		YYDEBUG(444, *YYCURSOR);
		yyaccept = 33;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy445:
		YYDEBUG(445, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1739 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_ARRAY);
}
#line 6002 "Zend/zend_language_scanner.c"
yy446:
		YYDEBUG(446, *YYCURSOR);
		yyaccept = 34;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy447:
		YYDEBUG(447, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1499 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_BREAK);
}
#line 6018 "Zend/zend_language_scanner.c"
yy448:
		YYDEBUG(448, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'B') goto yy536;
		if (yych == 'b') goto yy536;
		goto yy48;
yy449:
		YYDEBUG(449, *YYCURSOR);
		yyaccept = 35;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy450:
		YYDEBUG(450, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1407 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_CATCH);
}
#line 6041 "Zend/zend_language_scanner.c"
yy451:
		YYDEBUG(451, *YYCURSOR);
		yyaccept = 36;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy452:
		YYDEBUG(452, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1519 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_CLASS);
}
#line 6057 "Zend/zend_language_scanner.c"
yy453:
		YYDEBUG(453, *YYCURSOR);
		yyaccept = 37;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy454:
		YYDEBUG(454, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1601 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_CLONE);
}
#line 6073 "Zend/zend_language_scanner.c"
yy455:
		YYDEBUG(455, *YYCURSOR);
		yyaccept = 38;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy456:
		YYDEBUG(456, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1380 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_CONST);
}
#line 6089 "Zend/zend_language_scanner.c"
yy457:
		YYDEBUG(457, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy537;
		if (yych == 'n') goto yy537;
		goto yy48;
yy458:
		YYDEBUG(458, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy538;
		if (yych == 'r') goto yy538;
		goto yy48;
yy459:
		YYDEBUG(459, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy539;
		if (yych == 'l') goto yy539;
		goto yy48;
yy460:
		YYDEBUG(460, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy540;
		if (yych == 'f') goto yy540;
		goto yy48;
yy461:
		YYDEBUG(461, *YYCURSOR);
		yyaccept = 39;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy462:
		YYDEBUG(462, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1685 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_EMPTY);
}
#line 6133 "Zend/zend_language_scanner.c"
yy463:
		YYDEBUG(463, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy542;
		if (yych == 'c') goto yy542;
		goto yy48;
yy464:
		YYDEBUG(464, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy543;
		if (yych == 'r') goto yy543;
		goto yy48;
yy465:
		YYDEBUG(465, *YYCURSOR);
		yyaccept = 40;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy466:
		YYDEBUG(466, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1427 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDIF);
}
#line 6163 "Zend/zend_language_scanner.c"
yy467:
		YYDEBUG(467, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy545;
		if (yych == 'i') goto yy545;
		goto yy48;
yy468:
		YYDEBUG(468, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy546;
		if (yych == 'i') goto yy546;
		goto yy48;
yy469:
		YYDEBUG(469, *YYCURSOR);
		++YYCURSOR;
		YYFILL(10);
		yych = *YYCURSOR;
		YYDEBUG(470, *YYCURSOR);
		if (yych <= 'I') {
			if (yych <= 0x1F) {
				if (yych <= '\n') {
					if (yych <= 0x08) goto yy86;
					goto yy469;
				} else {
					if (yych == '\r') goto yy469;
					goto yy86;
				}
			} else {
				if (yych <= 'D') {
					if (yych <= ' ') goto yy469;
					if (yych <= '@') goto yy86;
					goto yy547;
				} else {
					if (yych <= 'E') goto yy549;
					if (yych <= 'H') goto yy547;
					goto yy550;
				}
			}
		} else {
			if (yych <= 'd') {
				if (yych <= '^') {
					if (yych <= 'Z') goto yy547;
					goto yy86;
				} else {
					if (yych == '`') goto yy86;
					goto yy547;
				}
			} else {
				if (yych <= 'i') {
					if (yych <= 'e') goto yy549;
					if (yych <= 'h') goto yy547;
					goto yy550;
				} else {
					if (yych <= 'z') goto yy547;
					if (yych <= 0x7F) goto yy86;
					goto yy547;
				}
			}
		}
yy471:
		YYDEBUG(471, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy551;
		if (yych == 'd') goto yy551;
		goto yy48;
yy472:
		YYDEBUG(472, *YYCURSOR);
		yyaccept = 41;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= 'K') {
				if (yych <= '/') goto yy473;
				if (yych <= '9') goto yy47;
				if (yych >= 'A') goto yy47;
			} else {
				if (yych <= 'L') goto yy552;
				if (yych <= 'Z') goto yy47;
				if (yych >= '\\') goto yy161;
			}
		} else {
			if (yych <= 'k') {
				if (yych == '_') goto yy47;
				if (yych >= 'a') goto yy47;
			} else {
				if (yych <= 'l') goto yy552;
				if (yych <= 'z') goto yy47;
				if (yych >= 0x80) goto yy47;
			}
		}
yy473:
		YYDEBUG(473, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1701 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_FINAL);
}
#line 6263 "Zend/zend_language_scanner.c"
yy474:
		YYDEBUG(474, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy553;
		if (yych == 'c') goto yy553;
		goto yy48;
yy475:
		YYDEBUG(475, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy554;
		if (yych == 'i') goto yy554;
		goto yy48;
yy476:
		YYDEBUG(476, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy555;
		if (yych == 'l') goto yy555;
		goto yy48;
yy477:
		YYDEBUG(477, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy557;
		if (yych == 'm') goto yy557;
		goto yy48;
yy478:
		YYDEBUG(478, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy558;
		if (yych == 'd') goto yy558;
		goto yy48;
yy479:
		YYDEBUG(479, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy559;
		if (yych == 'n') goto yy559;
		goto yy48;
yy480:
		YYDEBUG(480, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy560;
		if (yych == 'a') goto yy560;
		goto yy48;
yy481:
		YYDEBUG(481, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy561;
		if (yych == 'f') goto yy561;
		goto yy48;
yy482:
		YYDEBUG(482, *YYCURSOR);
		yyaccept = 42;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy483:
		YYDEBUG(483, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1681 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_ISSET);
}
#line 6335 "Zend/zend_language_scanner.c"
yy484:
		YYDEBUG(484, *YYCURSOR);
		yyaccept = 43;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy485:
		YYDEBUG(485, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1483 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_MATCH);
}
#line 6351 "Zend/zend_language_scanner.c"
yy486:
		YYDEBUG(486, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy562;
		if (yych == 'p') goto yy562;
		goto yy48;
yy487:
		YYDEBUG(487, *YYCURSOR);
		yyaccept = 44;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy488:
		YYDEBUG(488, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1515 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_PRINT);
}
#line 6374 "Zend/zend_language_scanner.c"
yy489:
		YYDEBUG(489, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy563;
		if (yych == 't') goto yy563;
		goto yy48;
yy490:
		YYDEBUG(490, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy564;
		if (yych == 'c') goto yy564;
		goto yy48;
yy491:
		YYDEBUG(491, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy565;
		if (yych == 'c') goto yy565;
		goto yy48;
yy492:
		YYDEBUG(492, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy567;
		if (yych == 'n') goto yy567;
		goto yy48;
yy493:
		YYDEBUG(493, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy568;
		if (yych == 'r') goto yy568;
		goto yy48;
yy494:
		YYDEBUG(494, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy569;
		if (yych == 'n') goto yy569;
		goto yy48;
yy495:
		YYDEBUG(495, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy571;
		if (yych == 'c') goto yy571;
		goto yy48;
yy496:
		YYDEBUG(496, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy573;
		if (yych == 'h') goto yy573;
		goto yy48;
yy497:
		YYDEBUG(497, *YYCURSOR);
		yyaccept = 45;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy498:
		YYDEBUG(498, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1415 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_THROW);
}
#line 6446 "Zend/zend_language_scanner.c"
yy499:
		YYDEBUG(499, *YYCURSOR);
		yyaccept = 46;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy500:
		YYDEBUG(500, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1527 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_TRAIT);
}
#line 6462 "Zend/zend_language_scanner.c"
yy501:
		YYDEBUG(501, *YYCURSOR);
		yyaccept = 47;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy502:
		YYDEBUG(502, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1727 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_UNSET);
}
#line 6478 "Zend/zend_language_scanner.c"
yy503:
		YYDEBUG(503, *YYCURSOR);
		yyaccept = 48;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy504:
		YYDEBUG(504, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1435 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_WHILE);
}
#line 6494 "Zend/zend_language_scanner.c"
yy505:
		YYDEBUG(505, *YYCURSOR);
		yyaccept = 49;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych <= '\r') {
			if (yych <= 0x08) goto yy506;
			if (yych <= '\n') goto yy575;
			if (yych >= '\r') goto yy575;
		} else {
			if (yych <= ' ') {
				if (yych >= ' ') goto yy575;
			} else {
				if (yych == '\\') goto yy161;
			}
		}
yy506:
		YYDEBUG(506, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1399 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_YIELD);
}
#line 6520 "Zend/zend_language_scanner.c"
yy507:
		YYDEBUG(507, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy577;
		if (yych == 's') goto yy577;
		goto yy48;
yy508:
		YYDEBUG(508, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy578;
		goto yy48;
yy509:
		YYDEBUG(509, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy579;
		if (yych == 'e') goto yy579;
		goto yy48;
yy510:
		YYDEBUG(510, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy580;
		if (yych == 'c') goto yy580;
		goto yy48;
yy511:
		YYDEBUG(511, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy581;
		if (yych == 't') goto yy581;
		goto yy48;
yy512:
		YYDEBUG(512, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy582;
		if (yych == 'e') goto yy582;
		goto yy48;
yy513:
		YYDEBUG(513, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy583;
		if (yych == 'h') goto yy583;
		goto yy48;
yy514:
		YYDEBUG(514, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy584;
		if (yych == 'e') goto yy584;
		goto yy48;
yy515:
		YYDEBUG(515, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy585;
		if (yych == 'i') goto yy585;
		goto yy48;
yy516:
		YYDEBUG(516, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(517, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy516;
			goto yy86;
		} else {
			if (yych <= ' ') goto yy516;
			if (yych == ')') goto yy586;
			goto yy86;
		}
yy518:
		YYDEBUG(518, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'Y') goto yy588;
		if (yych == 'y') goto yy588;
		goto yy86;
yy519:
		YYDEBUG(519, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy520:
		YYDEBUG(520, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy519;
			goto yy86;
		} else {
			if (yych <= ' ') goto yy519;
			if (yych != ')') goto yy86;
		}
		YYDEBUG(521, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(522, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1637 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_BOOL_CAST);
}
#line 6625 "Zend/zend_language_scanner.c"
yy523:
		YYDEBUG(523, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'A') goto yy590;
		if (yych == 'a') goto yy590;
		goto yy86;
yy524:
		YYDEBUG(524, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy525;
		if (yych != 'e') goto yy86;
yy525:
		YYDEBUG(525, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(526, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy525;
			goto yy86;
		} else {
			if (yych <= ' ') goto yy525;
			if (yych == ')') goto yy591;
			goto yy86;
		}
yy527:
		YYDEBUG(527, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy593;
		if (yych == 'e') goto yy593;
		goto yy86;
yy528:
		YYDEBUG(528, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy594;
		if (yych == 't') goto yy594;
		goto yy86;
yy529:
		YYDEBUG(529, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(530, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1617 "Zend/zend_language_scanner.l"
		{
	if (PARSER_MODE()) {
		zend_throw_exception(zend_ce_parse_error, "The (real) cast has been removed, use (float) instead", 0);
		RETURN_TOKEN(T_ERROR);
	}
	RETURN_TOKEN(T_DOUBLE_CAST);
}
#line 6676 "Zend/zend_language_scanner.c"
yy531:
		YYDEBUG(531, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'G') goto yy588;
		if (yych == 'g') goto yy588;
		goto yy86;
yy532:
		YYDEBUG(532, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(533, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy532;
			goto yy86;
		} else {
			if (yych <= ' ') goto yy532;
			if (yych == ')') goto yy596;
			goto yy86;
		}
yy534:
		YYDEBUG(534, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '\n') goto yy440;
		if (yych == '\r') goto yy442;
		goto yy86;
yy535:
		YYDEBUG(535, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy598;
		if (yych == 'c') goto yy598;
		goto yy48;
yy536:
		YYDEBUG(536, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy599;
		if (yych == 'l') goto yy599;
		goto yy48;
yy537:
		YYDEBUG(537, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'U') goto yy600;
		if (yych == 'u') goto yy600;
		goto yy48;
yy538:
		YYDEBUG(538, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy601;
		if (yych == 'e') goto yy601;
		goto yy48;
yy539:
		YYDEBUG(539, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy603;
		if (yych == 't') goto yy603;
		goto yy48;
yy540:
		YYDEBUG(540, *YYCURSOR);
		yyaccept = 50;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy541:
		YYDEBUG(541, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1423 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_ELSEIF);
}
#line 6753 "Zend/zend_language_scanner.c"
yy542:
		YYDEBUG(542, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy605;
		if (yych == 'l') goto yy605;
		goto yy48;
yy543:
		YYDEBUG(543, *YYCURSOR);
		yyaccept = 51;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= 'D') {
				if (yych <= '/') goto yy544;
				if (yych <= '9') goto yy47;
				if (yych >= 'A') goto yy47;
			} else {
				if (yych <= 'E') goto yy606;
				if (yych <= 'Z') goto yy47;
				if (yych >= '\\') goto yy161;
			}
		} else {
			if (yych <= 'd') {
				if (yych == '_') goto yy47;
				if (yych >= 'a') goto yy47;
			} else {
				if (yych <= 'e') goto yy606;
				if (yych <= 'z') goto yy47;
				if (yych >= 0x80) goto yy47;
			}
		}
yy544:
		YYDEBUG(544, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1451 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDFOR);
}
#line 6792 "Zend/zend_language_scanner.c"
yy545:
		YYDEBUG(545, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy607;
		if (yych == 't') goto yy607;
		goto yy48;
yy546:
		YYDEBUG(546, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy608;
		if (yych == 'l') goto yy608;
		goto yy48;
yy547:
		YYDEBUG(547, *YYCURSOR);
		++YYCURSOR;
yy548:
		YYDEBUG(548, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1539 "Zend/zend_language_scanner.l"
		{
	yyless(4);
	RETURN_TOKEN_WITH_IDENT(T_ENUM);
}
#line 6818 "Zend/zend_language_scanner.c"
yy549:
		YYDEBUG(549, *YYCURSOR);
		yyaccept = 52;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'X') goto yy609;
		if (yych == 'x') goto yy609;
		goto yy548;
yy550:
		YYDEBUG(550, *YYCURSOR);
		yyaccept = 52;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy610;
		if (yych == 'm') goto yy610;
		goto yy548;
yy551:
		YYDEBUG(551, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy611;
		if (yych == 's') goto yy611;
		goto yy48;
yy552:
		YYDEBUG(552, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'Y') goto yy613;
		if (yych == 'y') goto yy613;
		goto yy48;
yy553:
		YYDEBUG(553, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy615;
		if (yych == 'h') goto yy615;
		goto yy48;
yy554:
		YYDEBUG(554, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy617;
		if (yych == 'o') goto yy617;
		goto yy48;
yy555:
		YYDEBUG(555, *YYCURSOR);
		yyaccept = 53;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy556:
		YYDEBUG(556, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1677 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_GLOBAL);
}
#line 6876 "Zend/zend_language_scanner.c"
yy557:
		YYDEBUG(557, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy618;
		if (yych == 'e') goto yy618;
		goto yy48;
yy558:
		YYDEBUG(558, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy619;
		if (yych == 'e') goto yy619;
		goto yy48;
yy559:
		YYDEBUG(559, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy621;
		if (yych == 'c') goto yy621;
		goto yy48;
yy560:
		YYDEBUG(560, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy622;
		if (yych == 'd') goto yy622;
		goto yy48;
yy561:
		YYDEBUG(561, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy623;
		if (yych == 'a') goto yy623;
		goto yy48;
yy562:
		YYDEBUG(562, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy624;
		if (yych == 'a') goto yy624;
		goto yy48;
yy563:
		YYDEBUG(563, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy625;
		if (yych == 'e') goto yy625;
		goto yy48;
yy564:
		YYDEBUG(564, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy627;
		if (yych == 't') goto yy627;
		goto yy48;
yy565:
		YYDEBUG(565, *YYCURSOR);
		yyaccept = 54;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy566:
		YYDEBUG(566, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1713 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_PUBLIC);
}
#line 6948 "Zend/zend_language_scanner.c"
yy567:
		YYDEBUG(567, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy628;
		if (yych == 'l') goto yy628;
		goto yy48;
yy568:
		YYDEBUG(568, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy629;
		if (yych == 'e') goto yy629;
		goto yy48;
yy569:
		YYDEBUG(569, *YYCURSOR);
		yyaccept = 55;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy570:
		YYDEBUG(570, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1384 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_RETURN);
}
#line 6978 "Zend/zend_language_scanner.c"
yy571:
		YYDEBUG(571, *YYCURSOR);
		yyaccept = 56;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy572:
		YYDEBUG(572, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1693 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_STATIC);
}
#line 6994 "Zend/zend_language_scanner.c"
yy573:
		YYDEBUG(573, *YYCURSOR);
		yyaccept = 57;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy574:
		YYDEBUG(574, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1479 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_SWITCH);
}
#line 7010 "Zend/zend_language_scanner.c"
yy575:
		YYDEBUG(575, *YYCURSOR);
		++YYCURSOR;
		YYFILL(5);
		yych = *YYCURSOR;
		YYDEBUG(576, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych <= 0x08) goto yy86;
				goto yy575;
			} else {
				if (yych == '\r') goto yy575;
				goto yy86;
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ' ') goto yy575;
				if (yych <= 'E') goto yy86;
				goto yy631;
			} else {
				if (yych == 'f') goto yy631;
				goto yy86;
			}
		}
yy577:
		YYDEBUG(577, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy632;
		if (yych == 's') goto yy632;
		goto yy48;
yy578:
		YYDEBUG(578, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy633;
		goto yy48;
yy579:
		YYDEBUG(579, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy635;
		goto yy48;
yy580:
		YYDEBUG(580, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy636;
		if (yych == 't') goto yy636;
		goto yy48;
yy581:
		YYDEBUG(581, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy637;
		goto yy48;
yy582:
		YYDEBUG(582, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy638;
		goto yy48;
yy583:
		YYDEBUG(583, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy639;
		if (yych == 'o') goto yy639;
		goto yy48;
yy584:
		YYDEBUG(584, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy640;
		if (yych == 's') goto yy640;
		goto yy48;
yy585:
		YYDEBUG(585, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy641;
		if (yych == 't') goto yy641;
		goto yy48;
yy586:
		YYDEBUG(586, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(587, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1629 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_ARRAY_CAST);
}
#line 7103 "Zend/zend_language_scanner.c"
yy588:
		YYDEBUG(588, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(589, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy588;
			goto yy86;
		} else {
			if (yych <= ' ') goto yy588;
			if (yych == ')') goto yy642;
			goto yy86;
		}
yy590:
		YYDEBUG(590, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy519;
		if (yych == 'n') goto yy519;
		goto yy86;
yy591:
		YYDEBUG(591, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(592, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1613 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_DOUBLE_CAST);
}
#line 7133 "Zend/zend_language_scanner.c"
yy593:
		YYDEBUG(593, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy426;
		if (yych == 'r') goto yy426;
		goto yy86;
yy594:
		YYDEBUG(594, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(595, *YYCURSOR);
		if (yych <= 0x1F) {
			if (yych == '\t') goto yy594;
			goto yy86;
		} else {
			if (yych <= ' ') goto yy594;
			if (yych == ')') goto yy644;
			goto yy86;
		}
yy596:
		YYDEBUG(596, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(597, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1641 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_UNSET_CAST);
}
#line 7163 "Zend/zend_language_scanner.c"
yy598:
		YYDEBUG(598, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy646;
		if (yych == 't') goto yy646;
		goto yy48;
yy599:
		YYDEBUG(599, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy648;
		if (yych == 'e') goto yy648;
		goto yy48;
yy600:
		YYDEBUG(600, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy650;
		if (yych == 'e') goto yy650;
		goto yy48;
yy601:
		YYDEBUG(601, *YYCURSOR);
		yyaccept = 58;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy602:
		YYDEBUG(602, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1463 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_DECLARE);
}
#line 7200 "Zend/zend_language_scanner.c"
yy603:
		YYDEBUG(603, *YYCURSOR);
		yyaccept = 59;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy604:
		YYDEBUG(604, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1495 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_DEFAULT);
}
#line 7216 "Zend/zend_language_scanner.c"
yy605:
		YYDEBUG(605, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy652;
		if (yych == 'a') goto yy652;
		goto yy48;
yy606:
		YYDEBUG(606, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy653;
		if (yych == 'a') goto yy653;
		goto yy48;
yy607:
		YYDEBUG(607, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy654;
		if (yych == 'c') goto yy654;
		goto yy48;
yy608:
		YYDEBUG(608, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy655;
		if (yych == 'e') goto yy655;
		goto yy48;
yy609:
		YYDEBUG(609, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy657;
		if (yych == 't') goto yy657;
		goto yy86;
yy610:
		YYDEBUG(610, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'P') goto yy658;
		if (yych == 'p') goto yy658;
		goto yy86;
yy611:
		YYDEBUG(611, *YYCURSOR);
		yyaccept = 60;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy612:
		YYDEBUG(612, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1544 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_EXTENDS);
}
#line 7272 "Zend/zend_language_scanner.c"
yy613:
		YYDEBUG(613, *YYCURSOR);
		yyaccept = 61;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy614:
		YYDEBUG(614, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1411 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_FINALLY);
}
#line 7288 "Zend/zend_language_scanner.c"
yy615:
		YYDEBUG(615, *YYCURSOR);
		yyaccept = 62;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy616:
		YYDEBUG(616, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1455 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_FOREACH);
}
#line 7304 "Zend/zend_language_scanner.c"
yy617:
		YYDEBUG(617, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy659;
		if (yych == 'n') goto yy659;
		goto yy48;
yy618:
		YYDEBUG(618, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy661;
		if (yych == 'n') goto yy661;
		goto yy48;
yy619:
		YYDEBUG(619, *YYCURSOR);
		yyaccept = 63;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy620;
				if (yych <= '9') goto yy47;
			} else {
				if (yych <= 'Z') goto yy47;
				if (yych >= '\\') goto yy161;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy662;
			} else {
				if (yych <= 'z') goto yy47;
				if (yych >= 0x80) goto yy47;
			}
		}
yy620:
		YYDEBUG(620, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1649 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_INCLUDE);
}
#line 7346 "Zend/zend_language_scanner.c"
yy621:
		YYDEBUG(621, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy663;
		if (yych == 'e') goto yy663;
		goto yy48;
yy622:
		YYDEBUG(622, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy664;
		if (yych == 'o') goto yy664;
		goto yy48;
yy623:
		YYDEBUG(623, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy665;
		if (yych == 'c') goto yy665;
		goto yy48;
yy624:
		YYDEBUG(624, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy666;
		if (yych == 'c') goto yy666;
		goto yy48;
yy625:
		YYDEBUG(625, *YYCURSOR);
		yyaccept = 64;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy626:
		YYDEBUG(626, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1705 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_PRIVATE);
}
#line 7390 "Zend/zend_language_scanner.c"
yy627:
		YYDEBUG(627, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy667;
		if (yych == 'e') goto yy667;
		goto yy48;
yy628:
		YYDEBUG(628, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'Y') goto yy668;
		if (yych == 'y') goto yy668;
		goto yy48;
yy629:
		YYDEBUG(629, *YYCURSOR);
		yyaccept = 65;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy630;
				if (yych <= '9') goto yy47;
			} else {
				if (yych <= 'Z') goto yy47;
				if (yych >= '\\') goto yy161;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy670;
			} else {
				if (yych <= 'z') goto yy47;
				if (yych >= 0x80) goto yy47;
			}
		}
yy630:
		YYDEBUG(630, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1657 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_REQUIRE);
}
#line 7432 "Zend/zend_language_scanner.c"
yy631:
		YYDEBUG(631, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'R') goto yy671;
		if (yych == 'r') goto yy671;
		goto yy86;
yy632:
		YYDEBUG(632, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy672;
		goto yy48;
yy633:
		YYDEBUG(633, *YYCURSOR);
		yyaccept = 66;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy634:
		YYDEBUG(634, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2194 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_DIR);
}
#line 7460 "Zend/zend_language_scanner.c"
yy635:
		YYDEBUG(635, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy673;
		goto yy48;
yy636:
		YYDEBUG(636, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy675;
		if (yych == 'i') goto yy675;
		goto yy48;
yy637:
		YYDEBUG(637, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy676;
		if (yych == 'c') goto yy676;
		goto yy48;
yy638:
		YYDEBUG(638, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy677;
		goto yy48;
yy639:
		YYDEBUG(639, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy679;
		if (yych == 'd') goto yy679;
		goto yy48;
yy640:
		YYDEBUG(640, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy680;
		if (yych == 'p') goto yy680;
		goto yy48;
yy641:
		YYDEBUG(641, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy681;
		goto yy48;
yy642:
		YYDEBUG(642, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(643, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1625 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_STRING_CAST);
}
#line 7516 "Zend/zend_language_scanner.c"
yy644:
		YYDEBUG(644, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(645, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1633 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_OBJECT_CAST);
}
#line 7526 "Zend/zend_language_scanner.c"
yy646:
		YYDEBUG(646, *YYCURSOR);
		yyaccept = 67;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy647:
		YYDEBUG(647, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1697 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_ABSTRACT);
}
#line 7542 "Zend/zend_language_scanner.c"
yy648:
		YYDEBUG(648, *YYCURSOR);
		yyaccept = 68;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy649:
		YYDEBUG(649, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1743 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_CALLABLE);
}
#line 7558 "Zend/zend_language_scanner.c"
yy650:
		YYDEBUG(650, *YYCURSOR);
		yyaccept = 69;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy651:
		YYDEBUG(651, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1503 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_CONTINUE);
}
#line 7574 "Zend/zend_language_scanner.c"
yy652:
		YYDEBUG(652, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy682;
		if (yych == 'r') goto yy682;
		goto yy48;
yy653:
		YYDEBUG(653, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy683;
		if (yych == 'c') goto yy683;
		goto yy48;
yy654:
		YYDEBUG(654, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy684;
		if (yych == 'h') goto yy684;
		goto yy48;
yy655:
		YYDEBUG(655, *YYCURSOR);
		yyaccept = 70;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy656:
		YYDEBUG(656, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1439 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDWHILE);
}
#line 7611 "Zend/zend_language_scanner.c"
yy657:
		YYDEBUG(657, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy686;
		if (yych == 'e') goto yy686;
		goto yy86;
yy658:
		YYDEBUG(658, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'L') goto yy687;
		if (yych == 'l') goto yy687;
		goto yy86;
yy659:
		YYDEBUG(659, *YYCURSOR);
		yyaccept = 71;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy660:
		YYDEBUG(660, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1376 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_FUNCTION);
}
#line 7639 "Zend/zend_language_scanner.c"
yy661:
		YYDEBUG(661, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'T') goto yy688;
		if (yych == 't') goto yy688;
		goto yy48;
yy662:
		YYDEBUG(662, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy689;
		if (yych == 'o') goto yy689;
		goto yy48;
yy663:
		YYDEBUG(663, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy690;
		if (yych == 'o') goto yy690;
		goto yy48;
yy664:
		YYDEBUG(664, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy691;
		if (yych == 'f') goto yy691;
		goto yy48;
yy665:
		YYDEBUG(665, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy693;
		if (yych == 'e') goto yy693;
		goto yy48;
yy666:
		YYDEBUG(666, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy695;
		if (yych == 'e') goto yy695;
		goto yy48;
yy667:
		YYDEBUG(667, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'D') goto yy697;
		if (yych == 'd') goto yy697;
		goto yy48;
yy668:
		YYDEBUG(668, *YYCURSOR);
		yyaccept = 72;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych <= 0x1F) {
			if (yych <= '\n') {
				if (yych >= '\t') goto yy699;
			} else {
				if (yych == '\r') goto yy699;
			}
		} else {
			if (yych <= '(') {
				if (yych <= ' ') goto yy699;
				if (yych >= '(') goto yy701;
			} else {
				if (yych == '\\') goto yy161;
			}
		}
yy669:
		YYDEBUG(669, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1717 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_READONLY);
}
#line 7717 "Zend/zend_language_scanner.c"
yy670:
		YYDEBUG(670, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy703;
		if (yych == 'o') goto yy703;
		goto yy48;
yy671:
		YYDEBUG(671, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'O') goto yy704;
		if (yych == 'o') goto yy704;
		goto yy86;
yy672:
		YYDEBUG(672, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy705;
		goto yy48;
yy673:
		YYDEBUG(673, *YYCURSOR);
		yyaccept = 73;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy674:
		YYDEBUG(674, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2190 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_FILE);
}
#line 7752 "Zend/zend_language_scanner.c"
yy675:
		YYDEBUG(675, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy707;
		if (yych == 'o') goto yy707;
		goto yy48;
yy676:
		YYDEBUG(676, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'O') goto yy708;
		if (yych == 'o') goto yy708;
		goto yy48;
yy677:
		YYDEBUG(677, *YYCURSOR);
		yyaccept = 74;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy678:
		YYDEBUG(678, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2186 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_LINE);
}
#line 7782 "Zend/zend_language_scanner.c"
yy679:
		YYDEBUG(679, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy709;
		goto yy48;
yy680:
		YYDEBUG(680, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'A') goto yy710;
		if (yych == 'a') goto yy710;
		goto yy48;
yy681:
		YYDEBUG(681, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy711;
		goto yy48;
yy682:
		YYDEBUG(682, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy713;
		if (yych == 'e') goto yy713;
		goto yy48;
yy683:
		YYDEBUG(683, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'H') goto yy715;
		if (yych == 'h') goto yy715;
		goto yy48;
yy684:
		YYDEBUG(684, *YYCURSOR);
		yyaccept = 75;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy685:
		YYDEBUG(685, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1487 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDSWITCH);
}
#line 7831 "Zend/zend_language_scanner.c"
yy686:
		YYDEBUG(686, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy717;
		if (yych == 'n') goto yy717;
		goto yy86;
yy687:
		YYDEBUG(687, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy718;
		if (yych == 'e') goto yy718;
		goto yy86;
yy688:
		YYDEBUG(688, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'S') goto yy719;
		if (yych == 's') goto yy719;
		goto yy48;
yy689:
		YYDEBUG(689, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy721;
		if (yych == 'n') goto yy721;
		goto yy48;
yy690:
		YYDEBUG(690, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'F') goto yy722;
		if (yych == 'f') goto yy722;
		goto yy48;
yy691:
		YYDEBUG(691, *YYCURSOR);
		yyaccept = 76;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy692:
		YYDEBUG(692, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1673 "Zend/zend_language_scanner.l"
		{
    RETURN_TOKEN_WITH_IDENT(T_INSTEADOF);
}
#line 7880 "Zend/zend_language_scanner.c"
yy693:
		YYDEBUG(693, *YYCURSOR);
		yyaccept = 77;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy694:
		YYDEBUG(694, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1523 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_INTERFACE);
}
#line 7896 "Zend/zend_language_scanner.c"
yy695:
		YYDEBUG(695, *YYCURSOR);
		yyaccept = 78;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy724;
yy696:
		YYDEBUG(696, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1665 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_NAMESPACE);
}
#line 7912 "Zend/zend_language_scanner.c"
yy697:
		YYDEBUG(697, *YYCURSOR);
		yyaccept = 79;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy698:
		YYDEBUG(698, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1709 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_PROTECTED);
}
#line 7928 "Zend/zend_language_scanner.c"
yy699:
		YYDEBUG(699, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(700, *YYCURSOR);
		if (yych <= '\r') {
			if (yych <= 0x08) goto yy86;
			if (yych <= '\n') goto yy699;
			if (yych <= '\f') goto yy86;
			goto yy699;
		} else {
			if (yych <= ' ') {
				if (yych <= 0x1F) goto yy86;
				goto yy699;
			} else {
				if (yych != '(') goto yy86;
			}
		}
yy701:
		YYDEBUG(701, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(702, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1722 "Zend/zend_language_scanner.l"
		{
	yyless(strlen("readonly"));
	RETURN_TOKEN_WITH_STR(T_STRING, 0);
}
#line 7958 "Zend/zend_language_scanner.c"
yy703:
		YYDEBUG(703, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy725;
		if (yych == 'n') goto yy725;
		goto yy48;
yy704:
		YYDEBUG(704, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy726;
		if (yych == 'm') goto yy726;
		goto yy86;
yy705:
		YYDEBUG(705, *YYCURSOR);
		yyaccept = 80;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy706:
		YYDEBUG(706, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2170 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_CLASS_C);
}
#line 7987 "Zend/zend_language_scanner.c"
yy707:
		YYDEBUG(707, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'N') goto yy727;
		if (yych == 'n') goto yy727;
		goto yy48;
yy708:
		YYDEBUG(708, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'M') goto yy728;
		if (yych == 'm') goto yy728;
		goto yy48;
yy709:
		YYDEBUG(709, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy729;
		goto yy48;
yy710:
		YYDEBUG(710, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy731;
		if (yych == 'c') goto yy731;
		goto yy48;
yy711:
		YYDEBUG(711, *YYCURSOR);
		yyaccept = 81;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy712:
		YYDEBUG(712, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2174 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_TRAIT_C);
}
#line 8030 "Zend/zend_language_scanner.c"
yy713:
		YYDEBUG(713, *YYCURSOR);
		yyaccept = 82;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy714:
		YYDEBUG(714, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1467 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDDECLARE);
}
#line 8046 "Zend/zend_language_scanner.c"
yy715:
		YYDEBUG(715, *YYCURSOR);
		yyaccept = 83;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy716:
		YYDEBUG(716, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1459 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_ENDFOREACH);
}
#line 8062 "Zend/zend_language_scanner.c"
yy717:
		YYDEBUG(717, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'D') goto yy732;
		if (yych == 'd') goto yy732;
		goto yy86;
yy718:
		YYDEBUG(718, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'M') goto yy733;
		if (yych == 'm') goto yy733;
		goto yy86;
yy719:
		YYDEBUG(719, *YYCURSOR);
		yyaccept = 84;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy720:
		YYDEBUG(720, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1548 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_IMPLEMENTS);
}
#line 8090 "Zend/zend_language_scanner.c"
yy721:
		YYDEBUG(721, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy734;
		if (yych == 'c') goto yy734;
		goto yy48;
yy722:
		YYDEBUG(722, *YYCURSOR);
		yyaccept = 85;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy723:
		YYDEBUG(723, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1471 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_INSTANCEOF);
}
#line 8113 "Zend/zend_language_scanner.c"
yy724:
		YYDEBUG(724, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy86;
			if (yych <= 'Z') goto yy735;
			if (yych <= '^') goto yy86;
			goto yy735;
		} else {
			if (yych <= '`') goto yy86;
			if (yych <= 'z') goto yy735;
			if (yych <= 0x7F) goto yy86;
			goto yy735;
		}
yy725:
		YYDEBUG(725, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'C') goto yy738;
		if (yych == 'c') goto yy738;
		goto yy48;
yy726:
		YYDEBUG(726, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych <= '/') goto yy739;
				goto yy86;
			} else {
				if (yych <= '@') goto yy739;
				if (yych <= 'Z') goto yy86;
				goto yy739;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy86;
				goto yy739;
			} else {
				if (yych <= 'z') goto yy86;
				if (yych <= 0x7F) goto yy739;
				goto yy86;
			}
		}
yy727:
		YYDEBUG(727, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy741;
		goto yy48;
yy728:
		YYDEBUG(728, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'P') goto yy742;
		if (yych == 'p') goto yy742;
		goto yy48;
yy729:
		YYDEBUG(729, *YYCURSOR);
		yyaccept = 86;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy730:
		YYDEBUG(730, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2182 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_METHOD_C);
}
#line 8187 "Zend/zend_language_scanner.c"
yy731:
		YYDEBUG(731, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy743;
		if (yych == 'e') goto yy743;
		goto yy48;
yy732:
		YYDEBUG(732, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'S') goto yy744;
		if (yych == 's') goto yy744;
		goto yy86;
yy733:
		YYDEBUG(733, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'E') goto yy746;
		if (yych == 'e') goto yy746;
		goto yy86;
yy734:
		YYDEBUG(734, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy747;
		if (yych == 'e') goto yy747;
		goto yy48;
yy735:
		YYDEBUG(735, *YYCURSOR);
		yyaccept = 87;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(736, *YYCURSOR);
		if (yych <= '\\') {
			if (yych <= '@') {
				if (yych <= '/') goto yy737;
				if (yych <= '9') goto yy735;
			} else {
				if (yych <= 'Z') goto yy735;
				if (yych >= '\\') goto yy724;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy735;
			} else {
				if (yych <= 'z') goto yy735;
				if (yych >= 0x80) goto yy735;
			}
		}
yy737:
		YYDEBUG(737, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2352 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_STR(T_NAME_RELATIVE, sizeof("namespace\\") - 1);
}
#line 8244 "Zend/zend_language_scanner.c"
yy738:
		YYDEBUG(738, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy749;
		if (yych == 'e') goto yy749;
		goto yy48;
yy739:
		YYDEBUG(739, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(740, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1393 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	HANDLE_NEWLINES(yytext, yyleng);
	RETURN_TOKEN_WITH_IDENT(T_YIELD_FROM);
}
#line 8263 "Zend/zend_language_scanner.c"
yy741:
		YYDEBUG(741, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy751;
		goto yy48;
yy742:
		YYDEBUG(742, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'I') goto yy753;
		if (yych == 'i') goto yy753;
		goto yy48;
yy743:
		YYDEBUG(743, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy754;
		goto yy48;
yy744:
		YYDEBUG(744, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(745, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1535 "Zend/zend_language_scanner.l"
		{
	yyless(4);
	RETURN_TOKEN_WITH_STR(T_STRING, 0);
}
#line 8293 "Zend/zend_language_scanner.c"
yy746:
		YYDEBUG(746, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'N') goto yy755;
		if (yych == 'n') goto yy755;
		goto yy86;
yy747:
		YYDEBUG(747, *YYCURSOR);
		yyaccept = 88;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy748:
		YYDEBUG(748, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1653 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_INCLUDE_ONCE);
}
#line 8315 "Zend/zend_language_scanner.c"
yy749:
		YYDEBUG(749, *YYCURSOR);
		yyaccept = 89;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy750:
		YYDEBUG(750, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1661 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_REQUIRE_ONCE);
}
#line 8331 "Zend/zend_language_scanner.c"
yy751:
		YYDEBUG(751, *YYCURSOR);
		yyaccept = 90;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy752:
		YYDEBUG(752, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2178 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_FUNC_C);
}
#line 8347 "Zend/zend_language_scanner.c"
yy753:
		YYDEBUG(753, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'L') goto yy756;
		if (yych == 'l') goto yy756;
		goto yy48;
yy754:
		YYDEBUG(754, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '_') goto yy757;
		goto yy48;
yy755:
		YYDEBUG(755, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == 'T') goto yy732;
		if (yych == 't') goto yy732;
		goto yy86;
yy756:
		YYDEBUG(756, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'E') goto yy759;
		if (yych == 'e') goto yy759;
		goto yy48;
yy757:
		YYDEBUG(757, *YYCURSOR);
		yyaccept = 91;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy758:
		YYDEBUG(758, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2198 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_NS_C);
}
#line 8389 "Zend/zend_language_scanner.c"
yy759:
		YYDEBUG(759, *YYCURSOR);
		yyaccept = 4;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == 'R') goto yy760;
		if (yych != 'r') goto yy48;
yy760:
		YYDEBUG(760, *YYCURSOR);
		yyaccept = 92;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy47;
		}
		if (yych == '\\') goto yy161;
yy761:
		YYDEBUG(761, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1689 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_IDENT(T_HALT_COMPILER);
}
#line 8411 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_LOOKING_FOR_PROPERTY:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,  64,  64,   0,   0,  64,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			 64,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(762, *YYCURSOR);
		YYFILL(3);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 64) {
			goto yy766;
		}
		if (yych <= 'Z') {
			if (yych <= '>') {
				if (yych == '-') goto yy769;
			} else {
				if (yych <= '?') goto yy770;
				if (yych >= 'A') goto yy771;
			}
		} else {
			if (yych <= '`') {
				if (yych == '_') goto yy771;
			} else {
				if (yych <= 'z') goto yy771;
				if (yych >= 0x80) goto yy771;
			}
		}
		YYDEBUG(764, *YYCURSOR);
		++YYCURSOR;
yy765:
		YYDEBUG(765, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1579 "Zend/zend_language_scanner.l"
		{
	yyless(0);
	yy_pop_state();
	goto restart;
}
#line 8482 "Zend/zend_language_scanner.c"
yy766:
		YYDEBUG(766, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(767, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy766;
		}
		YYDEBUG(768, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1562 "Zend/zend_language_scanner.l"
		{
	goto return_whitespace;
}
#line 8498 "Zend/zend_language_scanner.c"
yy769:
		YYDEBUG(769, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy774;
		goto yy765;
yy770:
		YYDEBUG(770, *YYCURSOR);
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych == '-') goto yy776;
		goto yy765;
yy771:
		YYDEBUG(771, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(772, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy771;
		}
		YYDEBUG(773, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1574 "Zend/zend_language_scanner.l"
		{
	yy_pop_state();
	RETURN_TOKEN_WITH_STR(T_STRING, 0);
}
#line 8525 "Zend/zend_language_scanner.c"
yy774:
		YYDEBUG(774, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(775, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1566 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_OBJECT_OPERATOR);
}
#line 8535 "Zend/zend_language_scanner.c"
yy776:
		YYDEBUG(776, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy778;
		YYDEBUG(777, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy765;
yy778:
		YYDEBUG(778, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(779, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1570 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN(T_NULLSAFE_OBJECT_OPERATOR);
}
#line 8552 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_BACKQUOTE:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(780, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych == '$') goto yy784;
		} else {
			if (yych <= '`') goto yy785;
			if (yych == '{') goto yy787;
		}
		YYDEBUG(782, *YYCURSOR);
		++YYCURSOR;
yy783:
		YYDEBUG(783, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2826 "Zend/zend_language_scanner.l"
		{
	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}
	if (yytext[0] == '\\' && YYCURSOR < YYLIMIT) {
		YYCURSOR++;
	}

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '`':
				break;
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT) {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

	yyleng = YYCURSOR - SCNG(yy_text);

	if (EXPECTED(zend_scan_escape_string(zendlval, yytext, yyleng, '`') == SUCCESS)
	 || !PARSER_MODE()) {
		RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
	} else {
		RETURN_TOKEN(T_ERROR);
	}
}
#line 8650 "Zend/zend_language_scanner.c"
yy784:
		YYDEBUG(784, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy783;
			if (yych <= 'Z') goto yy788;
			if (yych <= '^') goto yy783;
			goto yy788;
		} else {
			if (yych <= 'z') {
				if (yych <= '`') goto yy783;
				goto yy788;
			} else {
				if (yych <= '{') goto yy791;
				if (yych <= 0x7F) goto yy783;
				goto yy788;
			}
		}
yy785:
		YYDEBUG(785, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(786, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2766 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_IN_SCRIPTING);
	RETURN_TOKEN('`');
}
#line 8679 "Zend/zend_language_scanner.c"
yy787:
		YYDEBUG(787, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '$') goto yy793;
		goto yy783;
yy788:
		YYDEBUG(788, *YYCURSOR);
		YYMARKER = ++YYCURSOR;
		YYFILL(4);
		yych = *YYCURSOR;
		YYDEBUG(789, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy788;
		}
		if (yych <= '>') {
			if (yych == '-') goto yy795;
		} else {
			if (yych <= '?') goto yy797;
			if (yych <= '@') goto yy790;
			if (yych <= '[') goto yy798;
		}
yy790:
		YYDEBUG(790, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2330 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
#line 8708 "Zend/zend_language_scanner.c"
yy791:
		YYDEBUG(791, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(792, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1898 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME);
	enter_nesting('{');
	RETURN_TOKEN(T_DOLLAR_OPEN_CURLY_BRACES);
}
#line 8720 "Zend/zend_language_scanner.c"
yy793:
		YYDEBUG(793, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(794, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2753 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_IN_SCRIPTING);
	yyless(1);
	enter_nesting('{');
	RETURN_TOKEN(T_CURLY_OPEN);
}
#line 8733 "Zend/zend_language_scanner.c"
yy795:
		YYDEBUG(795, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy800;
yy796:
		YYDEBUG(796, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy790;
yy797:
		YYDEBUG(797, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '-') goto yy801;
		goto yy796;
yy798:
		YYDEBUG(798, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(799, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2324 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
#line 8758 "Zend/zend_language_scanner.c"
yy800:
		YYDEBUG(800, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy796;
			if (yych <= 'Z') goto yy802;
			if (yych <= '^') goto yy796;
			goto yy802;
		} else {
			if (yych <= '`') goto yy796;
			if (yych <= 'z') goto yy802;
			if (yych <= 0x7F) goto yy796;
			goto yy802;
		}
yy801:
		YYDEBUG(801, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy804;
		goto yy796;
yy802:
		YYDEBUG(802, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(803, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2310 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
#line 8789 "Zend/zend_language_scanner.c"
yy804:
		YYDEBUG(804, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy796;
			if (yych <= 'Z') goto yy805;
			if (yych <= '^') goto yy796;
		} else {
			if (yych <= '`') goto yy796;
			if (yych <= 'z') goto yy805;
			if (yych <= 0x7F) goto yy796;
		}
yy805:
		YYDEBUG(805, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(806, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2316 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 4);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
#line 8813 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_DOUBLE_QUOTES:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(807, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '#') {
			if (yych == '"') goto yy811;
		} else {
			if (yych <= '$') goto yy813;
			if (yych == '{') goto yy814;
		}
		YYDEBUG(809, *YYCURSOR);
		++YYCURSOR;
yy810:
		YYDEBUG(810, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2772 "Zend/zend_language_scanner.l"
		{
	if (GET_DOUBLE_QUOTES_SCANNED_LENGTH()) {
		YYCURSOR += GET_DOUBLE_QUOTES_SCANNED_LENGTH() - 1;
		SET_DOUBLE_QUOTES_SCANNED_LENGTH(0);

		goto double_quotes_scan_done;
	}

	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}
	if (yytext[0] == '\\' && YYCURSOR < YYLIMIT) {
		YYCURSOR++;
	}

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '"':
				break;
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT) {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

double_quotes_scan_done:
	yyleng = YYCURSOR - SCNG(yy_text);

	if (EXPECTED(zend_scan_escape_string(zendlval, yytext, yyleng, '"') == SUCCESS)
	 || !PARSER_MODE()) {
		RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
	} else {
		RETURN_TOKEN(T_ERROR);
	}
}
#line 8919 "Zend/zend_language_scanner.c"
yy811:
		YYDEBUG(811, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(812, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2761 "Zend/zend_language_scanner.l"
		{
	BEGIN(ST_IN_SCRIPTING);
	RETURN_TOKEN('"');
}
#line 8930 "Zend/zend_language_scanner.c"
yy813:
		YYDEBUG(813, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy810;
			if (yych <= 'Z') goto yy815;
			if (yych <= '^') goto yy810;
			goto yy815;
		} else {
			if (yych <= 'z') {
				if (yych <= '`') goto yy810;
				goto yy815;
			} else {
				if (yych <= '{') goto yy818;
				if (yych <= 0x7F) goto yy810;
				goto yy815;
			}
		}
yy814:
		YYDEBUG(814, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '$') goto yy820;
		goto yy810;
yy815:
		YYDEBUG(815, *YYCURSOR);
		YYMARKER = ++YYCURSOR;
		YYFILL(4);
		yych = *YYCURSOR;
		YYDEBUG(816, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy815;
		}
		if (yych <= '>') {
			if (yych == '-') goto yy822;
		} else {
			if (yych <= '?') goto yy824;
			if (yych <= '@') goto yy817;
			if (yych <= '[') goto yy825;
		}
yy817:
		YYDEBUG(817, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2330 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
#line 8977 "Zend/zend_language_scanner.c"
yy818:
		YYDEBUG(818, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(819, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1898 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME);
	enter_nesting('{');
	RETURN_TOKEN(T_DOLLAR_OPEN_CURLY_BRACES);
}
#line 8989 "Zend/zend_language_scanner.c"
yy820:
		YYDEBUG(820, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(821, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2753 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_IN_SCRIPTING);
	yyless(1);
	enter_nesting('{');
	RETURN_TOKEN(T_CURLY_OPEN);
}
#line 9002 "Zend/zend_language_scanner.c"
yy822:
		YYDEBUG(822, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy827;
yy823:
		YYDEBUG(823, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy817;
yy824:
		YYDEBUG(824, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '-') goto yy828;
		goto yy823;
yy825:
		YYDEBUG(825, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(826, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2324 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
#line 9027 "Zend/zend_language_scanner.c"
yy827:
		YYDEBUG(827, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy823;
			if (yych <= 'Z') goto yy829;
			if (yych <= '^') goto yy823;
			goto yy829;
		} else {
			if (yych <= '`') goto yy823;
			if (yych <= 'z') goto yy829;
			if (yych <= 0x7F) goto yy823;
			goto yy829;
		}
yy828:
		YYDEBUG(828, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy831;
		goto yy823;
yy829:
		YYDEBUG(829, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(830, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2310 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
#line 9058 "Zend/zend_language_scanner.c"
yy831:
		YYDEBUG(831, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy823;
			if (yych <= 'Z') goto yy832;
			if (yych <= '^') goto yy823;
		} else {
			if (yych <= '`') goto yy823;
			if (yych <= 'z') goto yy832;
			if (yych <= 0x7F) goto yy823;
		}
yy832:
		YYDEBUG(832, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(833, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2316 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 4);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
#line 9082 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_HEREDOC:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(834, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych == '$') goto yy838;
		if (yych == '{') goto yy839;
		YYDEBUG(836, *YYCURSOR);
		++YYCURSOR;
yy837:
		YYDEBUG(837, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2872 "Zend/zend_language_scanner.l"
		{
	zend_heredoc_label *heredoc_label = zend_ptr_stack_top(&SCNG(heredoc_label_stack));
	int newline = 0, indentation = 0, spacing = 0;

	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

	YYCURSOR--;

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '\r':
				if (*YYCURSOR == '\n') {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			case '\n':
				indentation = spacing = 0;

				while (YYCURSOR < YYLIMIT && (*YYCURSOR == ' ' || *YYCURSOR == '\t')) {
					if (*YYCURSOR == '\t') {
						spacing |= HEREDOC_USING_TABS;
					} else {
						spacing |= HEREDOC_USING_SPACES;
					}
					++YYCURSOR;
					++indentation;
				}

				if (YYCURSOR == YYLIMIT) {
					yyleng = YYCURSOR - SCNG(yy_text);
					HANDLE_NEWLINES(yytext, yyleng);
					ZVAL_NULL(zendlval);
					RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
				}

				/* Check for ending label on the next line */
				if (IS_LABEL_START(*YYCURSOR) && heredoc_label->length < YYLIMIT - YYCURSOR && !memcmp(YYCURSOR, heredoc_label->label, heredoc_label->length)) {
					if (IS_LABEL_SUCCESSOR(YYCURSOR[heredoc_label->length])) {
						continue;
					}

					if (spacing == (HEREDOC_USING_SPACES | HEREDOC_USING_TABS)) {
						zend_throw_exception(zend_ce_parse_error, "Invalid indentation - tabs and spaces cannot be mixed", 0);
						if (PARSER_MODE()) {
							RETURN_TOKEN(T_ERROR);
						}
					}

					/* newline before label will be subtracted from returned text, but
					 * yyleng/yytext will include it, for zend_highlight/strip, tokenizer, etc. */
					if (YYCURSOR[-indentation - 2] == '\r' && YYCURSOR[-indentation - 1] == '\n') {
						newline = 2; /* Windows newline */
					} else {
						newline = 1;
					}

					CG(increment_lineno) = 1; /* For newline before label */

					if (SCNG(heredoc_scan_ahead)) {
						SCNG(heredoc_indentation) = indentation;
						SCNG(heredoc_indentation_uses_spaces) = (spacing == HEREDOC_USING_SPACES);
					} else {
						YYCURSOR -= indentation;
					}

					BEGIN(ST_END_HEREDOC);

					goto heredoc_scan_done;
				}
				continue;
			case '$':
				if (IS_LABEL_START(*YYCURSOR) || *YYCURSOR == '{') {
					break;
				}
				continue;
			case '{':
				if (*YYCURSOR == '$') {
					break;
				}
				continue;
			case '\\':
				if (YYCURSOR < YYLIMIT && *YYCURSOR != '\n' && *YYCURSOR != '\r') {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}

		YYCURSOR--;
		break;
	}

heredoc_scan_done:

	yyleng = YYCURSOR - SCNG(yy_text);
	ZVAL_STRINGL(zendlval, yytext, yyleng - newline);

	if (!SCNG(heredoc_scan_ahead) && !EG(exception) && PARSER_MODE()) {
		bool newline_at_start = *(yytext - 1) == '\n' || *(yytext - 1) == '\r';
		zend_string *copy = Z_STR_P(zendlval);

		if (!strip_multiline_string_indentation(
				zendlval, heredoc_label->indentation, heredoc_label->indentation_uses_spaces,
				newline_at_start, newline != 0)) {
			RETURN_TOKEN(T_ERROR);
		}

		if (UNEXPECTED(zend_scan_escape_string(zendlval, ZSTR_VAL(copy), ZSTR_LEN(copy), 0) != SUCCESS)) {
			zend_string_efree(copy);
			RETURN_TOKEN(T_ERROR);
		}

		zend_string_efree(copy);
	} else {
		HANDLE_NEWLINES(yytext, yyleng - newline);
	}

	RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
}
#line 9254 "Zend/zend_language_scanner.c"
yy838:
		YYDEBUG(838, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy837;
			if (yych <= 'Z') goto yy840;
			if (yych <= '^') goto yy837;
			goto yy840;
		} else {
			if (yych <= 'z') {
				if (yych <= '`') goto yy837;
				goto yy840;
			} else {
				if (yych <= '{') goto yy843;
				if (yych <= 0x7F) goto yy837;
				goto yy840;
			}
		}
yy839:
		YYDEBUG(839, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '$') goto yy845;
		goto yy837;
yy840:
		YYDEBUG(840, *YYCURSOR);
		YYMARKER = ++YYCURSOR;
		YYFILL(4);
		yych = *YYCURSOR;
		YYDEBUG(841, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy840;
		}
		if (yych <= '>') {
			if (yych == '-') goto yy847;
		} else {
			if (yych <= '?') goto yy849;
			if (yych <= '@') goto yy842;
			if (yych <= '[') goto yy850;
		}
yy842:
		YYDEBUG(842, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2330 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
#line 9301 "Zend/zend_language_scanner.c"
yy843:
		YYDEBUG(843, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(844, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1898 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_LOOKING_FOR_VARNAME);
	enter_nesting('{');
	RETURN_TOKEN(T_DOLLAR_OPEN_CURLY_BRACES);
}
#line 9313 "Zend/zend_language_scanner.c"
yy845:
		YYDEBUG(845, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(846, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2753 "Zend/zend_language_scanner.l"
		{
	yy_push_state(ST_IN_SCRIPTING);
	yyless(1);
	enter_nesting('{');
	RETURN_TOKEN(T_CURLY_OPEN);
}
#line 9326 "Zend/zend_language_scanner.c"
yy847:
		YYDEBUG(847, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy852;
yy848:
		YYDEBUG(848, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy842;
yy849:
		YYDEBUG(849, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '-') goto yy853;
		goto yy848;
yy850:
		YYDEBUG(850, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(851, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2324 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	yy_push_state(ST_VAR_OFFSET);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
#line 9351 "Zend/zend_language_scanner.c"
yy852:
		YYDEBUG(852, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy848;
			if (yych <= 'Z') goto yy854;
			if (yych <= '^') goto yy848;
			goto yy854;
		} else {
			if (yych <= '`') goto yy848;
			if (yych <= 'z') goto yy854;
			if (yych <= 0x7F) goto yy848;
			goto yy854;
		}
yy853:
		YYDEBUG(853, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych == '>') goto yy856;
		goto yy848;
yy854:
		YYDEBUG(854, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(855, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2310 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 3);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
#line 9382 "Zend/zend_language_scanner.c"
yy856:
		YYDEBUG(856, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy848;
			if (yych <= 'Z') goto yy857;
			if (yych <= '^') goto yy848;
		} else {
			if (yych <= '`') goto yy848;
			if (yych <= 'z') goto yy857;
			if (yych <= 0x7F) goto yy848;
		}
yy857:
		YYDEBUG(857, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(858, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2316 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 4);
	yy_push_state(ST_LOOKING_FOR_PROPERTY);
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
#line 9406 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_LOOKING_FOR_VARNAME:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0,   0,   0,   0,   0,   0, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0, 128, 
			  0, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128,   0,   0,   0,   0,   0, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(859, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy861;
			if (yych <= 'Z') goto yy863;
			if (yych >= '_') goto yy863;
		} else {
			if (yych <= '`') goto yy861;
			if (yych <= 'z') goto yy863;
			if (yych >= 0x80) goto yy863;
		}
yy861:
		YYDEBUG(861, *YYCURSOR);
		++YYCURSOR;
yy862:
		YYDEBUG(862, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1921 "Zend/zend_language_scanner.l"
		{
	yyless(0);
	yy_pop_state();
	yy_push_state(ST_IN_SCRIPTING);
	goto restart;
}
#line 9470 "Zend/zend_language_scanner.c"
yy863:
		YYDEBUG(863, *YYCURSOR);
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= '_') {
			if (yych <= '@') {
				if (yych <= '/') goto yy862;
				if (yych <= '9') goto yy865;
				goto yy862;
			} else {
				if (yych <= '[') goto yy865;
				if (yych <= '^') goto yy862;
				goto yy865;
			}
		} else {
			if (yych <= '|') {
				if (yych <= '`') goto yy862;
				if (yych <= 'z') goto yy865;
				goto yy862;
			} else {
				if (yych <= '}') goto yy865;
				if (yych <= 0x7F) goto yy862;
				goto yy865;
			}
		}
yy864:
		YYDEBUG(864, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
yy865:
		YYDEBUG(865, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy864;
		}
		if (yych <= '@') goto yy866;
		if (yych <= '[') goto yy867;
		if (yych == '}') goto yy867;
yy866:
		YYDEBUG(866, *YYCURSOR);
		YYCURSOR = YYMARKER;
		goto yy862;
yy867:
		YYDEBUG(867, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(868, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 1913 "Zend/zend_language_scanner.l"
		{
	yyless(yyleng - 1);
	yy_pop_state();
	yy_push_state(ST_IN_SCRIPTING);
	RETURN_TOKEN_WITH_STR(T_STRING_VARNAME, 0);
}
#line 9524 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_ST_VAR_OFFSET:
	{
		static const unsigned char yybm[] = {
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			  0,   0,   0,   0,   0,   0,   0,   0, 
			248, 248, 216, 216, 216, 216, 216, 216, 
			152, 152,   0,   0,   0,   0,   0,   0, 
			  0, 144, 144, 144, 144, 144, 144,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,   0,   0,   0,   0,  16, 
			  0, 144, 144, 144, 144, 144, 144,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,   0,   0,   0,   0,   0, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
			 16,  16,  16,  16,  16,  16,  16,  16, 
		};
		YYDEBUG(869, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych <= '0') {
			if (yych <= ' ') {
				if (yych <= '\f') {
					if (yych <= 0x08) goto yy871;
					if (yych <= '\n') goto yy873;
				} else {
					if (yych <= '\r') goto yy873;
					if (yych >= ' ') goto yy873;
				}
			} else {
				if (yych <= '$') {
					if (yych <= '"') goto yy875;
					if (yych <= '#') goto yy873;
					goto yy877;
				} else {
					if (yych == '\'') goto yy873;
					if (yych <= '/') goto yy875;
					goto yy878;
				}
			}
		} else {
			if (yych <= ']') {
				if (yych <= 'Z') {
					if (yych <= '9') goto yy880;
					if (yych <= '@') goto yy875;
					goto yy882;
				} else {
					if (yych <= '[') goto yy875;
					if (yych <= '\\') goto yy873;
					goto yy885;
				}
			} else {
				if (yych <= '`') {
					if (yych == '_') goto yy882;
					goto yy875;
				} else {
					if (yych <= 'z') goto yy882;
					if (yych <= '~') goto yy875;
					if (yych >= 0x80) goto yy882;
				}
			}
		}
yy871:
		YYDEBUG(871, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(872, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 3087 "Zend/zend_language_scanner.l"
		{
	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

	RETURN_TOKEN(T_BAD_CHARACTER);
}
#line 9621 "Zend/zend_language_scanner.c"
yy873:
		YYDEBUG(873, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(874, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2344 "Zend/zend_language_scanner.l"
		{
	/* Invalid rule to return a more explicit parse error with proper line number */
	yyless(0);
	yy_pop_state();
	ZVAL_NULL(zendlval);
	RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
}
#line 9635 "Zend/zend_language_scanner.c"
yy875:
		YYDEBUG(875, *YYCURSOR);
		++YYCURSOR;
yy876:
		YYDEBUG(876, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2339 "Zend/zend_language_scanner.l"
		{
	/* Only '[' or '-' can be valid, but returning other tokens will allow a more explicit parse error */
	RETURN_TOKEN(yytext[0]);
}
#line 9647 "Zend/zend_language_scanner.c"
yy877:
		YYDEBUG(877, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych <= '_') {
			if (yych <= '@') goto yy876;
			if (yych <= 'Z') goto yy887;
			if (yych <= '^') goto yy876;
			goto yy887;
		} else {
			if (yych <= '`') goto yy876;
			if (yych <= 'z') goto yy887;
			if (yych <= 0x7F) goto yy876;
			goto yy887;
		}
yy878:
		YYDEBUG(878, *YYCURSOR);
		yyaccept = 0;
		yych = *(YYMARKER = ++YYCURSOR);
		if (yych <= 'X') {
			if (yych <= 'B') {
				if (yych <= '/') goto yy879;
				if (yych <= '9') goto yy890;
				if (yych >= 'B') goto yy893;
			} else {
				if (yych == 'O') goto yy895;
				if (yych >= 'X') goto yy896;
			}
		} else {
			if (yych <= 'b') {
				if (yych == '_') goto yy897;
				if (yych >= 'b') goto yy893;
			} else {
				if (yych <= 'o') {
					if (yych >= 'o') goto yy895;
				} else {
					if (yych == 'x') goto yy896;
				}
			}
		}
yy879:
		YYDEBUG(879, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2125 "Zend/zend_language_scanner.l"
		{ /* Offset could be treated as a long */
	if (yyleng < MAX_LENGTH_OF_LONG - 1 || (yyleng == MAX_LENGTH_OF_LONG - 1 && strcmp(yytext, long_min_digits) < 0)) {
		char *end;
		errno = 0;
		ZVAL_LONG(zendlval, ZEND_STRTOL(yytext, &end, 10));
		if (errno == ERANGE) {
			goto string;
		}
		ZEND_ASSERT(end == yytext + yyleng);
	} else {
string:
		ZVAL_STRINGL(zendlval, yytext, yyleng);
	}
	RETURN_TOKEN_WITH_VAL(T_NUM_STRING);
}
#line 9706 "Zend/zend_language_scanner.c"
yy880:
		YYDEBUG(880, *YYCURSOR);
		yyaccept = 0;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(881, *YYCURSOR);
		if (yybm[0+yych] & 8) {
			goto yy880;
		}
		if (yych == '_') goto yy897;
		goto yy879;
yy882:
		YYDEBUG(882, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(883, *YYCURSOR);
		if (yybm[0+yych] & 16) {
			goto yy882;
		}
		YYDEBUG(884, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2368 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_STR(T_STRING, 0);
}
#line 9734 "Zend/zend_language_scanner.c"
yy885:
		YYDEBUG(885, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(886, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2334 "Zend/zend_language_scanner.l"
		{
	yy_pop_state();
	RETURN_TOKEN(']');
}
#line 9745 "Zend/zend_language_scanner.c"
yy887:
		YYDEBUG(887, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(888, *YYCURSOR);
		if (yych <= '^') {
			if (yych <= '9') {
				if (yych >= '0') goto yy887;
			} else {
				if (yych <= '@') goto yy889;
				if (yych <= 'Z') goto yy887;
			}
		} else {
			if (yych <= '`') {
				if (yych <= '_') goto yy887;
			} else {
				if (yych <= 'z') goto yy887;
				if (yych >= 0x80) goto yy887;
			}
		}
yy889:
		YYDEBUG(889, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2330 "Zend/zend_language_scanner.l"
		{
	RETURN_TOKEN_WITH_STR(T_VARIABLE, 1);
}
#line 9774 "Zend/zend_language_scanner.c"
yy890:
		YYDEBUG(890, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(891, *YYCURSOR);
		if (yych <= '/') goto yy892;
		if (yych <= '9') goto yy890;
		if (yych == '_') goto yy897;
yy892:
		YYDEBUG(892, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2141 "Zend/zend_language_scanner.l"
		{ /* Offset must be treated as a string */
	if (yyleng == 1) {
		ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR((zend_uchar)*(yytext)));
	} else {
		ZVAL_STRINGL(zendlval, yytext, yyleng);
	}
	RETURN_TOKEN_WITH_VAL(T_NUM_STRING);
}
#line 9797 "Zend/zend_language_scanner.c"
yy893:
		YYDEBUG(893, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 32) {
			goto yy898;
		}
yy894:
		YYDEBUG(894, *YYCURSOR);
		YYCURSOR = YYMARKER;
		if (yyaccept == 0) {
			goto yy879;
		} else {
			goto yy892;
		}
yy895:
		YYDEBUG(895, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 64) {
			goto yy900;
		}
		goto yy894;
yy896:
		YYDEBUG(896, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yybm[0+yych] & 128) {
			goto yy902;
		}
		goto yy894;
yy897:
		YYDEBUG(897, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		if (yych <= '/') goto yy894;
		if (yych <= '9') goto yy890;
		goto yy894;
yy898:
		YYDEBUG(898, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(899, *YYCURSOR);
		if (yybm[0+yych] & 32) {
			goto yy898;
		}
		if (yych == '_') goto yy893;
		goto yy892;
yy900:
		YYDEBUG(900, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(901, *YYCURSOR);
		if (yybm[0+yych] & 64) {
			goto yy900;
		}
		if (yych == '_') goto yy895;
		goto yy892;
yy902:
		YYDEBUG(902, *YYCURSOR);
		yyaccept = 1;
		YYMARKER = ++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(903, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy902;
		}
		if (yych == '_') goto yy896;
		goto yy892;
	}
/* *********************************** */
yyc_SHEBANG:
	{
		static const unsigned char yybm[] = {
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128,   0, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
			128, 128, 128, 128, 128, 128, 128, 128, 
		};
		YYDEBUG(904, *YYCURSOR);
		YYFILL(2);
		yych = *YYCURSOR;
		if (yych == '#') goto yy908;
		YYDEBUG(906, *YYCURSOR);
		++YYCURSOR;
yy907:
		YYDEBUG(907, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2208 "Zend/zend_language_scanner.l"
		{
	yyless(0);
	BEGIN(INITIAL);
	goto restart;
}
#line 9929 "Zend/zend_language_scanner.c"
yy908:
		YYDEBUG(908, *YYCURSOR);
		yych = *++YYCURSOR;
		if (yych != '!') goto yy907;
yy909:
		YYDEBUG(909, *YYCURSOR);
		++YYCURSOR;
		YYFILL(1);
		yych = *YYCURSOR;
		YYDEBUG(910, *YYCURSOR);
		if (yybm[0+yych] & 128) {
			goto yy909;
		}
		YYDEBUG(911, *YYCURSOR);
		++YYCURSOR;
		YYDEBUG(912, *YYCURSOR);
		yyleng = YYCURSOR - SCNG(yy_text);
#line 2202 "Zend/zend_language_scanner.l"
		{
	CG(zend_lineno)++;
	BEGIN(INITIAL);
	goto restart;
}
#line 9953 "Zend/zend_language_scanner.c"
	}
/* *********************************** */
yyc_INITIAL:
	YYDEBUG(913, *YYCURSOR);
	YYFILL(7);
	yych = *YYCURSOR;
	if (yych == '<') goto yy917;
	YYDEBUG(915, *YYCURSOR);
	++YYCURSOR;
yy916:
	YYDEBUG(916, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
#line 2254 "Zend/zend_language_scanner.l"
	{
	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

inline_char_handler:

	while (1) {
		YYCTYPE *ptr = memchr(YYCURSOR, '<', YYLIMIT - YYCURSOR);

		YYCURSOR = ptr ? ptr + 1 : YYLIMIT;

		if (YYCURSOR >= YYLIMIT) {
			break;
		}

		if (*YYCURSOR == '?') {
			if (CG(short_tags) /* <? */
				|| (*(YYCURSOR + 1) == '=') /* <?= */
				|| (!strncasecmp((char*)YYCURSOR + 1, "php", 3) && /* <?php[ \t\r\n] */
					(YYCURSOR + 4 == YYLIMIT ||
					YYCURSOR[4] == ' ' || YYCURSOR[4] == '\t' ||
					YYCURSOR[4] == '\n' || YYCURSOR[4] == '\r'))
			) {
				YYCURSOR--;
				break;
			}
		}
	}

	yyleng = YYCURSOR - SCNG(yy_text);

	if (SCNG(output_filter)) {
		size_t readsize;
		char *s = NULL;
		size_t sz = 0;
		// TODO: avoid reallocation ???
		readsize = SCNG(output_filter)((unsigned char **)&s, &sz, (unsigned char *)yytext, (size_t)yyleng);
		ZVAL_STRINGL(zendlval, s, sz);
		efree(s);
		if (readsize < yyleng) {
			yyless(readsize);
		}
	} else if (yyleng == 1) {
		ZVAL_INTERNED_STR(zendlval, ZSTR_CHAR((zend_uchar)*yytext));
	} else {
		ZVAL_STRINGL(zendlval, yytext, yyleng);
	}
	HANDLE_NEWLINES(yytext, yyleng);
	RETURN_TOKEN_WITH_VAL(T_INLINE_HTML);
}
#line 10018 "Zend/zend_language_scanner.c"
yy917:
	YYDEBUG(917, *YYCURSOR);
	yych = *++YYCURSOR;
	if (yych != '?') goto yy916;
	YYDEBUG(918, *YYCURSOR);
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 'O') {
		if (yych == '=') goto yy920;
	} else {
		if (yych <= 'P') goto yy922;
		if (yych == 'p') goto yy922;
	}
yy919:
	YYDEBUG(919, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
#line 2245 "Zend/zend_language_scanner.l"
	{
	if (CG(short_tags)) {
		BEGIN(ST_IN_SCRIPTING);
		RETURN_OR_SKIP_TOKEN(T_OPEN_TAG);
	} else {
		goto inline_char_handler;
	}
}
#line 10043 "Zend/zend_language_scanner.c"
yy920:
	YYDEBUG(920, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(921, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
#line 2214 "Zend/zend_language_scanner.l"
	{
	BEGIN(ST_IN_SCRIPTING);
	if (PARSER_MODE()) {
		/* We'll reject this as an identifier in zend_lex_tstring. */
		RETURN_TOKEN_WITH_IDENT(T_ECHO);
	}
	RETURN_TOKEN(T_OPEN_TAG_WITH_ECHO);
}
#line 10058 "Zend/zend_language_scanner.c"
yy922:
	YYDEBUG(922, *YYCURSOR);
	yych = *++YYCURSOR;
	if (yych == 'H') goto yy924;
	if (yych == 'h') goto yy924;
yy923:
	YYDEBUG(923, *YYCURSOR);
	YYCURSOR = YYMARKER;
	goto yy919;
yy924:
	YYDEBUG(924, *YYCURSOR);
	yych = *++YYCURSOR;
	if (yych == 'P') goto yy925;
	if (yych != 'p') goto yy923;
yy925:
	YYDEBUG(925, *YYCURSOR);
	yych = *++YYCURSOR;
	if (yych <= '\f') {
		if (yych <= 0x08) goto yy926;
		if (yych <= '\n') goto yy927;
	} else {
		if (yych <= '\r') goto yy929;
		if (yych == ' ') goto yy927;
	}
yy926:
	YYDEBUG(926, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
#line 2230 "Zend/zend_language_scanner.l"
	{
	/* Allow <?php followed by end of file. */
	if (YYCURSOR == YYLIMIT) {
		BEGIN(ST_IN_SCRIPTING);
		RETURN_OR_SKIP_TOKEN(T_OPEN_TAG);
	}
	/* Degenerate case: <?phpX is interpreted as <? phpX with short tags. */
	if (CG(short_tags)) {
		yyless(2);
		BEGIN(ST_IN_SCRIPTING);
		RETURN_OR_SKIP_TOKEN(T_OPEN_TAG);
	}
	goto inline_char_handler;
}
#line 10101 "Zend/zend_language_scanner.c"
yy927:
	YYDEBUG(927, *YYCURSOR);
	++YYCURSOR;
yy928:
	YYDEBUG(928, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
#line 2224 "Zend/zend_language_scanner.l"
	{
	HANDLE_NEWLINE(yytext[yyleng-1]);
	BEGIN(ST_IN_SCRIPTING);
	RETURN_OR_SKIP_TOKEN(T_OPEN_TAG);
}
#line 10114 "Zend/zend_language_scanner.c"
yy929:
	YYDEBUG(929, *YYCURSOR);
	yych = *++YYCURSOR;
	if (yych == '\n') goto yy927;
	goto yy928;
/* *********************************** */
yyc_ST_END_HEREDOC:
	YYDEBUG(930, *YYCURSOR);
	YYFILL(1);
	yych = *YYCURSOR;
	YYDEBUG(932, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(933, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
#line 2739 "Zend/zend_language_scanner.l"
	{
	zend_heredoc_label *heredoc_label = zend_ptr_stack_pop(&SCNG(heredoc_label_stack));

	yyleng = heredoc_label->indentation + heredoc_label->length;
	YYCURSOR += yyleng - 1;

	heredoc_label_dtor(heredoc_label);
	efree(heredoc_label);

	BEGIN(ST_IN_SCRIPTING);
	RETURN_TOKEN(T_END_HEREDOC);
}
#line 10142 "Zend/zend_language_scanner.c"
/* *********************************** */
yyc_ST_NOWDOC:
	YYDEBUG(934, *YYCURSOR);
	YYFILL(1);
	yych = *YYCURSOR;
	YYDEBUG(936, *YYCURSOR);
	++YYCURSOR;
	YYDEBUG(937, *YYCURSOR);
	yyleng = YYCURSOR - SCNG(yy_text);
#line 2996 "Zend/zend_language_scanner.l"
	{
	zend_heredoc_label *heredoc_label = zend_ptr_stack_top(&SCNG(heredoc_label_stack));
	int newline = 0, indentation = 0, spacing = -1;

	if (YYCURSOR > YYLIMIT) {
		RETURN_END_TOKEN;
	}

	YYCURSOR--;

	while (YYCURSOR < YYLIMIT) {
		switch (*YYCURSOR++) {
			case '\r':
				if (*YYCURSOR == '\n') {
					YYCURSOR++;
				}
				ZEND_FALLTHROUGH;
			case '\n':
				indentation = spacing = 0;

				while (YYCURSOR < YYLIMIT && (*YYCURSOR == ' ' || *YYCURSOR == '\t')) {
					if (*YYCURSOR == '\t') {
						spacing |= HEREDOC_USING_TABS;
					} else {
						spacing |= HEREDOC_USING_SPACES;
					}
					++YYCURSOR;
					++indentation;
				}

				if (YYCURSOR == YYLIMIT) {
					yyleng = YYCURSOR - SCNG(yy_text);
					HANDLE_NEWLINES(yytext, yyleng);
					ZVAL_NULL(zendlval);
					RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
				}

				/* Check for ending label on the next line */
				if (IS_LABEL_START(*YYCURSOR) && heredoc_label->length < YYLIMIT - YYCURSOR && !memcmp(YYCURSOR, heredoc_label->label, heredoc_label->length)) {
					if (IS_LABEL_SUCCESSOR(YYCURSOR[heredoc_label->length])) {
						continue;
					}

					if (spacing == (HEREDOC_USING_SPACES | HEREDOC_USING_TABS)) {
						zend_throw_exception(zend_ce_parse_error, "Invalid indentation - tabs and spaces cannot be mixed", 0);
						if (PARSER_MODE()) {
							RETURN_TOKEN(T_ERROR);
						}
					}

					/* newline before label will be subtracted from returned text, but
					 * yyleng/yytext will include it, for zend_highlight/strip, tokenizer, etc. */
					if (YYCURSOR[-indentation - 2] == '\r' && YYCURSOR[-indentation - 1] == '\n') {
						newline = 2; /* Windows newline */
					} else {
						newline = 1;
					}

					CG(increment_lineno) = 1; /* For newline before label */

					YYCURSOR -= indentation;
					heredoc_label->indentation = indentation;

					BEGIN(ST_END_HEREDOC);

					goto nowdoc_scan_done;
				}
				ZEND_FALLTHROUGH;
			default:
				continue;
		}
	}

nowdoc_scan_done:
	yyleng = YYCURSOR - SCNG(yy_text);
	ZVAL_STRINGL(zendlval, yytext, yyleng - newline);

	if (!EG(exception) && spacing != -1 && PARSER_MODE()) {
		bool newline_at_start = *(yytext - 1) == '\n' || *(yytext - 1) == '\r';
		if (!strip_multiline_string_indentation(
				zendlval, indentation, spacing == HEREDOC_USING_SPACES,
				newline_at_start, newline != 0)) {
			RETURN_TOKEN(T_ERROR);
		}
	}

	HANDLE_NEWLINES(yytext, yyleng - newline);
	RETURN_TOKEN_WITH_VAL(T_ENCAPSED_AND_WHITESPACE);
}
#line 10242 "Zend/zend_language_scanner.c"
}
#line 3095 "Zend/zend_language_scanner.l"


emit_token_with_str:
	zend_copy_value(zendlval, (yytext + offset), (yyleng - offset));

emit_token_with_val:
	if (PARSER_MODE()) {
		ZEND_ASSERT(Z_TYPE_P(zendlval) != IS_UNDEF);
		elem->ast = zend_ast_create_zval_with_lineno(zendlval, start_line);
	}

emit_token:
	if (SCNG(on_event)) {
		SCNG(on_event)(ON_TOKEN, token, start_line, yytext, yyleng, SCNG(on_event_context));
	}
	return token;

emit_token_with_ident:
	if (PARSER_MODE()) {
		elem->ident = SCNG(yy_text);
	}
	if (SCNG(on_event)) {
		SCNG(on_event)(ON_TOKEN, token, start_line, yytext, yyleng, SCNG(on_event_context));
	}
	return token;

return_whitespace:
	HANDLE_NEWLINES(yytext, yyleng);
	if (SCNG(on_event)) {
		SCNG(on_event)(ON_TOKEN, T_WHITESPACE, start_line, yytext, yyleng, SCNG(on_event_context));
	}
	if (PARSER_MODE()) {
		start_line = CG(zend_lineno);
		goto restart;
	} else {
		return T_WHITESPACE;
	}

skip_token:
	if (SCNG(on_event)) {
		SCNG(on_event)(ON_TOKEN, token, start_line, yytext, yyleng, SCNG(on_event_context));
	}
	start_line = CG(zend_lineno);
	goto restart;
}
